2026-07-22  Sean Whitton  <spwhitton@spwhitton.name>

	VC-Annotate menu: Fix inserting "Span NN.NN days" entries

	* lisp/vc/vc-annotate.el (vc-annotate-mode-menu): Generate
	entries based on vc-annotate-color-map using a :filter function,
	instead of using whatever value that variable happened to have
	at load time.

2026-07-22  Donjuanplatinum  <donplat@barrensea.org>  (tiny change)

	Fix typo in Fmatch_end's doc string

	* src/search.c (Fmatch_end): Fix "start position" to "end position".
	(Bug#81447)

2026-07-21  James Cherti  <contact@jamescherti.com>

	Fix false positive warnings in 'elisp-flymake-checkdoc' when narrowed

	* lisp/progmodes/elisp-mode.el (elisp-flymake-checkdoc): Temporarily
	widen the buffer before calling 'checkdoc-current-buffer'.  This
	prevents checkdoc from reporting missing file-level structural
	elements when the user has narrowed the buffer.  (Bug#81258)

2026-07-20  Aaron L. Zeng  <azeng@janestreet.com>  (tiny change)

	Fix void-function on push-button in goto-address-mode

	* lisp/net/goto-addr.el (goto-address--button-action):
	New function (bug#81419).
	(goto-address-fontify): Use it as the button action.

2026-07-19  Petteri Hintsanen  <petterih@iki.fi>

	Fix perl-calculate-indent

	* lisp/progmodes/perl-mode.el (perl-calculate-indent): Ensure that
	the value from (nth 3 state) is a character before passing it to
	char-equal.

2026-07-19  Michael Albinus  <michael.albinus@gmx.de>

	* admin/notes/documentation: Describe quoting of key names.

2026-07-19  Eli Zaretskii  <eliz@gnu.org>

	Fix 'url-parse-query-string'

	* lisp/url/url-util.el (url-parse-query-string): Fix use of
	'match-beginning' and 'match-end'.  (Bug#81430)

2026-07-18  Eshel Yaron  <me@eshelyaron.com>

	markdown-ts-mode: Fix code-block fontification leak

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--fontify-non-ts-collect-faces): Prevent
	'font-lock-ensure' from widening and fontifying outside the
	intended code-block (bug#81412).

2026-07-18  Eli Zaretskii  <eliz@gnu.org>

	Revert "; * admin/authors.el (authors-aliases): Fix Borys Buliha's name."

	This reverts commit cf6918c189e11a891facdac4a9baea3316a39c59.
	It was a mistake, as Boris prefers the other spelling.

2026-07-18  Eli Zaretskii  <eliz@gnu.org>

	Fix 'mouse-drag-copy-region' = 'non-empty'

	* lisp/mouse.el (mouse-save-then-kill): Fix conditions for copying
	when 'mouse-drag-copy-region' is 'non-empty'.  (Bug#81366)

2026-07-16  Michael Albinus  <michael.albinus@gmx.de>

	Fix `with-tramp-local-environment'

	* lisp/net/tramp.el (with-tramp-local-environment): Do not change the
	global environment.  Reported by Daniel Kraus <daniel@kraus.my>.
	(Bug#81409)

2026-07-16  Dmitry Gutov  <dmitry@gutov.dev>

	project.el: Bump version to 0.12

	Do not merge to master.

2026-07-15  Paul Eggert  <eggert@cs.ucla.edu>

	Port pdumper to m68k

	Problem reported by John Paul Adrian Glaubitz (bug#44531).
	* src/pdumper.c (DUMP_RELOCATION_ALIGNMENT_BITS): Remove.  It’s
	not needed for optimization, as today’s compilers deduce that
	multiplying and dividing by the alignment can be done with shifts.
	All uses changed to use DUMP_RELOCATION_ALIGNMENT.
	(DUMP_RELOCATION_ALIGNMENT) [__mc68000__]:
	Now min (4, alignof (Lisp_Object)), not 4.
	(dump_reloc_set_offset): Change eassert to eassume to help
	the compiler.

2026-07-14  Mark Hindley  <mark@hindley.org.uk>  (tiny change)

	browse-url-with-browser-kind: Use strings for DEF

	* lisp/net/browse-url.el (browse-url-with-browser-kind): Use
	strings for DEF argument to completing-read (bug#81369).

2026-07-14  Martin Rudalics  <rudalics@gmx.at>

	Fix issues related to window layout changes (Bug#81406)

	* src/window.c (Vwindow_combination_resize): In doc-string say
	that binding this to nil may be necessary to produce specific,
	predefined frame layouts (Bug#81406).
	* lisp/window-x.el (window-layout-rotate-clockwise)
	(window-layout-rotate-anticlockwise)
	(window-layout-flip-leftright, window-layout-flip-topdown)
	(window-layout-transpose, rotate-windows-change-selected)
	(rotate-windows, rotate-windows-back): Rewrite doc-strings.
	Make sure that non-interactive calls with nil or absent WINDOW
	argument work on the frame's main window.  Fix infinite loop
	when 'rotate-windows' is called for a non-selected frame.
	* doc/lispref/windows.texi (Recombining Windows): Say that
	binding 'window-combination-resize' to nil may be necessary to
	produce specific, predefined frame layouts (Bug#81406).
	(Changing Window Layouts): Minor rewrite.
	* etc/NEWS: Announce names of new commands to change window
	layout (Bug#81406).

2026-07-13  Martin Rudalics  <rudalics@gmx.at>

	Turn off combination resizing in 'window--transpose-1' (Bug#81406)

	* lisp/window-x.el (window--transpose-1): Bind
	'window-combination-resize' to nil around splitting (Bug#81406).

2026-07-13  Eli Zaretskii  <eliz@gnu.org>

	Fix copy-by-mouse in *Backtrace* buffers

	* lisp/emacs-lisp/backtrace.el (backtrace--filter-visible):
	Support BEG and END in reverse order.  Patch by Jakub
	T. Jankiewicz <jcubic@jcubic.pl>.  (Bug#81365)

2026-07-11  Kisaragi Hiu  <mail@kisaragi-hiu.com>

	Support javascript "using" keyword (bug#81351)

	* lisp/progmodes/js.el:
	(js--keyword-re): Add "using" as a JavaScript keyword.
	(js--font-lock-keywords-3, js--declaration-keyword-re):
	Add "using" as a variable declaration keyword, like "const".
	(js--treesit-optional-keywords): New variable, for keywords that may not
	yet be supported by many versions of tree-sitter-javascript.
	(js--treesit-font-lock-settings): Use it.
	(js--treesit-defun-name, js--treesit-valid-imenu-entry)
	(js--treesit-sentence-nodes, js--treesit-simple-imenu-settings)
	(js--treesit-defun-type-regexp): Add using_declaration as an alternative
	to lexical_declaration (let and const) and variable_declaration (var).

	* lisp/progmodes/typescript-ts-mode.el (typescript-ts-mode--keywords):
	Add "using" as a TypeScript keyword.

2026-07-10  Juri Linkov  <juri@linkov.net>

	Ensure the correct current buffer in completions--background-update

	* lisp/minibuffer.el (completions--background-update):
	Add new arg 'buffer' and compare it with 'current-buffer'.
	(completions--start-background-update): Run an idle timer
	for 'completions--background-update' with a new arg
	set to 'current-buffer' that ensures that the timer function
	is run in the same buffer (bug#81349).

2026-07-09  Daniel Mendler  <mail@daniel-mendler.de>

	Improve eldoc-help-at-pt docstrings

	* lisp/emacs-lisp/eldoc.el (eldoc-help-at-pt, eldoc-show-help-at-pt):
	Improve docstrings.  (Bug#81356)

2026-07-09  Daniel Mendler  <mail@daniel-mendler.de>

	Fix 'eldoc-show-help-at-pt'

	* lisp/emacs-lisp/eldoc.el (eldoc-show-help-at-pt): Don't test
	'eldoc-help-at-pt'.  (Bug#81356)

2026-07-07  Paul Eggert  <eggert@cs.ucla.edu>

	Fix uninit read in Android TrueType font scan

	Problem reported privately by Michal Majchrowicz and Marcin
	Wyczechowski, members of the AFINE Team.
	* src/sfnt.c (sfnt_read_table_directory):
	Fix typo where wrong size was used.

2026-07-07  Paul Eggert  <eggert@cs.ucla.edu>

	Fix OOB read in Android TrueType font scan

	Problem reported privately by Michal Majchrowicz and Marcin
	Wyczechowski, members of the AFINE Team.
	* src/sfnt.c (sfnt_vary_simple_glyph, sfnt_vary_compound_glyph):
	Reject indexes equal exactly to sizes.

2026-07-07  Martin Rudalics  <rudalics@gmx.at>

	Have 'replace-buffer-in-windows' remove BUFFER-OR-NAME everywhere (Bug#81370)

	* lisp/window.el (replace-buffer-in-windows): Unrecord
	BUFFER-OR-NAME and thus remove it from the lists of previous and
	next buffers in all live windows regardless of whether they
	currently show BUFFER-OR-NAME or not (Bug#81370).

2026-07-07  Juri Linkov  <juri@linkov.net>

	Fix test breakage in files-tests

	* test/lisp/files-tests.el (files-tests--with-buffer-offer-save):
	Redefine 'read-key-sequence-vector' instead of 'read-key'
	after recent changes in 'map-y-or-n-p' (bug#81168).

2026-07-07  Juri Linkov  <juri@linkov.net>

	Check for a live buffer in 'quit-restore-window'

	* lisp/window.el (quit-restore-window):
	Check with 'buffer-live-p' when finding a prev buffer
	in 'window-prev-buffers' (bug#81370).

2026-07-07  Daniel Mendler  <mail@daniel-mendler.de>

	Fix blinking Eldoc messages

	Ensure that `global-eldoc-mode' does not enable `eldoc-mode' in
	ephemeral Eldoc buffers and accidentally reset `eldoc-last-message'.
	This caused Eldoc message blinking (bug#81356).

	* lisp/emacs-lisp/eldoc.el (eldoc--supported-p): Exclude ephemeral Eldoc
	buffers to avoid blinking.
	(eldoc-help-at-pt): Add custom :set function.
	(eldoc-documentation-functions): Do not register `eldoc-show-help-at-pt'
	by default.

2026-07-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix undefined behavior in pbm_load

	int*int problem reported by Tristan Madani in:
	https://bugs.gnu.org/81344
	* src/image.c (pbm_load): Avoid undefined behavior when
	multiplying ints, or when adding pointer to int.

2026-07-05  Philip Kaludercic  <philipk@posteo.net>

	Avoid destructively modifying 'package--builtin-alist'

	* lisp/emacs-lisp/package.el (package--upgradeable-packages):
	Use 'append' instead of 'nconc' to not append the contents of
	'package-alist' to 'package--builtin-alist'.  (Bug#81242)

2026-07-05  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.8.7

2026-07-05  Michael Albinus  <michael.albinus@gmx.de>

	Ensure, that `buffer-file-name' is expanded in tramp-archive

	* lisp/net/tramp-archive.el (tramp-archive-handle-insert-file-contents):
	Ensure, that `buffer-file-name' is expanded.

2026-07-04  Eli Zaretskii  <eliz@gnu.org>

	Fix min-width in mode-line constructs

	* src/xdisp.c (handle_display_prop): To handle min-width's end on
	the mode line, call display_min_width also when starting a new
	string.  This is needed because mode line supports :propertize
	application to a list of strings, and we only need to apply the
	effect of min-width at the end of the last element.  (Bug#81354)

2026-07-03  Binbin Ye  <phantom2501@gmail.com>  (tiny change)

	Fix syntax of tsx tag angle brackets to use matching pairs

	The matching characters for JSX tag angle brackets were
	self-referential ('<' matched '<', and '>' matched '>') rather than
	pointing at each other.  Tools that check the matching character, such
	as 'show-paren-mode' and the rainbow-delimiters package, therefore
	treated every JSX closing '>' as a mismatched delimiter.  Use the same
	descriptors as 'sgml-make-syntax-table', where '<' is closed by '>'
	and '>' by '<' (bug#81348).

	* lisp/progmodes/typescript-ts-mode.el
	(tsx-ts--syntax-propertize-captures): Give '<' the syntax descriptor
	"(>" and '>' the descriptor ")<".

2026-07-03  Samuele FAVAZZA  <sfavazza.github@gmail.com>  (tiny change)

	Fix Tramp container name completion

	* lisp/net/tramp-container.el (tramp-container--completion-function):
	Use "<>" as separator instead of "\t", which could be modified in
	the shell.

2026-07-03  Sean Whitton  <spwhitton@spwhitton.name>

	server-tests/can-create-frames-p: Check for TERM=dumb-emacs-ansi

	* test/lisp/server-tests.el (server-tests/can-create-frames-p):
	Check for TERM=dumb-emacs-ansi.

2026-07-03  Sean Whitton  <spwhitton@spwhitton.name>

	Disable failing SCCS tests on the release branch

	These are broken and we don't have an SCCS expert to fix them at
	present.  This shouldn't block the Emacs 31 release because SCCS
	is a relatively obscure VCS.

	* test/lisp/vc/vc-tests/vc-tests.el (vc-test-sccs05-rename-file)
	(vc-test-sccs10-rename-directory): Mark as expected to fail.
	Do not merge to master.

2026-07-03  Sean Whitton  <spwhitton@spwhitton.name>

	Finish reverting experiment with proportional font on mode line

	This change

	    Author:     Lars Ingebrigtsen <larsi@gnus.org>
	    AuthorDate: Thu Dec 23 11:43:47 2021 +0100

	        Revert back to using monospaced fonts in the mode line

	        * lisp/faces.el (mode-line-active, mode-line-inactive): Revert
	        back to using monospaced fonts on the mode line (for now).  The
	        main remaining usability problem is clicking on the very small "-"
	        characters in "U:--".

	didn't also undo these changes to bindings.el that were
	introduced along with the proportional font experiment, leading
	to bug#81336.

	* lisp/bindings.el (mode-line-position)
	(standard-mode-line-format): Don't set display minimum widths (bug#81336).

2026-07-03  Alan Mackenzie  <acm@muc.de>

	CC Mode: Fix erroneous type: arguments to two defcustoms.

	This allows customize to set the variables directly to regular
	expressions as an alternative to a list of identifiers.  It
	fixes bug#81339.
	* lisp/progmodes/cc-vars.el (c-noise-macro-with-parens-names)
	(c-noise-macro-names): Correct the type: arguments to defcustom
	to two `choice' constructs.

2026-07-02  Spencer Baugh  <sbaugh@janestreet.com>

	Fix initials completion style after // in file name

	* lisp/minibuffer.el (completion-initials-expand): Change the
	heuristic to check for an empty previous field, not total string
	length (bug#81241).
	* test/lisp/minibuffer-tests.el (completion-initials): New test.

2026-07-02  Spencer Baugh  <sbaugh@janestreet.com>

	Fix c-pcm-try-completion with boundaries completion

	PCM try-completion could behavior incorrectly with completion
	tables using boundaries, such as file name completion.  It would
	"grow" earlier path components as if point was at the end of
	each path component (rather than at its true location), which
	meant all path components would "grow" not only from the left
	\(which is correct) but also from the right (which can only work
	when point is there).

	* lisp/minibuffer.el (completion-pcm--find-all-completions):
	Drop the sub-pattern's trailing `point' (bug#80914).
	* test/lisp/minibuffer-tests.el (completion-pcm-test-9): New
	test.

2026-07-02  haiyang miao  <miaohaiyang1024@outlook.com>  (tiny change)

	In pgtk_free_frame_resources transfer keyboard focus to parent (Bug#64625)

	* src/pgtkterm.c (pgtk_new_focus_frame): Declare static.
	(pgtk_free_frame_resources): If this frame currently holds
	keyboard focus, explicitly transfer focus to its parent frame
	before releasing resources (Bug#64625).

2026-07-02  Johan Myréen  <johan.myreen@gmail.com>  (tiny change)

	Fix fullscreen state handling for PGTK (Bug#81165, Bug#81320)

	* src/pgtkterm.c (set_fullscreen_state): Unfullscreen frame in
	the FULLSCREEN_HEIGHT/_WIDTH case (Bug#81165, Bug#81320).

2026-07-02  Dmitry Gutov  <dmitry@gutov.dev>

	* lisp/progmodes/project.el: Update Commentary.

2026-07-02  Dmitry Gutov  <dmitry@gutov.dev>

	Localize cache invalidation to project-try-vc

	With other functions only using the cached values or populating
	when necessary.

	* lisp/progmodes/project.el: Update commentary (bug#81317).
	(project--get-cached): Add explicit parameter TIMEOUT, use it.
	(project-try-vc): Build its value from 'non-essential' and the
	values of two timeout variables.  And pass them on.
	(project-try-vc--search, project--vc-merge-submodules-p)
	(project--value-in-dir): Also add TIMEOUT.
	(project-files, vc-git-project-list-files)
	(vc-hg-project-list-files, project-ignores, project-buffers)
	(project-name, project-uniquify-dirname-transform): Remove the
	binding of 'non-essential' as now redundant for cache duration.

	* test/lisp/progmodes/project-tests.el (project-try-vc-uses-cache)
	(project-try-vc-invalidates-cache)
	(project-name-<vc>-reuses-cache)
	(project-name-<vc>-obeys-cache-invalidation): New tests.
	(project-vc-supports-project-in-different-dir)
	(project-vc-ignores-in-external-directory): Use
	'project--clear-cache' as the more reliable option.

2026-07-02  Dmitry Gutov  <dmitry@gutov.dev>

	Fix project--clear-cache and project--value-in-dir in special case

	* lisp/progmodes/project.el (project--clear-cache): Make sure to
	clear the 'project-vc-dir-locals' keys too.
	(project--value-in-dir): Predicate the cache lookup (and most
	importantly, write) on whether enable-dir-local-variables is
	non-nil.  So its uses inside recursive 'project-try-vc--search'
	call do not not bust the value (bug#81317).

2026-07-01  Michael Albinus  <michael.albinus@gmx.de>

	* admin/notes/jargon: Add TTTT.

2026-07-01  Michael Albinus  <michael.albinus@gmx.de>

	Fix error handling in Tramp delete-{file,directory}

	* lisp/net/tramp-smb.el (tramp-smb-handle-delete-directory):
	* lisp/net/tramp.el (tramp-skeleton-delete-directory): Fail if
	DIRECTORY is missing.
	(tramp-skeleton-delete-file): Don't fail if DIRECTORY is missing.

	* test/lisp/net/tramp-tests.el (tramp-test14-delete-directory):
	Adapt test.

2026-07-01  Michael Albinus  <michael.albinus@gmx.de>

	Change Tramp version integrated in Emacs 31.1 (don't merge)

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el (tramp-version): Adapt Tramp versions.

	* lisp/net/trampver.el (customize-package-emacs-version-alist):
	Change Tramp version integrated in Emacs 31.1.

2026-07-01  Yuan Fu  <casouri@gmail.com>

	Correct cursor range in Ftreesit_query_capture (bug#81297)

	* src/treesit.c (Ftreesit_query_capture): Always explicitly set
	cursor's range.

2026-06-30  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-update: Remove assertion invalid on this branch

	* lisp/vc/vc-dir.el (vc-dir-update): Remove assertion invalid on
	the emacs-31 branch.  Do not merge to master.

2026-06-30  Martin Rudalics  <rudalics@gmx.at>

	Don't use window manager activation when a child frame has focus (Bug#81326)

	* src/xterm.c (x_get_toplevel_parent): Remove.
	(x_focus_frame): Never call x_ewmh_activate_frame when a child
	frame has focus (Bug#81326).

2026-06-29  Philip Kaludercic  <philipk@posteo.net>

	Compile User Lisp files after adjusting 'load-path'

	* lisp/startup.el (prepare-user-lisp): Collect Lisp files in a
	list and process these after traversing the file system.  This
	is necessary to prevent the compiler from failing to
	byte-compile files that depend on other files in the User Lisp
	directory because their neighboring dependencies cannot be
	located.  (Bug#81304)

2026-06-29  Sean Whitton  <spwhitton@spwhitton.name>

	Fix strange logic in vc-git-incoming-revision

	I think that I didn't fully update this function in this change:

	    commit e915646b8944d8b611ab7094d9eb305ed162ff27
	    Author: Sean Whitton <spwhitton@spwhitton.name>
	    Date:   Wed Feb 18 11:35:16 2026 +0000

	        vc-git-pull, vc-git-incoming-revision: Use push remotes

	        * lisp/vc/vc-git.el (vc-git-pull, vc-git-incoming-revision): Use
	        configured push remotes.
	        * etc/NEWS: Announce change to vc-git-pull.

	* lisp/vc/vc-git.el (vc-git-incoming-revision): Don't duplicate
	looking for a branch remote after just having called
	vc-git--branch-remotes (bug#81328).

2026-06-28  Eli Zaretskii  <eliz@gnu.org>

	Fix 'format-mode-line' when faces are in format string

	* src/xdisp.c (store_mode_line_string): Don't assume that PROPS
	can only specify the face for LISP_STRING; if PROPS don't specify
	a face, fall back on the 'face' property of LISP_STRING.
	(Bug#81316)

	* test/src/xdisp-tests.el (xdisp-test-format-mode-line): Add a
	test for this issue.

2026-06-28  Martin Rudalics  <rudalics@gmx.at>

	Restore frame's fullheight/fullwidth after exiting from fullboth (Bug#81165)

	* src/xterm.c (do_ewmh_fullscreen): Try to restore
	fullheight/fullwidth states after exiting from fullboth state
	(Bug#81165).

2026-06-27  Zhengyi Fu  <i@fuzy.me>  (tiny change)

	Fix interactive mode spec of `xwidget-webkit-end-edit-textarea'

	* lisp/xwidget.el (xwidget-webkit-end-edit-textarea): Remove
	`xwidget-webkit-mode' condition from the interactive mode spec.
	This command is intended to be invoked in the 'textarea' buffer,
	which is created by `xwidget-webkit-begin-edit-textarea', and
	that buffer is in Fundamental mode.  (Bug#81306)

2026-06-27  Andrea Alberti  <a.alberti82@gmail.com>

	Fix pixels-vs-columns confusion in margin face fill (bug#81109)

	* src/xdisp.c (extend_face_to_end_of_line): WINDOW_LEFT/RIGHT_MARGIN_WIDTH
	is a pixel value (columns times the frame column width).  Compare the
	margin glyph count against WINDOW_LEFT/RIGHT_MARGIN_COLS instead, and use
	the *_WIDTH value directly for remaining_pixels rather than multiplying it
	by FRAME_COLUMN_WIDTH a second time.  The old code worked on text
	terminals, where the column width is one pixel, but computed wrong widths
	on GUI frames.

2026-06-27  Richard Lawrence  <rwl@recursewithless.net>

	Fix ISO date insertion in diary

	See Bug#81263.  Diary's 'iso' dates should use ISO8601 YYYY-MM-DD
	format.  This change fixes the format used by `diary-insert-entry'.

	* lisp/calendar/calendar.el (diary-iso-date-insertion-form): Use
	YYYY-MM-DD format (not YYYY/M/D) when inserting ISO dates.
	* test/lisp/calendar/diary-icalendar-resources/import-bug-11473.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-bug-22092.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-bug-33277.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-legacy-vars.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-multiple-vcalendars.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-non-recurring-1.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-non-recurring-all-day.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-non-recurring-another-example.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-non-recurring-folded-summary.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-non-recurring-long-summary.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-time-format-12hr-blank.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-with-attachment.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-with-timezone.diary-iso:
	* test/lisp/calendar/diary-icalendar-resources/import-with-uid.diary-iso:
	Update tests.

2026-06-27  Eli Zaretskii  <eliz@gnu.org>

	Minor fix for 'format-mode-line'

	* src/xdisp.c (Fformat_mode_line): Treat 'default' exactly like
	nil.  (Bug#81307)

2026-06-26  Juri Linkov  <juri@linkov.net>

	Improve the previous fix in toggle-window-dedicated

	* lisp/window.el (toggle-window-dedicated):
	Don't select the window by mouse click in another window.
	This keeps the currently selected window like for
	toggling other indicators on the mode-line (bug#81178).

2026-06-25  Sean Whitton  <spwhitton@spwhitton.name>

	VC-Dir: Fix removing empty directory entries

	* lisp/vc/vc-dir.el (vc-dir-refresh-files): Do another pass to
	remove directory entries with no children.  Do not merge to
	master.

2026-06-25  Juri Linkov  <juri@linkov.net>

	Fix interactive spec of some commands bound on the mode line

	Use interactive spec '@' for two commands bound on the mode line
	that should select the window associated with the mouse click
	to avoid toggling the status of the wrong window or buffer.

	* lisp/progmodes/elisp-mode.el (elisp-enable-lexical-binding):
	Add interactive spec '@' (bug#81178).

	* lisp/window.el (toggle-window-dedicated): Add interactive
	spec '@' and replace 'current-buffer' with 'window-buffer'
	to not assume that it operates on the current buffer.

2026-06-25  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir--count-outgoing: Bind enable-local-variables

	* lisp/vc/vc-dir.el (vc-dir--count-outgoing): Bind
	enable-local-variables (bug#81233).  Do not merge to master.

2026-06-25  Michael Albinus  <michael.albinus@gmx.de>

	Support tramp-rpc in filenotify-tests.el

	* test/lisp/filenotify-tests.el (top, file-notify--test-monitor)
	(file-notify-test03-events, file-notify-test12-unmount):
	Handle also tramp-rpc.

2026-06-25  Alan Mackenzie  <acm@muc.de>

	CC Mode: Set parse-sexp-lookup-properties for every mode

	This fixes a bug reported and diagnosed by Campbell Barton
	<ideasman42@gmail.com> on the emacs-devel list.

	* lisp/progmodes/cc-mode.el (c-basic-common-init): Set
	parse-sexp-lookup-properties or (for XEmacs) lookup-syntax-properties
	for every CC Mode mode.

2026-06-25  Dirk-Jan C. Binnema  <djcb@djcbsoftware.nl>  (tiny change)

	Disable DMABUF and Compositing for xwidget

	Webkit does not support DMABUF or accelerated compositing in the
	offscreen widgets Emacs uses for xwidget.  Disable both for non-pgtk
	GTK3 builds (Bug#80834).
	* src/xterm.c (init_xterm): Set WEBKIT_DISABLE_DMABUF_RENDERER and
	WEBKIT_DISABLE_COMPOSITING_MODE when built with xwidgets and not pgtk.

2026-06-25  Eli Zaretskii  <eliz@gnu.org>

	Fix failure code in 'run-hook-query-error-with-timeout'

	* lisp/subr.el (run-hook-query-error-with-timeout): Fix incorrect
	call to 'error'.  (Bug#81292)

2026-06-25  Zhengyi Fu  <i@fuzy.me>  (tiny change)

	Use default-value in project--value-in-dir

	When in a VC project whose dir-locals file specifies `project-vc-name',
	the function `project--value-in-dir' previously used `symbol-value' to
	retrieve the variable value, causing `project-name' to return the same
	name for all VC projects without an explicit `project-vc-name'.  Use
	`default-value' instead to correctly fall back to the default value.

	* lisp/progmodes/project.el (project--value-in-dir): Replace `symbol-value'
	with `default-value' (bug#81293).

2026-06-24  Dmitry Gutov  <dmitry@gutov.dev>

	etags-regen--maybe-generate: No error when no project found

	* lisp/progmodes/etags-regen.el (etags-regen--maybe-generate):
	When no project found, abort cleanly with a message.

2026-06-24  Stephen Berman  <stephen.berman@gmx.net>

	Mark ChangeLog entry as tiny change

	* ChangeLog.5: Mark an entry as a tiny change, because the
	"Copyright-paperwork-exempt: yes" line was mistakenly omitted from
	the commit log entry.

2026-06-24  Sean Whitton  <spwhitton@spwhitton.name>

	VC revert: When un-adding, clear vc-backend property

	* lisp/vc/vc.el (vc-revert-file, vc-revert-files): When
	un-adding, clear vc-backend property (bug#81291).

2026-06-24  Martin Rudalics  <rudalics@gmx.at>

	Document new option 'delete-frame-choose-selected' (Bug#80397)

	* doc/lispref/frames.texi (Deleting Frames): Document new option
	'delete-frame-choose-selected'.
	* etc/NEWS: Mark 'delete-frame-choose-selected', 'split-frame'
	and 'merge-frames' as documented.

2026-06-23  Martin Rudalics  <rudalics@gmx.at>

	Document 'split-frame' and 'merge-frames' in Elisp manual

	* doc/lispref/frames.texi (Splitting and Merging Frames): New
	section.
	* doc/lispref/elisp.texi (Top): Add new section.
	* doc/lispref/windows.texi (Basic Windows): Explain terms
	'layout' and 'identity' of windows.
	(Window Configurations): Explain that window identities are
	preserved by window configurations and get lost with window
	states.

2026-06-23  Sean Whitton  <spwhitton@spwhitton.name>

	Eglot: release version 1.24

	* lisp/progmodes/eglot.el (Version): Bump to 1.24.

	* etc/EGLOT-NEWS: Announce new version.

2026-06-23  Sean Whitton  <spwhitton@spwhitton.name>

	Jsonrpc: release version 1.0.29

	(Version): Bump to 1.0.29.

2026-06-23  João Távora  <joaotavora@gmail.com>

	jsonrpc-shutdown: Ensure we wait whole timeout & increase timeout

	* lisp/jsonrpc.el (jsonrpc-shutdown): Ensure that we wait for
	the whole timeout and increase the timeout to 300ms (bug#80140).

2026-06-23  Sean Whitton  <spwhitton@spwhitton.name>

	vc-hg-state-slow: Run from the repository root

	* lisp/vc/vc-hg.el (vc-hg-state-slow): Run command from the
	repository root.  This fixes cases where a whole subdirectory no
	longer exists.  We should return 'missing' for any files within
	it.

2026-06-23  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-delete-file: Call vc-delete-file on FILESET-ONLY-FILES

	* lisp/vc/vc-dir.el (vc-dir-delete-file): Call vc-delete-file on
	FILESET-ONLY-FILES.  See bug#80998.

2026-06-23  Stéphane Marks  <shipmints@gmail.com>

	Fix 'truncate-string-pixelwise' to restore the window buffer

	* lisp/emacs-lisp/subr-x.el (truncate-string-pixelwise): Safely
	save/restore the selected window's buffer, and not the reference
	or current buffers.  Guard dedicated windows.  Remove the work
	buffer from the window's buffer list.  Bind
	'buffer-list-update-hook' 'window-scroll-functions'
	'window-configuration-change-hook' to nil around the window
	buffer swap.  (Bug#81262; see also bug#80244.)

2026-06-23  Stéphane Marks  <shipmints@gmail.com>

	Restore progress-reporter suffix as update-text (bug#81134)

	* lisp/subr.el (progress-reporter-update-functions): Update
	docstring.
	(progress-reporter-update): New UPDATE-TEXT argument replacing
	previously deleted SUFFIX.
	(make-progress-reporter): Document suffix slot available for
	reuse.
	(progress-reporter-force-update): Update function signature.
	(progress-reporter-echo-area): Restore the text argument and
	echo it.
	(progress-reporter-do-update): Update function signature.  Treat
	UPDATE-TEXT as ephemeral and do not persist it in the reporter
	instance.  Update the hook.
	(progress-reporter-done): Update the hook.
	* lisp/system-taskbar.el
	(system-taskbar--progress-reporter-update): Update function
	signature.
	* lisp/net/tramp.el (tramp-progress-reporter-update): Update
	function signature.
	* doc/lispref/display.texi (Progress): Update documentation.

2026-06-22  Juri Linkov  <juri@linkov.net>

	Rename recently added after-delete-frame-select-mru-frame

	Rename 'after-delete-frame-select-mru-frame' to
	'delete-frame-choose-selected' for symmetry with
	'delete-window-choose-selected' with the same
	default value 'mru' (bug#80397).

	* lisp/cus-start.el: Add a choice like in
	'delete-window-choose-selected'.

	* src/frame.c (delete_frame): Compare delete_frame_choose_selected
	with Qmru.
	(syms_of_frame): Define symbol Qmru.
	Use DEFVAR_LISP for 'delete-frame-choose-selected'
	and set the default value to Qmru.

2026-06-22  duli  <duli4868@gmail.com>  (tiny change)

	Eglot: decode unhexed file URI paths as UTF-8 (bug#79897)

	'url-unhex-string' only decodes %XX sequences and returns a
	unibyte string; it does not interpret the resulting octets as
	UTF-8.  Its docstring says that the resulting string generally
	requires decoding with an appropriate coding system.

	LSP messages are UTF-8, and document URIs are transferred as URI
	strings.  When recovering the file path from the URI, decode the
	unhexed octets as UTF-8 instead of using them directly as an
	Emacs string.  This should fix bug#79897.


	* lisp/progmodes/eglot.el (eglot-uri-to-path): Decode the
	  result of 'url-unhex-string' with 'utf-8-unix'.

2026-06-22  Michael Albinus  <michael.albinus@gmx.de>

	Sync with Tramp 2.8.2

	* lisp/net/tramp-message.el (tramp-trace-add-package): New defun.

	* lisp/net/tramp-smb.el (tramp-smb-maybe-open-connection):
	Remove superfluous comment.

	* lisp/net/tramp.el (tramp-restricted-shell-hosts-alist):
	Use `file-name-sans-extension'.
	(tramp-completion-handle-expand-file-name):
	Apply `tramp-drop-volume-letter' consequently.

	* test/lisp/net/tramp-tests.el
	(tramp--test-ignore-make-symbolic-link-error): Use `file-error'
	instead of `remote-file-error'
	(tramp--test-instrument-test-case-p): Fix doxstring.
	(tramp-test10-write-region-other-file-name-handler)
	(tramp-test49-external-backend-function): Adapt tests.

2026-06-22  Sean Whitton  <spwhitton@spwhitton.name>

	Rename variable to macroexp-enable-preserve-posification

	* lisp/emacs-lisp/macroexp.el
	(macroexp-enable-pos-preservation): Rename ...
	(macroexp-enable-preserve-posification): ... to this.  All uses
	changes.

2026-06-22  Eshel Yaron  <me@eshelyaron.com>

	New variable 'macroexp-enable-pos-preservation' (bug#79599)

	* lisp/emacs-lisp/macroexp.el
	(macroexp-enable-pos-preservation): New variable.
	(macroexp-preserve-posification): Respect it.
	* lisp/emacs-lisp/elisp-scope.el (elisp-scope-1): Use it.
	* test/lisp/emacs-lisp/macroexp-tests.el
	(macroexp--test-macroexp-enable-pos-preservation): New test.

2026-06-21  milkvetch  <xuhi@distruzione.org>  (tiny change)

	Avoid infinite loop in some Dired marking commands

	These commands use dired-get-filename inside a dired-mark-if form;
	when the bottom subdirectory is hidden, dired-get-filename makes
	it so the dired-mark-if loop never reaches the end of the buffer.
	This is fixed by skipping hidden subdirectories (bug#80964).

	* lisp/dired.el (dired-mark-files-regexp)
	(dired-mark-files-containing-regexp):
	* lisp/dired-x.el (dired-mark-unmarked-files):
	* lisp/dired-aux.el (dired-compare-directories): Skip hidden subdirectories.

2026-06-20  Eli Zaretskii  <eliz@gnu.org>

	Resurrect effect of 2nd arg t in 'format-mode-line'

	* src/xdisp.c (Fformat_mode_line): Resurrect support for FACE = t.
	Doc fix.  (Bug#81271)

	* doc/lispref/modes.texi (Emulating Mode Line): Fix documentation
	of 'format-mode-line' when 2nd argument is t.

	* test/src/xdisp-tests.el (xdisp-test-format-mode-line): New test.

2026-06-20  Eli Zaretskii  <eliz@gnu.org>

	Fix 'format-mode-line' for integer second argument

	* src/xdisp.c (Fformat_mode_line): Test for integers with
	INTEGERP.  (Bug#81272)

2026-06-20  Stéphane Marks  <shipmints@gmail.com>

	markdown-ts-mode: fix code block and table overlays (bug#81195)

	Fix to eliminate erroneous multiple code block overlays.  Fixes
	to deal with 'treesit' fontification catching up to
	user-initiated code block range expansions; e.g., inserting,
	yanking.  Set overlay properties only once.

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--fontify-code-block): Use 'overlays-in' not
	'overlays-at'.  Use only overlays, eliminate markers.
	(markdown-ts--enable-code-block-in-context-mode): Add 'sit-for'
	to allow 'treesit' to catch up (pending input should not be an
	issue).
	(markdown-ts--run-command-in-code-block): Use overlays instead
	of 'get-char-property'.
	(markdown-ts--code-block-in-context-mode-update-ov): Use
	overlays instead of 'get-char-property'.  Set overlay properties
	only once.
	(markdown-ts--in-table-mode-update-ov): Set overlay properties
	only once.

2026-06-20  Stéphane Marks  <shipmints@gmail.com>

	markdown-ts-mode: Fix computing code block current region (bug#81219)

	This ensures that commands such as 'comment-or-uncomment-region'
	operate on the correct region in the work buffer.

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts--run-command-in-code-block):
	Fix adj-region-beg and adj-region-end.

2026-06-20  Oleksandr Makhmudov  <oleksandr.makhmudov@pm.me>  (tiny change)

	Eglot: add 'nu-ts-mode' as a nushell major mode

	'nu-ts-mode' is an alternative tree-sitter-based major mode for
	nushell.  This commit adds it to the list of major modes that run
	the nushell language server.
	* lisp/progmodes/eglot.el (eglot-server-programs): Add 'nu-ts-mode'.
	(Bug#81206)

2026-06-20  समीर सिंह Sameer Singh  <lumarzeli30@gmail.com>

	Fix c-ts-mode bsd-style indentation of union bodies (bug#81255)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--simple-indent-rules): Add
	"union_specifier" to the parent-is regexp.

	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts: New test.

2026-06-20  Yuan Fu  <casouri@gmail.com>

	Fix markdown-inline incremental parsing issue (bug#81019)

	* lisp/treesit.el:
	(treesit--embed-languages-need-full-parse): New variable.
	(treesit--set-embed-ranges): Reparse full range if the langauge
	needs it.

2026-06-19  Stephen Berman  <stephen.berman@gmx.net>

	Avoid an unusual error when visiting a directory in Dired

	* lisp/dired.el (dired-internal-noselect): Unset
	'dired--ls-error-buffer' before calling 'dired-readin'.  This is a
	safeguard to prevent an error when visiting a directory in Dired,
	which apparently happens when the variable somehow gets set even
	though 'ls' has not emitted an error message (bug#80499, Message #218).

	* test/lisp/dired-tests.el (dired-test-set-dired--ls-error-buffer): New test.

2026-06-19  Dmitry Gutov  <dmitry@gutov.dev>

	Fix "diff-apply-buffer applies to the wrong file"

	* lisp/vc/diff-mode.el (diff-find-file-name): Inhibit the "drop
	dir" behavior in diffs produced by Git and Hg (bug#81210).
	Except for the virtual subdirectories like a/b/etc, which is
	moved and happens for all such diffs.  Tighten the check for
	such virtual directory names, though (characters are the chars
	used by the configuration option 'diff.mnemonicPrefix').
	(diff-setup-buffer-type): Recognize Hg diffs where only one
	revision is specified, too.

	* test/lisp/vc/diff-mode-tests.el
	(diff-mode-test-setup-buffer-type)
	(diff-mode-test-find-file-name-create): New tests.

2026-06-18  Martin Rudalics  <rudalics@gmx.at>

	Fix thinko in 'set-frame-size-and-position' (Bug#81193)

	* lisp/frame.el (set-frame-size-and-position): Do not subtract
	scoll bar, fringes and internal border sizes twice (Bug#81193).

2026-06-17  JD Smith  <jdtsmith@gmail.com>

	Correct default native-comp tests

	Supersedes 5bd9d1f7df3.

	* configure.ac: Store `with_native_compilation' to correctly test
	whether to use the soft or hard (error) checks, as these set the
	variable by side-effect.

2026-06-16  JD Smith  <jdtsmith@gmail.com>

	Revert "Fix the Android build"

	This reverts commit 916572f6e0ab3e36f7098b6d9b5ff19f87240da4, in favor
	of another fix.

2026-06-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	(comint--intersect-regions): Fix bug#81243

	* lisp/comint.el (comint--intersect-regions): Fix syntax-propertization.

2026-06-14  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.8.6

2026-06-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	src/keyboard.c (Finsert_special_event): Don't ignore unknown events

2026-06-13  João Távora  <joaotavora@gmail.com>

	Eglot: restore compatibility to Emacs 26.3

	Github-reference: https://github.com/joaotavora/eglot/discussions/1591

	Can't use setf plist-get.

	* lisp/progmodes/eglot.el (eglot--async-request): Use cl-getf.

2026-06-12  Martin Rudalics  <rudalics@gmx.at>

	Fix behavior of 'temp-buffer-resize-mode' (Bug#81207)

	* lisp/help.el (temp-buffer-resize-mode): Fix doc-string - a
	window can be resized now even if it has shown another buffer in
	between (Bug#81207).
	(resize-temp-buffer-window): Resize window if and only if its
	buffer is the buffer it has shown initially (Bug#81207).

2026-06-11  Xiyue Deng  <manphiz@debian.org>

	Restore public interfaces for accessing built-in package info

	These functions were removed in ab36f5892203e4b1f59da7c995e0f1fa0a81d1b6
	during the reorganization of package.el as part of Bug#80079.

	Also add a simple test for these functions to avoid future regressions.

	See also discussion at
	https://lists.gnu.org/archive/html/emacs-devel/2026-06/msg00149.html.

	* lisp/emacs-lisp/package.el (package-versioned-builtin-packages,
	package-builtin-package-version): Restore.
	* lisp/emacs-lisp/package-activate.el: Remove lingering comments.
	* test/lisp/emacs-lisp/package-tests.el
	(package-test-builtin-package-info): Add.

2026-06-11  Philip Kaludercic  <philipk@posteo.net>

	Allow uninstalling dependency with multiple installations

	* lisp/emacs-lisp/package.el (package--dependency-p): Add new
	function to check if a package is a dependency.
	(package-delete): Prompt user if it is OK to uninstall a package
	that serves as a dependency, but where the package has multiple
	installations.  This also means that we don't de-select a
	selected dependency if there are multiple installations.

	(Bug#81082)

2026-06-11  Andrea Alberti  <a.alberti82@gmail.com>

	Fix memcpy size in 'merge_faces'

	* src/xfaces.c (merge_faces): Use 'sizeof lface_attrs' instead of
	LFACE_VECTOR_SIZE as the 'memcpy' size argument.  (Bug#81224)

2026-06-11  Sean Whitton  <spwhitton@spwhitton.name>

	Fix fontification in short unintegrated changes logs (bug#81215)

	Do not merge to master.

	* lisp/vc/vc.el (vc--shortlog): New variable.
	(vc-print-log-internal):
	* lisp/vc/vc-git.el (vc-git-log-view-mode):
	* lisp/vc/vc-hg.el (vc-hg-log-view-mode): Use it.

2026-06-11  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/vc/vc.el (vc-log-remote-unintegrated): Set vc-log-view-type.

	Do not merge to master.

2026-06-11  Sean Whitton  <spwhitton@spwhitton.name>

	vc-hg-trunk-or-topic-p, vc-hg-topic-outgoing-base: Fix ret vals

	* lisp/vc/vc-hg.el (vc-hg-trunk-or-topic-p)
	(vc-hg-topic-outgoing-base): Fix return values.

2026-06-11  Stéphane Marks  <shipmints@gmail.com>

	markdown-ts-mode: Sanitize work-buffer pool

	This a workaround for the release branch due to the work-buffer
	pool being insufficiently sanitized.
	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--run-command-in-code-block): Reset 'mark-active'.
	Do not merge to master.  (Bug#81218)  (Bug#81111)

2026-06-10  Michael Albinus  <michael.albinus@gmx.de>

	Extend Tramp external operations

	* doc/misc/tramp.texi (New operations): Extend.

	* lisp/net/tramp.el (tramp-file-name-for-operation-external):
	Extend docstring.
	(tramp-file-name-for-operation): Make more use of
	`tramp-file-name-for-operation-external'.
	(tramp-add-external-operation): Support ARG-TYPE `tramp-file-name'.

	* test/lisp/net/tramp-tests.el (tramp-test49-external-backend-function):
	Extend test.

2026-06-10  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	markdown-ts-mode: fix duplicated menu entries (bug#81201)

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts-code-block-in-context-mode-map)
	(markdown-ts-in-table-mode-map): Remove redundant :parent.

2026-06-10  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-recompute-file-state: Change directory to DEF-DIR

	* lisp/vc/vc-dir.el (vc-dir-recompute-file-state): Change
	directory to DEF-DIR before calling into the backend.
	* test/lisp/vc/vc-tests/vc-test-misc.el
	(vc-test-vc-dir-on-symlink): Test that the file has the right
	state.

2026-06-10  Pip Cet  <pipcet@protonmail.com>

	Restore "interactive" when describing functions

	* lisp/help-fns.el (help-fns-function-description-header): Only
	substitute "an" for "a", not for a longer BEG (bug#81203).

2026-06-09  Stéphane Marks  <shipmints@gmail.com>

	Inhibit follow-link via `mouse-1' on the tab-bar (bug#81036)

	Prevent 'tab-bar' mouse clicks from being directed to the
	current buffer, for example, in `dired-mode'.  This prevents the
	side effect that the clicked tab is erroneously closed.

	* lisp/mouse.el (mouse-on-link-p): Explicitly exempt clicks in
	'tab-bar' if there is a 'follow-link' property.

2026-06-09  Juri Linkov  <juri@linkov.net>

	Fix the tab close button appearance when clicking (bug#76394)

	* src/xdisp.c (handle_tab_bar_click): Use the variable 'close_p'
	to show mouse face as sunken/raised only when clicked
	on the close button.  Clicking elsewhere on the tab should not
	change the close button's appearance using DRAW_MOUSE_FACE.

2026-06-09  Peter Oliver  <git@mavit.org.uk>

	Install images with info documentation (bug#81204)

	* Makefile.in (info_misc): Install all files with .png and .jpg
	extensions into the info directory (bug#81204).

2026-06-09  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-recompute-file-state: Return nil state for nonexistent file

	* lisp/vc/vc-dir.el (vc-dir-recompute-file-state): Return nil
	state for nonexistent file (bug#81191).

2026-06-09  Sean Whitton  <spwhitton@spwhitton.name>

	vc-test-vc-dir-on-symlink: Use vc-test--with-author-identity

	* test/lisp/vc/vc-tests/vc-tests.el (vc-hg-global-switches):
	Declare.
	(vc-tests-helpers): Require.
	(vc-test--create-repo-function, vc-test--with-author-identity):
	Move these from here ...
	* test/lisp/vc/vc-tests/resources/vc-tests-helpers.el
	(vc-test--create-repo-function, vc-test--with-author-identity):
	... to here.
	(vc-hg-global-switches):
	* test/lisp/vc/vc-tests/vc-test-misc.el (vc-hg-global-switches):
	Declare.
	(vc-dir, log-edit, vc-tests-helpers): Require.
	(vc-test-vc-dir-on-symlink): Use vc-test--with-author-identity
	and vc-test--create-repo-function.

2026-06-08  Stéphane Marks  <shipmints@gmail.com>

	Fix M-RET in 'markdown-ts-in-table-mode-map'

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts-in-table-mode-map): Map 'M-RET' to
	'markdown-ts-table-insert-row-below' (bug#81196).

2026-06-08  Sean Whitton  <spwhitton@spwhitton.name>

	Fix recurrence of bug#80803 after changes in bug#80967

	* lisp/vc/vc-dir.el (vc-dir-resynch-file): Pass only truenames
	to vc-dir-recompute-file-state.
	* test/lisp/vc/vc-tests/vc-test-misc.el (vc-git): Require.
	(vc-test-vc-dir-on-symlink): New test.

2026-06-08  Michael Albinus  <michael.albinus@gmx.de>

	Ensure Tramp backward compatibility

	* lisp/net/tramp.el (tramp-local-environment-variable-p):
	Use `tramp-compat-funcall'.

2026-06-07  Juri Linkov  <juri@linkov.net>

	Read a key sequence instead of a single key in 'map-y-or-n-p'

	This is necessary to correctly read keys like 'M-~'
	used by 'save-some-buffers' that is two keys 'ESC ~'
	on a tty.

	* doc/lispref/minibuf.texi (Multiple Queries):
	Index 'y-or-n-p-use-read-key' for 'map-y-or-n-p'.
	Mention using a key sequence instead of single keys.

	* lisp/emacs-lisp/map-ynp.el (map-y-or-n-p):
	In the 'y-or-n-p-use-read-key' cond-branch,
	use 'read-key-sequence-vector' instead of 'read-key'.
	In the default cond-branch, use 'this-command-keys-vector'
	instead of 'last-command-event'.  In both cond-branches
	use 'key-description' instead of 'single-key-description'
	(bug#81168).
	Instead of '(eq def nil)' check if chars are either nil
	or an empty vector in noninteractive mode (bug#67836).

	* test/lisp/emacs-lisp/map-ynp-tests.el (test-map-ynp-kmacro):
	Test separately nil/non-nil 'y-or-n-p-use-read-key'.
	(test-map-ynp-keys): New test for complete coverage of
	'map-y-or-n-p'.

2026-06-07  Eli Zaretskii  <eliz@gnu.org>

	Avoid recursive error in debug-early in batch mode

	* lisp/emacs-lisp/debug-early.el (cl--generic-compiler): Defvar it.
	(debug-early-backtrace): Bind it so as to avoid loading
	byte-compiler; see the value of the variable in cl-generic.el.
	Do not merge to master.  (Bug#80916)

2026-06-07  Eli Zaretskii  <eliz@gnu.org>

	Remove from CC Mode code that modifies 'major-mode-remap-defaults'

	* lisp/progmodes/cc-mode.el: Remove code that adds to
	'major-mode-remap-defaults', as enabling and disabling tree-sitter
	based modes now goes through 'treesit-enabled-modes'.

2026-06-06  Pip Cet  <pipcet@protonmail.com>

	Assert we don't double-free timers (bug#81108)

	* src/atimer.c (cancel_atimer): Assert that we found the timer.

2026-06-06  Pip Cet  <pipcet@protonmail.com>

	Don't cancel random timers in x_get_foreign_selection (bug#81108)

	* src/pgtkselect.c (pgtk_display_selection_waiting_message):
	(pgtk_cancel_atimer):
	(pgtk_get_foreign_selection):
	* src/xselect.c (x_display_selection_waiting_message):
	(x_cancel_atimer):
	(x_get_foreign_selection): Use a pointer to a timer variable, which is
	cleared when the timer runs or is otherwise cancelled.  Don't cancel
	the timer twice.

2026-06-06  Pip Cet  <pipcet@protonmail.com>

	Fix use-after-free in Ffuncall_with_delayed_message (bug#81108)

	* src/eval.c (with_delayed_message_display):
	(with_delayed_message_cancel):
	(Ffuncall_with_delayed_message): Use new temporary data
	structure.  Cancel timer at most once.

2026-06-06  Andrea Alberti  <a.alberti82@gmail.com>

	Document 'margin' face as base for margin display strings (Bug#80693)

	* doc/lispref/display.texi (Displaying Faces): Note that the
	underlying-text rule does not apply to strings displayed in the
	display margins, and reword the margin-face bullet to describe
	'margin' as the base.
	(Basic Faces): Note that the 'margin' face also provides the base
	attributes for strings displayed in the margins.
	(Display Margins): Drop a sentence that restated the preceding one
	about unspecified attributes inheriting from 'margin'.
	* etc/NEWS: Document the change for margin strings.

	Suggested by F. Jason Park <jp@neverwas.me>.

2026-06-06  Augusto Stoffel  <arstoffel@gmail.com>

	Improve prompting for mail sending by by 'report-emacs-bug'

	* lisp/mail/emacsbug.el (report-emacs-bug-hook): Don't ask about
	mail sending options if 'message-server-alist' is set.  (Bug#81176)

2026-06-06  Po Lu  <luangruo@yahoo.com>

	Fix the Android build

	* configure.ac: Don't test for libgccjit.h if a preceding test
	have already concluded that native compilation is unavailable.

2026-06-05  Andrea Alberti  <a.alberti82@gmail.com>

	Don't resurrect invisible child frames when rebuilding parent links

	On the NS port, -[EmacsWindow setParentChildRelationships] reattaches
	every child frame to its parent via -addChildWindow:ordered:, which also
	orders the child window onto the screen.  This runs whenever the
	parent/child relationships are rebuilt, e.g., when entering non-native
	fullscreen, which allocates a fresh EmacsWindow whose initializer
	rebuilds the relationships.  A child frame that Emacs had made invisible
	(e.g. a corfu/company completion popup) was thereby brought back as a
	stale, non-responsive child frame.  Emacs never repaints to clear it
	because frame_redisplay_p trusts FRAME_VISIBLE_P on the NS port and
	avoids dealing with the child frame when it is marked as invisible.

	Native fullscreen does not trigger this: -toggleFullScreen: hands off to
	AppKit without allocating a new window, so the rebuild never runs.

	A hidden child frame is normally detached from its parent already: Emacs
	hides it with -orderOut: (ns_make_frame_invisible), which per Apple's
	documentation removes a child window from its parent before ordering it
	out.  The fix is therefore not to re-attach a child while it is
	invisible; ns_make_frame_visible already reinstates the parent/child link
	when the frame is shown again.

	* src/nsterm.m ([EmacsWindow setParentChildRelationships]): Only
	re-attach a child window when the frame is marked visible.
	(ns_make_frame_visible): Explain, with a reference to Apple's
	documentation, why the parent/child link must be reinstated on show.

2026-06-05  Stéphane Marks  <shipmints@gmail.com>

	Improve progress-reporter state to remove hard coded length (bug#80988)

	Remove hard-coded state range, now a monotonically increasing
	integer.

	* lisp/subr.el (progress-reporter-update-functions): Update
	docstring.
	(progress-reporter-echo-area): Use
	'progress-reporter--pulse-characters' length.
	(progress-reporter-do-update): Increase 'state' by 1 each pass.
	*
	lisp/system-taskbar.el (system-taskbar--progress-reporter-update):
	Make steps independent of 'progress-reporter-echo-area' steps.

2026-06-05  Arash Esbati  <arash@gnu.org>

	(tex-main-file): Add forgotten safety predicate (bug#81099)

	That variable is commonly set file-locally.

	* lisp/textmodes/tex-mode.el (tex-main-file): Add safety predicate.

2026-06-05  Al Haji-Ali  <a.hajiali@hw.ac.uk>

	Fix bug in latexenc when AUCTeX is loaded

	* lisp/international/latexenc.el
	(latexenc-find-file-coding-system): Set file name correctly when
	`TeX-master' is a string.  (Bug#81099)

2026-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	paren.el: Fix part of bug#81035

	* lisp/paren.el (show-paren--default): Syntax-propertize before narrowing.

2026-06-05  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp version

	* lisp/net/trampver.el (customize-package-emacs-version-alist):
	Add Tramp version integrated in Emacs 31.1.

	* doc/misc/trampver.texi:
	* lisp/net/trampver.el (tramp-version): Adapt Tramp versions.

2026-06-05  Augusto Stoffel  <arstoffel@gmail.com>

	Check buffer-local value in tramp-local-environment-variable-p

	* lisp/net/tramp.el (tramp-local-environment-variable-p): Do it.

2026-06-05  Sean Whitton  <spwhitton@spwhitton.name>

	Bump Emacs version to 31.0.90

	* README:
	* configure.ac:
	* exec/configure.ac:
	* java/AndroidManifest.xml.in (Version-code):
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 31.0.90.

2026-06-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	message.el: Fix part of bug#81035

	* lisp/gnus/message.el (message-narrow-to-field)
	(message-hide-headers): Syntax-propertize before narrowing.

2026-06-04  Michael Albinus  <michael.albinus@gmx.de>

	Fix prompt in remote shell

	* lisp/net/tramp-sh.el (tramp-sh-handle-make-process): Do not use a
	hard-coded directory in PS1.  (Bug#81177)

2026-06-04  Dirk-Jan C. Binnema  <djcb@djcbsoftware.nl>

	Fmake_xwidget: Use about:blank workaround only when needed

	* src/process.c (glib_installs_sigchld_handler): New variable.
	(init_process_emacs): Set it when GLib overrides Emacs's SIGCHLD
	handler.
	* src/process.h (glib_installs_sigchld_handler): Declare.
	* src/xwidget.c (Fmake_xwidget): Skip the "about:blank"
	workaround when glib_installs_sigchld_handler is false.

2026-06-04  JD Smith  <jdtsmith@gmail.com>

	Allow brew/macports libgccjit for default native compilation

	* configure.ac: Move flag setup for libgccjit installed by
	Homebrew or macports earlier, so default native compilation can
	proceed (bug#81171).

2026-06-04  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-refresh: Respect non-essential wrt saving buffers

	* lisp/vc/vc-dir.el (vc-dir-refresh): If non-essential is
	non-nil, don't call vc-buffer-sync-fileset.

2026-06-04  Alan Mackenzie  <acm@muc.de>

	CC Mode: Fontify a cast type preceding a brace initialization

	This fixes bug#81084.
	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1):
	In the test for a cast near the end of the function, add a test
	for a {...} block which isn't a statement block, allowing such
	blocks to be recognized as operands of casts.

2026-06-04  Michael Albinus  <michael.albinus@gmx.de>

	Fix Tramp distrobox integration

	* lisp/net/tramp.el (tramp-yesno-prompt-regexp): Fix docstring.
	(tramp-yn-prompt-regexp): Fix docstring.  Extend.  Add :version.

	* test/lisp/net/tramp-tests.el (tramp-test03-file-error): Adapt test.

2026-06-04  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	markdown-ts-mode: fix first-item indent (bug#81118)

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--fontify-unordered-list-marker): Skip leading
	whitespace in the node range before applying the display bullet,
	since the tree-sitter grammar bundles indent into the first
	list_marker_* node.

2026-06-03  Dmitry Gutov  <dmitry@gutov.dev>

	[GTK3] Re-fix the stored values for width and height

	* src/gtkutil.c (xg_frame_set_char_size)
	(xg_frame_set_size_and_position): Round WIDTH and HEIGHT to
	multiples of SCALE without adding toolbar/menubar (bug#80662).

2026-06-02  João Távora  <joaotavora@gmail.com>

	Eglot: mentions markdown-ts-view-mode less (bug#81150)

	* doc/misc/eglot.texi (Customization Variables): Don't mention
	markdown-ts-view-mode.

	* etc/EGLOT-NEWS: Don't mention markdown-ts-view-mode.

2026-06-02  Alexander Adolf  <alexander.adolf@condition-alpha.com>

	vc--subject-to-file-name: Fix over-greedy regex (bug#81017)

	* lisp/vc/vc.el (vc--subject-to-file-name): Make the prefix
	regex less greedy, ensure the result has no text properties,
	improve the docstring (bug#81017).

2026-06-02  F. Jason Park  <jp@neverwas.me>

	Fix more missing faces on ERC margin strings

	* lisp/erc/erc-goodies.el (keep-place-indicator): Add
	`erc-keep-place-indicator-arrow' face to overlay arrow.
	* lisp/erc/erc-stamp.el (erc-stamp--display-prompt-in-left-margin)
	(erc--conceal-prompt): Add `erc-prompt-face' to entire `left-margin'
	string.  See also 9ba65aa9 "Fix missing margin face on display prop in
	erc-stamp".
	* test/lisp/erc/erc-fill-tests.el (erc-fill--left-hand-stamps): Update
	expected text properties on prompt.  (Bug#80693)

2026-06-01  João Távora  <joaotavora@gmail.com>

	Eglot: Simplify markdown rendering support (bug#81150)

	Now that markdown-ts-view-mode is demoted to "experimental" in emacs-31,
	simplify bits of eglot.el and rewrite docs to be more neutral.  In
	practice 'gfm-view-mode' is still used if found, just like before, but
	intrepid users can still try the "experimental" modes.

	* lisp/progmodes/eglot.el (eglot-documentation-renderer): Rewrite
	doc string.
	(eglot--accepted-formats): Rewrite.
	(eglot--builtin-mdown-p): Remove.

	* doc/misc/eglot.texi (Customization Variables): Rewrite entry.

	* etc/EGLOT-NEWS: Tweak.

2026-06-01  Eli Zaretskii  <eliz@gnu.org>

	Prevent segfaults due to frame resizing at the wrong time

	* src/dispextern.h:
	* src/xdisp.c (dont_resize_frames): New variable.
	(unwind_format_mode_line): Decrement 'dont_resize_frames'.
	(gui_consider_frame_title, display_mode_line, Fformat_mode_line):
	Increment 'dont_resize_frames'.
	* src/dispnew.c (do_pending_window_change): Don't resize frames if
	'dont_resize_frames' is non-zero.  (Bug#81121)

	(cherry picked from commit 94eb6389d403eb1b71a81ecdc3b8416cf5f850d6)

2026-06-01  Sean Whitton  <spwhitton@spwhitton.name>

	Disable markdown-ts-mode & markdown-ts-view-mode for Emacs 31

	Do not merge to master.

	* lisp/progmodes/eglot.el (eglot-documentation-renderer)
	(eglot--format-markup): Don't call eglot--builtin-mdown-p.
	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-mode)
	(markdown-ts-view-mode): Mark as experimental.
	(auto-mode-alist, treesit-major-mode-remap-alist): Don't add
	anything.
	* doc/misc/eglot.texi (Customization Variables):
	* etc/EGLOT-NEWS:
	* etc/NEWS: Don't mention markdown-ts-mode or
	markdown-ts-view-mode.

2026-05-31  Juri Linkov  <juri@linkov.net>

	More tests for fill-paragraph-handle-comment.erts

	* test/lisp/textmodes/fill-resources/fill-paragraph-handle-comment.erts:
	Add more tests for current comment lines (bug#80449).

2026-05-31  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.8.5

2026-05-30  João Távora  <joaotavora@gmail.com>

	Eglot: replace eglot-prefer-plaintext with eglot-documentation-renderer

	The old boolean 'eglot-prefer-plaintext' is replaced by the more
	expressive 'eglot-documentation-renderer', which can hold a major-mode
	symbol, t (plain text), or nil (auto-detect each time).  By selecting a
	renderer once at startup the repeated per-request lookups are avoided,
	which helps with the slowness reported in bug#81150.

	* lisp/progmodes/eglot.el (eglot-prefer-plaintext): Declare obsolete
	alias to 'eglot-documentation-renderer'.
	(eglot-documentation-renderer): New defcustom, reworked from from
	eglot-prefer-plaintext.
	(eglot--accepted-formats): Use new variable.
	(eglot--format-markup): Use new variable.

	* etc/EGLOT-NEWS: Announce change.

	* doc/misc/eglot.texi (Customization Variables): Document
	  eglot-documentation-renderer.

2026-05-30  Amin Bandali  <bandali@gnu.org>

	Make HTML button elements tab-stoppable in eww (bug#81107)

	* lisp/net/eww.el (eww-form-submit): Call put-text-property to
	add help-echo and shr-tab-stop properties.
	(eww-tag-input): Exclude inputs with type="submit" when adding
	the help-echo and shr-tab-stop properties, since that's now done
	in eww-form-submit, called earlier for type="submit".

2026-05-30  Eli Zaretskii  <eliz@gnu.org>

	Don't make buffer read-only when reverting if 'view-mode' was disabled

	* lisp/view.el (view--disable): Reset 'read-only-mode--state'.
	(Bug#81149)

2026-05-29  Augusto Stoffel  <arstoffel@gmail.com>

	* lisp/shell.el (shell): Fix typo: use process-live-p (bug#81145).

2026-05-28  David Ponce  <da_vid@orange.fr>

	widget-image-find: Use 'image-load-path' (bug#81140)

	* lisp/wid-edit.el (widget-image-find): Use 'image-load-path' (bug#81140).

2026-05-28  Po Lu  <luangruo@yahoo.com>

	Fix the MSDOS build

	* msdos/sedlibmk.inp (GL_GNULIB_MEMEQ, GL_GNULIB_STREQ)
	(GL_GNULIB_STRNUL): New substitutions, replacing that of
	GL_GNULIB_STRINGEQ.

	* src/term.c (init_tty) [MSDOS]: Assign appropriate value to
	tty->TN_max_colors.

	Do not merge to master.

2026-05-27  Zhengyi Fu  <i@fuzy.me>  (tiny change)

	Fix lax whitespace highlight during query-replace

	* lisp/replace.el (query-replace-read-args): Add :lax-whitespace to
	minibuffer-lazy-highlight-setup, so lazy highlight during
	query-replace respects replace-lax-whitespace and
	replace-regexp-lax-whitespace (bug#81131).

2026-05-27  Juri Linkov  <juri@linkov.net>

	Fix fill-paragraph combining text with preceding comment

	* lisp/textmodes/fill.el (fill-paragraph): Handle the case
	when a non-comment line follows a comment line with
	non-nil 'fill-paragraph-handle-comment' (bug#80449).
	Skip such a comment line before filling a non-comment line.

	* test/lisp/textmodes/fill-tests.el
	(fill-test-fill-paragraph-handle-comment): Add new test.

	* test/lisp/textmodes/fill-resources/fill-paragraph-handle-comment.erts:
	New file.

2026-05-27  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient quote_argument is void

	* lib-src/emacsclient.c (quote_argument):
	Don’t use ‘return E;’ in a function returning void.
	Problem found by Oracle Developer Studio 12.6.

2026-05-24  Sean Whitton  <spwhitton@spwhitton.name>

	Revert "* admin/notes/documentation: Recommend not using "it's"."

2026-05-24  Sean Whitton  <spwhitton@spwhitton.name>

	native--compile-skip-on-battery-p: Try to fix ?b, ?B conditions

	* lisp/emacs-lisp/comp-run.el
	(native--compile-skip-on-battery-p): Don't skip charging because
	the battery is charging, and don't look for "discharging", at
	least for now (bug#80922).  Thanks to David Koppelman
	<koppel@ece.lsu.edu> for the report.

2026-05-24  Zhengyi Fu  <i@fuzy.me>  (tiny change)

	Save and restore original local keymap in grep-edit-mode

	* lisp/progmodes/grep.el (grep-edit-original-mode-map): New
	variable.
	(grep-change-to-grep-edit-mode): Save the current local map
	before switching to grep-edit-mode-map.
	(grep-edit-save-changes): Restore the saved local map instead of
	assuming grep-mode-map (bug#81090).

2026-05-24  Eli Zaretskii  <eliz@gnu.org>

	Fix display of inline SVG images in Rmail

	* lisp/mail/rmailmm.el (rmail-mime-set-bulk-data): Support
	Content-type of "svg+xml" if SVG images are supported,

2026-05-24  Yuan Fu  <casouri@gmail.com>

	Add treesit-ready-p check back to tree-sitter major modes (bug#80909)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode):
	(c++-ts-mode):
	* lisp/progmodes/cmake-ts-mode.el (cmake-ts-mode):
	* lisp/progmodes/dockerfile-ts-mode.el (dockerfile-ts-mode):
	* lisp/progmodes/elixir-ts-mode.el (elixir-ts-mode):
	* lisp/progmodes/go-ts-mode.el (go-ts-mode):
	(go-mod-ts-mode):
	(go-work-ts-mode):
	* lisp/progmodes/heex-ts-mode.el (heex-ts-mode):
	* lisp/progmodes/js.el (js-ts-mode):
	* lisp/progmodes/lua-ts-mode.el (lua-ts-mode):
	* lisp/progmodes/python.el (python-ts-mode):
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode):
	* lisp/progmodes/sh-script.el (bash-ts-mode):
	* lisp/progmodes/typescript-ts-mode.el (typescript-ts-mode):
	(tsx-ts-mode):
	* lisp/textmodes/css-mode.el (css-ts-mode):
	* lisp/textmodes/mhtml-ts-mode.el (mhtml-ts-mode):
	* lisp/textmodes/toml-ts-mode.el (toml-ts-mode):
	* lisp/textmodes/yaml-ts-mode.el (yaml-ts-mode):
	* lisp/treesit-x.el (treesit-generic-mode-setup): Add the check.

2026-05-24  João Távora  <joaotavora@gmail.com>

	Fix pathological slowness in flex completion

	The 'completion-regexp-list' optimization in
	completion--flex-all-completions-1, a cheap pre-filter via a trivial
	regexp, performs very poorly for longer patterns and strings, so drop
	it.  That alone recovers fairly decent performance for the flex
	completion when compared to the 'hotfuzz' point of reference.

	We then recover the cheap rejection with an O(N+M) pre-check in the
	Fcompletion__flex_cost_gotoh C scorer.  This kicks in the common case
	(completion-ignore-case is nil) and pays off especially when the table
	is already a list and 'all-completions' needn't cons.

	See:
	  https://lists.gnu.org/archive/html/emacs-devel/2026-04/msg01081.html
	  https://lists.gnu.org/archive/html/emacs-devel/2026-05/msg00519.html

	* lisp/minibuffer.el (completion--flex-all-completions-1): Remove
	regexp pre-filter.

	* src/minibuf.c (Fcompletion__flex_cost_gotoh): Add subsequence
	pre-check.

2026-05-23  Amin Bandali  <bandali@gnu.org>

	No longer raise error on HTTP 402 (Payment Required) (bug#81101)

	* lisp/url/url-http.el (url-http-parse-headers): Return t instead of
	raising an error, to give the user a chance to interact with the page.

2026-05-23  Thomas Mühlbacher  <tmuehlbacher@posteo.net>  (tiny change)

	Avoid compilation-mode matching rust as gnu

	* lisp/progmodes/compile.el
	(compilation-error-regexp-alist-alist): Put 'rust' before 'gnu'
	to avoid a mismatch since the " |" has become optional (bug#81075).

2026-05-23  Sean Whitton  <spwhitton@spwhitton.name>

	* build-aux/git-hooks/commit-msg: Replace Markdown-style quotation.

2026-05-23  Sean Whitton  <spwhitton@spwhitton.name>

	vc-test--rename-file: Disable part of test for SCCS

	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-file):
	Disable part of test for SCCS.

2026-05-23  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	markdown-ts-mode: Don't enable unconditionally by default

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-mode-maybe):
	New function.
	(auto-mode-alist): Bind ".md", ".markdown", and ".mdx" to
	'markdown-ts-mode-maybe' instead of 'markdown-ts-mode'.
	* etc/NEWS: Update the 'markdown-ts-mode' entry.

2026-05-23  Manuel Giraud  <manuel@ledu-giraud.fr>

	Prettify special glyphs

	* lisp/disp-table.el (prettify-special-glyphs-mode): New mode to
	display nicer special glyphs.
	(special-glyphs): New face for displaying special glyphs when
	the minor mode is active.
	(prettify-special-glyphs-saved-truncation)
	(prettify-special-glyphs-saved-continuation): Internal variables
	to save previous special glyphs.
	* etc/NEWS: Announce the change.  (Bug#80628)

2026-05-23  Eli Zaretskii  <eliz@gnu.org>

	Revert "sh-script: Mark + and * as punctuation rather than a symbol constituent"

	This reverts commit b3c0aee42b086af4b3c6e26da1a5d81490b6128b.
	It caused regressions in 'sh-script', see bug#80794 and
	bug#80854.

2026-05-23  Richard Lawrence  <rwl@recursewithless.net>

	Rename `icalendar-recur' type and related functions

	More context in Bug#80786 and:
	https://lists.gnu.org/archive/html/emacs-orgmode/2026-03/msg00286.html

	`icalendar-recur' as a type name for RRULE values was confusing and made
	the accessors for this type difficult to discover, because `icalendar-recur-'
	is also used as a prefix in icalendar-recur.el.  This change renames the
	`icalendar-recur' type to `icalendar-rrule-value' and renames the
	accessor functions for these values appropriately.

	* lisp/calendar/icalendar-parser.el:  Rename symbols as follows:
	(icalendar-recur): `icalendar-rrule-value'
	(icalendar-read-recur-rule-part): `icalendar-read-rrule-part'
	(icalendar-print-recur-rule-part): `icalendar-print-rrule-part'
	(icalendar-recur-rule-part): `icalendar-rrule-part'
	(icalendar-read-recur): `icalendar-read-rrule-value'
	(icalendar-print-recur): `icalendar-print-rrule-value'
	(icalendar--recur-value-types): `icalendar--rrule-value-types'
	(icalendar-recur-value-p): `icalendar-rrule-value-p'
	(icalendar-recur-freq): `icalendar-rrule-freq'
	(icalendar-recur-interval-size): `icalendar-rrule-interval-size'
	(icalendar-recur-until): `icalendar-rrule-until'
	(icalendar-recur-count): `icalendar-rrule-count'
	(icalendar-recur-weekstart): `icalendar-rrule-weekstart'
	(icalendar-recur-by*): `icalendar-rrule-by*'.
	(icalendar-rrule):
	(icalendar-index-insert):
	(icalendar-index-get): Update references.
	* lisp/calendar/icalendar-recur.el (icalendar-recur-find-interval):
	(icalendar-recur-nth-interval):
	(icalendar-recur-next-interval):
	(icalendar-recur-previous-interval):
	(icalendar-recur-refine-from-clauses):
	(icalendar-recur-recurrences-in-interval):
	(icalendar-recur-recurrences-in-window):
	(icalendar-recur-recurrences-to-count):
	(icalendar-recur-tz-observance-on): Update references.
	* lisp/calendar/diary-icalendar.el: Update references.
	* lisp/calendar/icalendar-shortdoc.el (icalendar): Update shortdoc examples.
	* lisp/gnus/gnus-icalendar.el: Update references.
	* test/lisp/calendar/diary-icalendar-tests.el:
	* test/lisp/calendar/icalendar-parser-tests.el:
	* test/lisp/calendar/icalendar-recur-tests.el: Update references in tests.

2026-05-22  Jacek Migacz  <jmigacz@redhat.com>

	Fix Lisp injection via X-Draft-From in Gnus

	* lisp/gnus/gnus-msg.el (gnus-inews-make-draft-meta-information):
	Escape the group name with prin1-to-string to prevent arbitrary
	Lisp injection through crafted group names.  The unescaped group
	name was embedded into a Lisp-readable string, parsed back with
	read-from-string in gnus-draft-setup, and eventually eval'd via
	message-do-actions, allowing code execution when a draft was sent.

2026-05-22  Martin Rudalics  <rudalics@gmx.at>

	Save/restore old_buffer slot via window configurations (Bug#81097)

	With Emacs 31 the old_buffer slot of a window gets overwritten
	with the buffer unshown in that window when that window is
	deleted.  Fset_window_configuration triggers that when calling
	delete_all_child_windows.  If a window configuration gets saved
	and restored in one and the same redisplay cycle, the change
	time stamps of the window and its frame will be equal and
	'window-buffer-change-functions' may wrongly decide that the
	window's buffer has not changed because its buffer and
	old_buffer slots refer to the same buffer (Bug#81097).  Fix that
	by saving and restoring the old_buffer slot.

	* src/window.c (struct saved_window): Add 'old_buffer' slot.
	(Fset_window_configuration): Restore old_buffer slot.
	(save_window_save): Save old_buffer slot.

2026-05-22  Michael Albinus  <michael.albinus@gmx.de>

	Adapt ert-remote-temporary-file-directory settings

	* lisp/emacs-lisp/ert-x.el (tramp-default-remote-shell)
	(tramp-encoding-shell): Declare.
	(tramp-methods) <mock>: Add `tramp-tmpdir'.  Adapt
	`tramp-login-program' and `tramp-remote-shell'.

2026-05-22  Eli Zaretskii  <eliz@gnu.org>

	Fix warning message in 'markdown-ts-mode--initialize'

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts-mode--initialize): Tweak the warning message when
	Tree-sitter is not available.  (Bug#81100)

2026-05-22  Dmitry Gutov  <dmitry@gutov.dev>

	Fix "assertion 'GTK_IS_WINDOW (window)' failed"

	* src/gtkutil.c (xg_frame_set_size_and_position): Remove a
	gtk_window_resize call which used a wrong value type
	(GdkX11Window instead of GtkWindow).  The original motivation
	for that line seems to be fixed by later changes (bug#80662).

2026-05-21  Dmitry Gutov  <dmitry@gutov.dev>

	[Xt] Fix child frame resizing glitch

	* src/widget.c (EmacsFrameResize): Exit early for child frames
	(bug#81077).

2026-05-21  João Távora  <joaotavora@gmail.com>

	Eglot: use standard face for completion annotations (bug#81088)

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Use
	completions-annotations face, not font-lock-function-name-face.

2026-05-20  Juri Linkov  <juri@linkov.net>

	Fix 'shr-outline-search' (bug#81073)

	* lisp/net/shr.el (shr-outline-search):
	Don't check for the beginning of the line.
	Suggested by Omar Antolín Camarena <omar@im.unam.mx>.
	Confirmed by Rahguzar <rahguzar@mailbox.org>.

2026-05-20  Michael Albinus  <michael.albinus@gmx.de>

	Improve auth-source-backend-parse

	* lisp/auth-source.el (auth-source-backend-parse): Use `run-hook-wrapped'.
	Suggested by Augusto Stoffel <arstoffel@gmail.com>.
	Transform a warning into a debug message.

2026-05-20  João Távora  <joaotavora@gmail.com>

	Eglot: announce markdown support for completion docs

	No reason not to.  Tested with gfm-view-mode and markdown-ts-mode

	* lisp/progmodes/eglot.el (eglot-client-capabilities): Annouce
	markdown support for completion docs.

2026-05-20  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	markdown-ts-mode: hide fence lines in view-mode (bug#81081)

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--fontify-delimiter): When `markdown-ts-hide-markup'
	is enabled in `markdown-ts-view-mode', also hide the whole line
	containing a `fenced_code_block_delimiter' (including its
	terminating newline) so Eldoc/LSP markdown snippets render
	without stray blank lines around the code block.  Scoped to
	view-mode and to fenced delimiters on purpose: the same handler
	is shared by inline delimiters (emphasis, code span, link
	brackets) where munching surrounding whitespace would collapse
	word separators, and tuning rendering for
	hide-markup-while-editing is not a goal.

2026-05-20  João Távora  <joaotavora@gmail.com>

	markdown-ts-mode: align default face definitions with markdown-mode

	Match the out-of-the-box appearance of markdown-ts-mode to the
	non-tree-sitter markdown-mode package, making switching between modes
	less jarring.

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-delimiter)
	(markdown-ts-heading-1, markdown-ts-heading-2, markdown-ts-heading-3)
	(markdown-ts-heading-4, markdown-ts-heading-5, markdown-ts-heading-6)
	(markdown-ts-block-quote, markdown-ts-code-block, markdown-ts-code-span)
	(markdown-ts-indented-code-block, markdown-ts-html-tag)
	(markdown-ts-html-block, markdown-ts-thematic-break)
	(markdown-ts-entity-reference, markdown-ts-numeric-character-reference)
	(markdown-ts-table, markdown-ts-table-header, markdown-ts-table-cell)
	(markdown-ts-table-delimiter-cell, markdown-ts-language-keyword)
	(markdown-ts-list-marker, markdown-ts-hard-line-break-backslash)
	(markdown-ts-hard-line-break-backslash-hidden)
	(markdown-ts-hard-line-break-space-hidden)
	(markdown-ts-task-unchecked, markdown-ts-task-checked): Tweak.

2026-05-20  Stéphane Marks  <shipmints@gmail.com>

	Fix markdown-ts-mode atx_heading face computation (bug#81042)

	The grammar reports leading spaces as part of the atx_heading "marker"
	and we cannot use the length of the marker as a result.  Instead, count
	the number of consecutive # after any blanks to determine its "level."

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--fontify-atx-heading): Count the octothorpes rather
	than using the length of the marker node's text.

2026-05-20  Stéphane Marks  <shipmints@gmail.com>

	Allow markdown-ts--run-command-in-code-block to ignore output (bug#81041)

	Do not assume every command run in
	'markdown-ts--run-command-in-code-block' produces output that needs to
	be merged from the temp/work buffer into the source buffer.  One example
	is 'xref-find-definitions', the temp buffer of which is unrelated to the
	source buffer.

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts-code-block-commands): Add 'complete-symbol'.
	(markdown-ts-code-block-ignore-output-commands): New defvar.
	(markdown-ts--run-command-in-code-block): Ignore command output
	when necessary.

2026-05-19  Lin Sun  <sunlin7@hotmail.com>

	hideshow: Menu entry for 'hs-toggle-all'

	* lisp/progmodes/hideshow.el: Menu entry for hs-toggle-all (bug#81045).

2026-05-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	doc/lispref/text.texi: Add complement to commit f4a1c006569f

	* doc/lispref/text.texi (Examining Properties): Mention the change in
	cursor-sensor-functions.

2026-05-18  João Távora  <joaotavora@gmail.com>

	Eglot: fix eglot--format-makrup when MARKUP just a string

	* lisp/progmodes/eglot.el (eglot--format-markup): Fix case where
	markup is string.

2026-05-18  F. Jason Park  <jp@neverwas.me>

	Fix missing margin face on display prop in erc-stamp

	* lisp/erc/erc-stamp.el (erc-insert-timestamp-right): Explicitly add
	face to right-hand stamp's `display' margin string.  Commit d24b10ca
	"Introduce 'margin' face for window margin background" did away with the
	"fall-through" behavior in which a margin spec's string that lacks its
	own face property inherited whatever the associated `display' char
	happened to have.  (Bug#80693)

	;; The old language in "(elisp) Display Margins" said "if the
	;; string to be displayed in the margin doesn't specify a face, its
	;; face is determined using the same rules and priorities as it is
	;; for strings displayed in the text area (see Displaying Faces),"
	;; and that "if this results in undesirable 'leaking' of faces into
	;; the margin, make sure the string has an explicit face specified
	;; for it."  It seems ERC and likely more than a few other packages
	;; never came to heed this guidance and have erroneously depended
	;; on such behavior for years if not decades.
	;;
	;; * test/lisp/erc/resources/fill/snapshots/merge-01-start.eld:
	;; * test/lisp/erc/resources/fill/snapshots/merge-02-right.eld:
	;; * test/lisp/erc/resources/fill/snapshots/merge-wrap-01.eld:
	;; * test/lisp/erc/resources/fill/snapshots/merge-wrap-indicator-pre-01.eld:
	;; * test/lisp/erc/resources/fill/snapshots/monospace-01-start.eld:
	;; * test/lisp/erc/resources/fill/snapshots/monospace-02-right.eld:
	;; * test/lisp/erc/resources/fill/snapshots/monospace-03-left.eld:
	;; * test/lisp/erc/resources/fill/snapshots/monospace-04-reset.eld:
	;; * test/lisp/erc/resources/fill/snapshots/spacing-01-mono.eld: Update
	;; snapshot.

2026-05-18  Sean Whitton  <spwhitton@spwhitton.name>

	vc-refresh-state: Override default-directory for backend functions

	I ran into the issue described in the comment with the current
	code in project-find-file-in and project-find-dir, when using
	'C-x p p' to switch between projects.

	* lisp/vc/vc-hooks.el (vc-refresh-state): When calling into the
	backend, override any let-bindings of default-directory.

2026-05-18  João Távora  <joaotavora@gmail.com>

	Eglot: unbreak for treesit-less builds

	* lisp/progmodes/eglot.el
	(eglot--builtin-mdown-p): New helper.
	(eglot--accepted-formats)
	(eglot--format-markup): Use it.

2026-05-18  Joshua Murphy  <joshuamurphy@posteo.net>  (tiny change)

	Get selected item in newsticker list view

	* lisp/net/newst-treeview.el
	(newsticker--treeview-get-selected-item): If an item is already
	selected, use it.  (Bug#80972)

2026-05-17  Brian Leung  <leungbk@posteo.net>

	Eglot: fix thinko in recent markdown-related commit (bug#81063)

	* lisp/progmodes/eglot.el (eglot--format-markup): Correct return value
	for gfm-view-mode.

2026-05-17  João Távora  <joaotavora@gmail.com>

	Jsonrpc: migrate more tests to Python subprocess fixtures

	All tests now use 'jsonrpc--with-python-fixture' with a Python3
	subprocess instead of the in-Emacs TCP server.  Changed the "harakiri"
	method to be a request instead of a notification for to reduce chance of
	"Sentinel hasn't run" warning.

	The two in-Emacs-RPC-specific error tests ('errors-with--32601' and
	'signals-an--32603-JSONRPC-error') are dropped with the fixture itself,
	as the error paths they exercise are internal to the Emacs Lisp
	dispatcher and have no direct Python equivalent.  They will have to be
	re-done later on in other form.

	* test/lisp/jsonrpc-resources/server-emacsrpc.py: New file.

	* test/lisp/jsonrpc-resources/server-anxious-nested.py: Use new
	  harakiri.

	* test/lisp/jsonrpc-resources/server-emacsrpc.py: Use new harakiri.

	* test/lisp/jsonrpc-resources/server-harakiri.py: Use new harakiri.

	* test/lisp/jsonrpc-resources/server-remote-during-sync-1.py: Use new
	  harakiri.

	* test/lisp/jsonrpc-resources/server-remote-during-sync-2.py: Use new
	  harakiri.

	* test/lisp/jsonrpc-resources/server-remote-error.py: Use new harakiri.

	* test/lisp/jsonrpc-resources/common.py (harakiri): New definition.

	* test/lisp/jsonrpc-tests.el
	(jsonrpc--with-python-fixture): Rework, move up.
	(jsonrpc-connection-ready-p): Move up.
	(jsonrpc--call-with-emacsrpc-fixture)
	(jsonrpc--with-emacsrpc-fixture)
	(errors-with--32601)
	(signals-an--32603-JSONRPC-error): Remove.
	(returns-3, times-out, doesnt-time-out, stretching-it-but-works)
	(deferred-action-toolate, deferred-action-intime)
	(deferred-action-complex-tests): Migrate to Python fixture.
	(scontrol-remote-during-sync-1, scontrol-remote-during-sync-2)
	(scontrol-anxious-nested, scontrol-remote-error)
	(shutdown-clean-after-notification): Tweak.

2026-05-17  João Távora  <joaotavora@gmail.com>

	Eglot: add left-fringe code action indicator (bug#80326)

	The fringe indicator uses a custom lightning-bolt bitmap, an alternative
	to the margin indicator on GUI frames.  It is non-interactive, however.

	* lisp/progmodes/eglot.el (eglot--fringe-action): New fringe bitmap.

	(eglot-code-action-indications): Add 'left-fringe' to default value
	and to docstring.  Update incompatibility note.

	(eglot-code-action-suggestion): Handle 'left-fringe' indication.

2026-05-17  Michael Albinus  <michael.albinus@gmx.de>

	Fix auth-source-backends-parse

	* lisp/auth-source.el (auth-source-backend-parse): Drop backends
	of type `ignore'.  (Bug#81024)
	(auth-source-backends): Drop duplicate backends.

2026-05-17  Eli Zaretskii  <eliz@gnu.org>

	Fix updates of embedded formulas by 'calc-embedded-update-formula'

	* lisp/calc/calc-embed.el (calc-embedded-update): Use
	'buffer-substring' to better track the string representation of
	the formula when it is being edited.  Suggested by
	gnu@publik.slmail.me.  Also, update commentary.  (Bug#80901)

2026-05-16  Andrea Alberti  <a.alberti82@gmail.com>

	Fill margins with 'margin' face on truncated screen lines

	* src/xdisp.c (display_line): Remove the unnecessary condition that
	row->used of the margin areas is zero, for when we call
	'extend_face_to_end_of_line'.  (Bug#80693)

2026-05-14  João Távora  <joaotavora@gmail.com>

	Eglot: adjust reference to completion frontends in manual

	* doc/misc/eglot.texi (Eglot Features): Rework.

2026-05-14  João Távora  <joaotavora@gmail.com>

	Eldoc: display documentation in visual-line-mode

	Documentation is overwhelmingly prose and intended to be viewed,
	not edited.  Using visual-line-mode allows members of
	'eldoc-doc-functions' to provide long lines that correctly fill
	to the window width.

	* lisp/emacs-lisp/eldoc.el (eldoc--format-doc-buffer): Use
	visual-line-mode.

2026-05-14  João Távora  <joaotavora@gmail.com>

	Eglot: prefer markdown-ts-view-mode for markup rendering (bug#80127)

	Eglot previously needed gfm-view-mode from markdown-mode.el to render
	Markdown from LSP servers.  It now prefers markdown-ts-view-mode when
	available.

	* lisp/progmodes/eglot.el (eglot--accepted-formats): Recognize
	markdown-ts-view-mode as a Markdown renderer.
	(eglot--format-markup): Rework with cl-labels; prefer
	markdown-ts-view-mode over gfm-view-mode.

	* doc/misc/eglot.texi (Eglot Features): Don't mention
	markdown-mode directly.

	* etc/EGLOT-NEWS: Mention change

2026-05-14  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	Use 'read-multiple-choice' in 'markdown-ts-mode' (bug#81027)

	Replace the "c" character-prompt interactive spec with
	'read-multiple-choice', which presents named options instead of
	requiring users to decode the prompt string and type a single
	character.

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts-table-align-column): Use 'read-multiple-choice'.
	Adjust ALIGN docstring punctuation.
	* lisp/textmodes/markdown-ts-mode-x.el
	(markdown-ts-toc-insert-template): Use 'read-multiple-choice'.

2026-05-14  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	Fix 'markdown-ts-code-span' face (bug#81026)

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-code-span):
	Inherit from 'font-lock-keyword-face' rather than
	'font-lock-string-face'.

2026-05-14  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	Add read-only 'markdown-ts-view-mode' (bug#81023)

	This new derived mode is intended for consumers that render
	Markdown content for display rather than editing, such as Eglot
	and Eldoc when showing documentation popups and buffers.  It
	pre-sets the relevant customizations (markup hidden, inline
	images on, hard-line-break markup hidden, native code-block
	fontification, table and code-block context minor modes off),
	makes the buffer read-only, and uses its own keymap derived from
	'special-mode-map' so navigation keys behave like a viewer.

	A pre-init hook lets callers normalize buffer content before the
	grammar parses it; 'markdown-ts-add-final-newline' is the
	default so that markup depending on a terminating newline parses
	correctly.  'markdown-ts-buffer-string' returns the rendered
	buffer string with overlay faces flattened into text properties,
	which is useful for callers that capture the rendered output.

	Along the way: 'list_marker_parenthesis' is now recognized as an
	ordered list marker; the strikethrough query is simplified to a
	single rule; thematic breaks span the window via an ':extend'
	underline when the face supports it.

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-view-mode):
	New read-only derived mode.
	(markdown-ts-view-mode-map): New keymap.
	(markdown-ts-view-mode-pre-init-hook): New hook, defaulting to
	'markdown-ts-add-final-newline'.
	(markdown-ts-mode--initialize): New helper, factored out of
	'markdown-ts-mode' so 'markdown-ts-view-mode' can reuse the
	parser readiness and setup logic after overriding local
	variables.
	(markdown-ts-mode): Call 'markdown-ts-mode--initialize'.
	(markdown-ts-add-final-newline): New function.
	(markdown-ts-buffer-string): New function.
	(markdown-ts-unordered-list-marker): New defcustom.
	(markdown-ts-hard-line-break-backslash)
	(markdown-ts-hard-line-break-space): Accept the symbol 'hide.
	(markdown-ts--fontify-hard-line-break): Honor 'hide.
	(markdown-ts--fontify-atx-heading)
	(markdown-ts--fontify-setext-heading)
	(markdown-ts--fontify-atx-delimiter)
	(markdown-ts--fontify-unordered-list-marker)
	(markdown-ts--list-item-depth): New functions supporting clean
	rendering when markup is hidden.
	(markdown-ts--fontify-thematic-break): Use ':extend' underline
	span when the face supports it.
	(markdown-ts--resolve-display-value): Accept non-cons values.
	(markdown-ts--list-ordered-item-p): Also recognize
	'list_marker_parenthesis'.
	(markdown-ts--range-settings): Mark markdown-inline embed as
	':local t'.
	(markdown-ts--set-up): Create the markdown-inline parser only in
	the inline setup branch; drop the redundant
	'markdown-ts-hide-markup' make-local-variable.
	(markdown-ts--treesit-settings): Route atx and setext headings
	to their dedicated fontifiers; route unordered list markers
	through 'markdown-ts--fontify-unordered-list-marker'; move
	'strikethrough' to the simpler paragraph-inline query.

2026-05-13  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	Fix strikethrough in 'markdown-ts-mode' (bug#80991)

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--treesit-settings): Add a new font-lock block for
	'paragraph-inline' that handles strikethrough nodes more
	carefully.

2026-05-13  Rahul Martim Juliato  <rahul.juliato@gmail.com>

	Fix code-span in headings in 'markdown-ts-mode' (bug#80979)

	* lisp/textmodes/markdown-ts-mode.el
	(markdown-ts--treesit-settings): Move the 'code_span' and
	'code_span_delimiter' font-lock rules into a separate block with
	':override prepend' instead of 'append'.  The heading feature
	(level 1) applies its face via 'font-lock-append-text-property',
	so a code span that later appends 'markdown-ts-code-span' ends
	up with '(markdown-ts-heading-N markdown-ts-code-span)', where
	the heading face takes priority and the code-span face is
	suppressed.  Prepending ensures 'markdown-ts-code-span' appears
	first in the face list and wins visually.

2026-05-13  Stéphane Marks  <shipmints@gmail.com>

	Make 'markdown-ts-inline-images' buffer local and test for GUI (bug#80978)

	* lisp/textmodes/markdown-ts-mode.el (markdown-ts-inline-images):
	Now buffer local.
	(markdown-ts--fontify-image): Defensively test for graphical
	display before rendering images.

2026-05-13  Michael Albinus  <michael.albinus@gmx.de>

	* etc/NEWS: Mention new user option tramp-propagate-emacsclient-tramp.

2026-05-13  Michael Albinus  <michael.albinus@gmx.de>

	Propagate EMACSCLIENT_TRAMP to remote hosts with Tramp

	* doc/misc/tramp.texi (Remote processes):
	Explain `tramp-propagate-emacsclient-tramp'.

	* lisp/net/tramp.el (tramp-remote-process-environment): Adapt docstring.
	(tramp-propagate-emacsclient-tramp): New defcustom.
	(tramp-handle-make-process):
	* lisp/net/tramp-sh.el (tramp-sh-handle-make-process)
	(tramp-sh-handle-process-file): Use it.

	* test/lisp/net/tramp-tests.el (tramp-test33-environment-variables):
	Adapt test.

2026-05-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	keyboard-tests.el: Try and fix the failure on EMBA

	* test/src/keyboard-tests.el (keyboard-sigint-to-quit): Fix a small
	race condition and avoid `sit-for` returning early.

2026-05-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	doc: Remove long obsolete references to `package-initialize`

	Since Emacs-27, `package-initialize` is for internal use only,
	and callers should either call `package-activate-all` instead
	(cheaper and faster) or do nothing at all (because the other
	functions should trigger the needed initialization automatically
	as needed).

	* doc/lispref/package.texi (Packaging Basics): Delete `package-initialize`.

	* doc/misc/eglot.texi (Reporting bugs): Don't recommend using `package-initialize`.

	* doc/misc/org.org (Using Emacs packaging system): Simplify the command
	line since both `(require 'package)` and `(package-initialize)` are
	redundant here.

2026-05-13  Sean Whitton  <spwhitton@spwhitton.name>

	vc-next-action: Call vc-delete-file on FILESET-ONLY-FILES

	* lisp/vc/vc.el (vc-next-action): Call vc-delete-file on
	FILESET-ONLY-FILES, not FILES (bug#80998).

2026-05-12  Elias Gabriel Perez  <eg642616@gmail.com>

	hideshow: Support new 'margin' face for margin indicators. (Bug#80693)

	* lisp/progmodes/hideshow.el (hs-indicator-hide): Remove 'default' face.
	(hs--make-indicators-overlays): Rework.

2026-05-12  Juri Linkov  <juri@linkov.net>

	Use the new 'margin' face in Flymake (bug#80693)

	* lisp/progmodes/flymake.el (flymake--bs-display):
	Use the 'margin' face when it's available.

2026-05-12  Sean Whitton  <spwhitton@spwhitton.name>

	vc-dir-resynch-file: Pass down non-truename'd FILE

	* lisp/vc/vc-dir.el (vc-dir-recompute-file-state): Delete
	recently introduced TRUENAME parameter.
	(vc-dir-resynch-file): Pass the file name from before calling
	file-truename to vc-dir-recompute-file-state.

2026-05-12  F. Jason Park  <jp@neverwas.me>

	Change ERC version for Emacs 31 to 5.6.2.31.1

	* doc/misc/erc.texi: Change ERCVER to 5.6.2.31.1.
	* lisp/erc/erc.el: Change "Version" package header to 5.6.2.31.1.  Don't
	update the `customize-package-emacs-version-alist' entry because this is
	not a GNU ELPA release.
	(erc-version): Change version to 5.6.2.31.1.

	Do not merge to master.

2026-05-11  Philip Kaludercic  <philipk@posteo.net>

	Fix 'sgml-parse-tag-backward' to handle tags in comments

	* lisp/textmodes/sgml-mode.el (sgml--find-<>-backward): Ignore
	SGML tags that happen to occur within comments.  This also means
	that the contents of comments are not indented, but also do not
	affect the indentation of tags following the comments as well.

	(Bug#80841)

2026-05-11  Aidan Coyle  <packrat386@gmail.com>  (tiny change)

	Fix eww-submit for forms with no action (bug#80918)

	* lisp/net/eww.el (eww-submit): If a form does not specify an action
	the assumed action is the current URL. If the current URL has an
	existing query part, that part must be replaced by the form values,
	rather than appended to.

2026-05-11  Elias Gabriel Perez  <eg642616@gmail.com>

	* lisp/progmodes/hideshow.el (hs--set-variable): Use 'set-local' (bug#80999)

2026-05-11  Juri Linkov  <juri@linkov.net>

	Fix Completions buffer disappearing with tmm-menubar (bug#80995)

	* lisp/minibuffer.el (completions--start-background-update):
	Cancel a possible leftover timer (e.g. from the previous
	after-change hook) that would suppress the display of
	*Completions* when 'completion-eager-update' is nil.
	(completions--after-change): Don't start background update
	when not required to automatically update *Completions*.

2026-05-11  Michael Albinus  <michael.albinus@gmx.de>

	Fix secrets.el when Emacs is a flatpak

	* doc/misc/dbus.texi (Flatpak integration): New chapter.

	* lisp/net/secrets.el (top): Protect against wrong signals in the
	flatpak case.  (Bug#80977)

2026-05-11  Philip Kaludercic  <philipk@posteo.net>

	Fix 'prepare-user-lisp' to follow symlinks

	* lisp/startup.el (prepare-user-lisp): Call
	'directory-files-recursively' with a non-nil value for
	FOLLOW-SYMLINKS.  This was the intended way for the function to
	operate, during the planning phase, so that users could
	structure their User Lisp directory by linking in Lisp
	directories from other parts of their file system.

2026-05-11  Philip Kaludercic  <philipk@posteo.net>

	Update "timeout" to 2.1.6

	See https://lists.gnu.org/archive/html/emacs-devel/2026-05/msg00033.html.

2026-05-11  Dmitry Gutov  <dmitry@gutov.dev>

	[GTK3, HiDPI] Fix width/height round-trip through ConfigureNotify

	* src/gtkutil.c (xg_frame_set_char_size)
	(xg_frame_set_size_and_position): Truncate WIDTH and HEIGHT to
	be multiples of the scale factor (bug#80662).

2026-05-11  Dmitry Gutov  <dmitry@gutov.dev>

	[GTK3] On Expose, repaint the border before the content

	* src/xterm.c (handle_one_xevent): Move the
	x_clear_under_internal_border call before expose_frame, for less
	chance of implicit flush to screen in between (bug#80662).

2026-05-10  Pip Cet  <pipcet@protonmail.com>

	Test read-passwd behavior (bug#80838)

	* test/lisp/auth-source-tests.el (auth-source-test--displayed-string):
	(auth-source-test-read-passwd):
	(auth-source-test-read-passwd-revealed):
	(auth-source-test-read-passwd-nested): New.

2026-05-10  Pip Cet  <pipcet@protonmail.com>

	Fix nested read-passwd calls (bug#80838)

	Calls to 'read-passwd' may be nested.  The old code didn't handle
	that, because some of the state was global and we'd end up revealing
	passwords.  The new code still has global state, but it has been
	changed so that we hide rather than reveal passwords when we enter or
	leave a nested read-passwd prompt.

	* lisp/auth-source.el (read-passwd--hide-password): Removed.
	(read-passwd--password-hidden): New.
	(read-passwd-toggle-visibility): Add optional FORCE argument.
	(read-passwd--mini-buffers): New variable.
	(read-passwd-mode): Don't modify mode line when nested.  Hide password
	when returning to nested minibuffer or entering a new one.

2026-05-09  Pip Cet  <pipcet@protonmail.com>

	Fix terminal emulation of "ESC [ K" sequence

	* lisp/term.el (term-erase-in-line): Don't immediately delete the
	newly inserted characters.

2026-05-09  Eli Zaretskii  <eliz@gnu.org>

	Fix vertical-motion across overlay strings with embedded newlines

	* src/indent.c (Fvertical_motion): Handle the case of an overlay
	string on invisible text at point.  (Bug#80989)

2026-05-09  Morgan Smith  <Morgan.J.Smith@outlook.com>

	Mark gnus-dbus.el as obsolete

	This functionality has been replaced by the new sleep library
	which supports more then just DBUS systems.

	* lisp/obsolete/gnus-dbus.el: Add Obsolete-since header.  Add
	commentary.
	(gnus-dbus-close-on-sleep, gnus-dbus-sleep-registration-object)
	(gnus-dbus-register-sleep-signal gnus-dbus-sleep-handler)
	(gnus-dbus-unregister-sleep-signal): Mark as obsolete.

2026-05-09  Morgan Smith  <Morgan.J.Smith@outlook.com>

	Move gnus-dbus.el to obsolete/gnus-dbus.el

	* lisp/gnus/gnus-dbus.el: Move from here...
	* lisp/obsolete/gnus-dbus.el: ...to here.

2026-05-09  Morgan Smith  <Morgan.J.Smith@outlook.com>

	Gnus: Use new sleep library

	* etc/NEWS: Announce.
	* lisp/gnus/gnus-start.el: Don't require gnus-dbus.
	(gnus-sleep-handler): New function.
	(gnus-close-on-sleep): New variable.
	(gnus-1): Add `gnus-sleep-handler' to
	`system-sleep-event-functions' when `gnus-close-on-sleep' is
	non-nil.
	* doc/misc/gnus.texi: Update documentation.

2026-05-09  Eli Zaretskii  <eliz@gnu.org>

	Fix Rmail behavior wrt globalized minor modes

	Previously, "M-x rmail" would not call 'run-mode-hooks', which
	didn't let globalized minor modes a chance to turn on themselves
	in Rmail buffers.  This modifies the way Rmail runs the various
	hooks so as to abide by behavior required by Emacs 30 and later.
	* lisp/mail/rmail.el (rmail-mode-2): Call 'run-mode-hooks'.
	(rmail-mode): Call 'run-hooks', not 'run-mode-hooks'.  Suggested
	by Mark Lillibridge <mdl@alum.mit.edu>.  (Bug#80879)

2026-05-09  Eli Zaretskii  <eliz@gnu.org>

	Fix display images in the display margins

	* src/xdisp.c (handle_single_display_spec): Set the iterator face
	to use 'margin' when displaying in the margins.  (Bug#80693)

2026-05-09  João Távora  <joaotavora@gmail.com>

	Eglot: fix eglot--sig-info with non-UTF-32 positionEncoding

	Github-reference: https://github.com/joaotavora/eglot/discussions/1588

	When the server negotiates positionEncoding utf-8 or utf-16,
	ParameterInformation.label vector offsets are byte/code-unit counts
	into the signature label, not character counts.  Using them raw caused
	wrong highlights and crashes on Unicode-rich signatures.

	* lisp/progmodes/eglot.el (eglot--sig-info): Mostly rewrite.
	(eglot-move-to-utf-8-linepos-function): Tweak docstring.
	(eglot-move-to-utf-8-linepos, eglot-move-to-utf-16-linepos): Return
	position moved to.

2026-05-08  Alan Third  <alan@idiocy.org>

	[NS] Fix deprecated variable (bug#80985)

	* src/nsterm.h (NSLevelIndicatorStyleContinuousCapacity): Define in
	macOS < 10.15.

2026-05-08  Dmitry Gutov  <dmitry@gutov.dev>

	vc-switch-working-tree: Use project-current again

	* lisp/vc/vc.el (vc-switch-working-tree): Use project-current
	instead of manually constructing VC project objects.

2026-05-08  Stéphane Marks  <shipmints@gmail.com>

	treesit-explore-mode usability improvements (bug#80935)

	Improve the usability of treesit-explore-mode.

	- Prompt for the primary parser first, if there is one, rather
	than the first in the list reported by 'treesit-parser-list'.
	Previously, in a multi-parser buffer like 'markdown-ts-mode', one
	had to hunt for the primary parser.

	- Kill the tree buffer and its window if the source buffer is
	killed or 'treesit-explore-mode'.  Previously, when
	'treesit-explore-mode' is disabled in the source buffer, its
	companion explorer tree buffer was left dangling and window
	open (with an unrelated buffer).

	- Improve 'treesit--explorer-refresh-1' to recenter the window
	around the selected nodes when the selected region in the source
	buffer changes.  Previously, one had to navigate manually to find
	the corresponding highlighted node in the tree window which may
	be far away from that the source buffer's region represents.

	- Disable 'treesit-explore-mode' in the source buffer if its
	companion tree buffer is killed.  Previously,
	'treesit-explore-mode' remained active in the source buffer in
	an effectively unusable state.

	- Disable 'treesit-explore-mode' if the user quits
	'completing-read' in 'treesit-explorer-switch-parser' when
	enabling the mode.  Previously, 'treesit-explore-mode' was left
	enabled after quit.

	- New command to switch back and forth between the source buffer
	and tree buffer windows to make navigating more convenient.
	Previously, in a multi-window frame, one had to navigate to/from
	these two related windows in a more cumbersome way.

	- New command to quit 'treesit-explore-mode' and
	'treesit--explorer-tree-mode' and handle buffer and window
	cleanup.

	* lisp/treesit.el (treesit--explorer-refresh-1): Recenter the
	window, if amenable, to the node selected in the source buffer.
	(treesit--explorer-kill-explorer-buffer): Remove function.
	(treesit--explorer-generate-parser-alist): Prioritize the
	primary parser, if there is one.
	(treesit--explorer-tree-mode-cleanup): New defun.
	(treesit-explore-quit): New command.
	(treesit-explorer-tree-window): New defun.
	(treesit-explorer-source-buffer-window): New defun.
	(treesit-explore-mode-map): Revise key bindings.
	(treesit--explorer-tree-mode-map): Revise key bindings.
	(treesit--explorer-tree-mode): New keymap.
	(treesit-explorer-switch-parser): Add a default to
	completing-read.
	(treesit-explore-mode): Guard completing read quit.  Wire up the
	new cleanup functions.

2026-05-07  João Távora  <joaotavora@gmail.com>

	Fix 'vc-dir-resynch-file' again (bug#80967)

	This unbreak project-vc-dir for dirs under non-truename
	hierarchies.

	The following commit presumably makes 'M-x vc-dir' usable again
	for versioned directories inside non-truename hierarchies,

	   commit e05fab5775c96f8f88eab8d75dea40253bfb78eb
	   Author: Stephen Berman <stephen.berman@gmx.net>
	   Date:   Sat May 2 15:11:37 2026 +0200

	       Fix 'vc-dir-resynch-file' (bug#80803)

	       * lisp/vc/vc-dir.el (vc-dir-resynch-file): Apply 'file-truename'
	       instead of 'expand-file-name' to FNAME argument to prevent
	       spurious display of symlinked files in *vc-dir* buffer.

	However the similar command 'M-x project-vc-dir' was broken and made
	unusable in similar circumstances.

	This relatively simple fix addresses both situations touching only the
	problematic 'vc-resynch-file' and one of its callees,
	'vc-dir-recompute-file-state', which now discerns clearly between the
	short/familiar name to present in the list and the "fname" to use to
	call into the backend to gather the VC state.  Since this function is
	also called from another context, where the requirements are less clear,
	keeping current smenatics in that situation seemed prudent, so the new
	behaviour is activate with a new optional parameter.

	* lisp/vc/vc-dir.el (vc-dir-resynch-file): Call
	vc-dir-recompute-file-state with truename=t.
	(vc-dir-recompute-file-state): Accept optional truename param.

2026-05-07  Sean Whitton  <spwhitton@spwhitton.name>

	Cut the emacs-31 release branch

	* README:
	* configure.ac:
	* exec/configure.ac:
	* java/AndroidManifest.xml.in (Version-code):
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 31.0.60.
	* lisp/cus-edit.el (customize-changed-options-previous-release):
	Set last version to 30.2.

2026-05-07  Zeke Dou  <zeke@zekedou.live>  (tiny change)

	Move ns_init_colors() after init_callproc() (bug#80752)

	'data-directory' needs to be established in advance of 'ns_init_colors'
	to ensure the file "etc/rgb.txt" is read.  This was encountered on an
	out-of-tree Nix build.

	* src/emacs.c (main): Move the 'ns_init_colors' after 'init_callproc'.

2026-05-07  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.13.3-10-g87d0ca08

2026-05-07  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in redisplay due to continuation glyphs

	* src/xdisp.c (display_line): When inserting continuation glyphs,
	account for the border glyph in non-rightmost windows on TTY
	frames.  (Bug#80975)

2026-05-07  Sean Whitton  <spwhitton@spwhitton.name>

	Unpreload package-activate-all

	See <https://debbugs.gnu.org/80079#49> for my reasoning.

	* lisp/emacs-lisp/package-activate.el (package-activate-all):
	Unpreload.

2026-05-07  Dmitry Gutov  <dmitry@gutov.dev>

	[GTK3] Move the frame to position before showing

	* src/xterm.c (x_make_frame_visible): Move XMoveWindow call before
	gtk_widget_show_all, so that the move happens before the frame
	become visible (bug#80662).

2026-05-07  Dmitry Gutov  <dmitry@gutov.dev>

	[GTK3] Improve the resize -> hide -> show scenario

	* src/gtkutil.c (xg_frame_set_char_size)
	(xg_frame_set_size_and_position): Call gtk_window_resize for
	child frames too, to record _GtkWindowGeometryInfo#resize_width
	and resize_height.  They are later looked up by
	gtk_widget_show_all in x_make_frame_visible (bug#80662).
	Without this the widgets go back and forth between the
	remembered and actual sizes after make-visible.

2026-05-06  Michael Albinus  <michael.albinus@gmx.de>

	Handle long environment variables in Tramp oricesses

	* lisp/net/tramp-sh.el (tramp-sh-handle-make-process):
	Handle loooong environment variables.  (Bug#80783)

	* test/lisp/net/tramp-tests.el (tramp-test33-environment-variables):
	Adapt test.

2026-05-06  Dmitry Gutov  <dmitry@gutov.dev>

	Fix flicker of child frame right after make-frame-visible

	* src/xterm.c (x_make_frame_visible): Call SET_FRAME_GARBAGED
	before making a child frame visible (bug#80943).

2026-05-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	(help--symbol-completion-table): Try and fix bug#80873

	* lisp/help-fns.el (help--symbol-completion-table): Don't let
	`test-completion` pretend that `definition-prefixes` are
	actually valid function names.

2026-05-05  Juri Linkov  <juri@linkov.net>

	Improve 'context-menu-send-to' (bug#79512)

	* lisp/mouse.el (context-menu-functions): Add missing
	'context-menu-send-to' to :type.
	(context-menu-send-to): Get non-nil items to avoid
	useless message "Nothing to send".

	* lisp/send-to.el (send-to-handlers): Change from
	'defvar-local' to 'defvar' to allow easier global configuration.
	(send-to-supported-p): Check for non-nil handler.

2026-05-05  Sean Whitton  <spwhitton@spwhitton.name>

	vc-switch-working-tree: Don't find non-VC projects

	* lisp/vc/vc.el (project-current-directory-override):
	Delete declaration.
	(project-find-matching-buffer-function): Declare.
	(vc-switch-working-tree):
	Don't find non-VC projects (bug#80939).

2026-05-05  Sean Whitton  <spwhitton@spwhitton.name>

	vc-finish-logentry: Skip displaying async command buffer sometimes

	* lisp/vc/vc-dispatcher.el (vc-finish-logentry): Don't display
	the async command buffer if vc-display-failed-async-commands is
	non-nil.

2026-05-05  Eshel Yaron  <me@eshelyaron.com>

	elisp-mode: Cache 'help-echo' function results (bug#80948)

	This ensures we only compute the 'help-echo' string once per
	symbol in a certain position.

	* lisp/progmodes/elisp-mode.el
	(elisp--annotate-symbol-with-help-echo): Add caching for
	when the symbol role's :help property is a function.

2026-05-05  Andrea Alberti  <a.alberti82@gmail.com>

	Introduce 'margin' face for window margin background

	A new basic face 'margin' is used for text displayed in the left and
	right margin areas, i.e., the areas typically used by VCS and LSP
	packages for per-line annotations.  Its background defaults to the
	frame default, preserving existing behavior for users who do not
	customize it.
	* etc/NEWS: Document the new 'margin' face.
	* lisp/faces.el (margin): Add 'margin' face, inheriting from 'default'.
	* src/dispextern.h (face_id): Add MARGIN_FACE_ID.
	* src/xdisp.c (face_at_pos): Use 'margin' as the base face for
	strings displayed in margin areas so that they inherit the gutter
	background by default.
	(extend_face_to_end_of_line): Compute 'margin_fill_face_id' from the
	'margin' face.  Use while loops to explicitly fill all empty character
	slots in both left and right margins for both GUI and TTY branches.
	(display_line): Call 'extend_face_to_end_of_line' for beyond-EOB rows
	when the window has margins.  Also extend the existing condition for
	text rows with empty margins to trigger when the 'margin' face
	background differs from the frame default, not only when the default
	face is remapped.
	* src/xfaces.c (realize_basic_faces): Realize 'margin' as a basic
	face to support face-remapping and efficient lookup.
	(Bug#80693)

2026-05-05  Augusto Stoffel  <arstoffel@gmail.com>

	Accept stream type as 4th argument of X-Message-SMTP-Method header

	* lisp/gnus/message.el (message-multi-smtp-send-mail): Set
	'smtpmail-stream-type' if specificed in the header.
	* doc/misc/message.texi (Mail Variables): Document that.
	(Bug#80880)

2026-05-05  Rahul Martim Juliato  <rahul.juliato@gmail.com>
	    Stéphane Marks  <shipmints@gmail.com>

	Improve 'markdown-ts-mode'

	Overhaul 'markdown-ts-mode' with comprehensive fontification,
	code block handling, editing commands, fill-paragraph support,
	inline image previews, a mode menu, and table editing.  Add
	'markdown-ts-mode-x.el' with conversion/export and TOC support.

	* lisp/textmodes/markdown-ts-mode.el: Add Version,
	Package-Requires, and Keywords header fields.  Expand Commentary
	with documentation for code block language modes, code block
	commands, bidirectional text, and known tree-sitter grammar
	bugs.
	(require 'goto-addr, xref, icons): New requirements.
	(markdown-ts): New customization group with :version and
	:package-version tags.
	(markdown-ts-hide-markup): Add :version and :package-version.
	(markdown-ts-ellipsis): New option for folded heading ellipsis.
	(markdown-ts-menu-bar-show): New option to toggle mode menu.
	(markdown-ts-default-folding): New option for default fold
	level.
	(markdown-ts-inline-images): New option to display inline
	images.
	(markdown-ts-image-max-width): New option for image max width.
	(markdown-ts-display-remote-inline-images): New option for
	remote image handling.
	(markdown-ts--resolve-display-value): New helper to resolve
	display values using char-displayable-p.
	(markdown-ts-checked-checkbox): New option for checked checkbox
	display string or icon.
	(markdown-ts-checked-checkbox-icon): New icons.el icon for the
	checked variant.
	(markdown-ts-unchecked-checkbox): New option for unchecked
	checkbox display string or icon.
	(markdown-ts-unchecked-checkbox-icon): New icons.el icon for the
	unchecked variant.
	(markdown-ts-thematic-break-character): New option for thematic
	break display character.
	(markdown-ts-hard-line-break-backslash): New option for the
	glyph shown in place of a trailing-backslash hard line break
	when markup is hidden.
	(markdown-ts-hard-line-break-space): New option for the glyph
	shown in place of a trailing-spaces hard line break when markup
	is hidden.
	(markdown-ts-code-block-in-context-mode-lighter): New option for
	code block context mode lighter string.
	(markdown-ts-inhibit-code-block-mode-warnings): New option to
	inhibit code-block major-mode messages and warnings.
	(markdown-ts-table-default-column-width): New option for default
	table column width.
	(markdown-ts-enable-table-mode): New option to enable table
	mode.
	(markdown-ts-table-auto-align): New option for triggers that
	cause automatic table alignment.
	(markdown-ts-table-align-features): New option for table align
	features.
	(markdown-ts-in-table-mode-lighter): New option for
	markdown-ts-in-table-mode lighter string.
	(markdown-ts-emphasis, markdown-ts-bold)
	(markdown-ts-strikethrough, markdown-ts-link)
	(markdown-ts-link-destination, markdown-ts-code-span)
	(markdown-ts-code-block, markdown-ts-code-block-markup-hidden)
	(markdown-ts-indented-code-block, markdown-ts-html-tag)
	(markdown-ts-html-block, markdown-ts-thematic-break)
	(markdown-ts-entity-reference)
	(markdown-ts-numeric-character-reference, markdown-ts-latex)
	(markdown-ts-table-header, markdown-ts-table-cell)
	(markdown-ts-table-delimiter-cell, markdown-ts-task-unchecked)
	(markdown-ts-task-checked): New faces.
	(markdown-ts-hard-line-break-backslash)
	(markdown-ts-hard-line-break-backslash-hidden)
	(markdown-ts-hard-line-break-space)
	(markdown-ts-hard-line-break-space-hidden): New faces for the
	two hard-line-break variants, with distinct shown/hidden
	appearances.
	(markdown-ts-in-code-block): New face for when point is inside a
	fenced code block.
	(markdown-ts-table): New face for Markdown pipe table
	background.
	(markdown-ts-in-table): New face for markdown-ts-in-table-mode
	when point is in a table.
	(markdown-ts--set-up-inline): New variable for lightweight setup
	in embedded inline markdown-ts-mode buffers used by code block
	commands.
	(markdown-ts-default-code-block-mode): New variable to define
	default mode for anonymous code blocks.
	(markdown-ts-fontify-code-blocks-natively): New option to
	enable/disable native fontification of fenced code block
	contents.
	(markdown-ts-enable-code-block-context-mode): New option to
	enable/disable code block context integration.
	(markdown-ts-code-block-modes): New variable replacing
	markdown-ts--code-block-language-map and
	markdown-ts-code-block-source-mode-map with unified language to
	mode mapping including heuristic lookup.
	(markdown-ts-code-block-force-conventional-modes): New variable
	listing tree-sitter modes whose fontification of code block
	content should be harvested via a temporary buffer.
	(markdown-ts-table-export-buffer): New constant for table export
	output buffer name.
	(markdown-ts--table-row-types, markdown-ts--table-cell-types)
	(markdown-ts--table-delimiter-cell-types)
	(markdown-ts--table-delimiter-cell-subtypes): New constants for
	pipe table node type classification.
	(markdown-ts--make-link-button): New function to create
	clickable link buttons with mailto, browse-url, and find-file
	dispatch.
	(markdown-ts--fontify-link-destination): New fontifier that
	hides link destinations when markup is hidden.
	(markdown-ts--link-ref-cache, markdown-ts--link-ref-cache-tick)
	(markdown-ts--link-ref-definitions)
	(markdown-ts--resolve-link-ref): New link reference definition
	cache with case-insensitive matching per CommonMark spec.
	(markdown-ts--fontify-link-node): New fontifier for inline,
	reference, shortcut, and collapsed links as clickable buttons.
	(markdown-ts--fontify-autolink): New fontifier for URI and email
	autolinks with angle bracket hiding.
	(markdown-ts--fontify-link-ref-label)
	(markdown-ts--fontify-link-ref-destination): New fontifiers for
	link reference definitions.
	(markdown-ts--slug-github-strip-re, markdown-ts--slug-github)
	(markdown-ts--slug-pandoc, markdown-ts--explicit-id-re)
	(markdown-ts--heading-text-and-id)
	(markdown-ts--heading-id-cache)
	(markdown-ts--heading-id-cache-tick)
	(markdown-ts--build-heading-ids, markdown-ts--heading-ids)
	(markdown-ts--follow-fragment): New fragment link support with
	GitHub and Pandoc slug algorithms.
	(markdown-ts--latex-block-valid-p)
	(markdown-ts--fontify-latex-block): New LaTeX/math fontifier
	with cross-paragraph validation.
	(markdown-ts--fontify-backslash-escape): New fontifier that
	hides backslash in escapes except inside LaTeX blocks.
	(markdown-ts--decode-entity, markdown-ts--fontify-entity): New
	HTML entity decoder and fontifier using org-entities and
	sgml-char-names with display property for decoded values.
	(markdown-ts--fontify-checkbox): New fontifier showing the
	configured checkbox glyph when markup is hidden.
	(markdown-ts--fontify-hard-line-break): New fontifier for
	'hard_line_break' nodes.
	(markdown-ts--fontify-heading): New fontifier for ATX and Setext
	headings.
	(markdown-ts--fontify-thematic-break): New fontifier showing
	horizontal line when markup is hidden.
	(markdown-ts--fontify-code-block): New fontifier applying
	background overlay to code blocks with language and mode
	properties.
	(markdown-ts-at-code-block-p)
	(markdown-ts-code-block-language-at)
	(markdown-ts-code-block-mode-at): New accessors for code block
	overlay properties.
	(markdown-ts--imenu-code-block-node-p): New helper for imenu
	code block detection.
	(markdown-ts--image-alone-on-line-p)
	(markdown-ts--fontify-image): New inline image display with
	standalone and inline positioning.
	(markdown-ts--bare-url-regexp)
	(markdown-ts--bare-email-uri-regexp)
	(markdown-ts--fontify-bare-uri): New bare URL/email
	fontification via jit-lock using goto-addr regexps.
	(markdown-ts--treesit-settings): Rewrite with dedicated faces,
	custom fontifiers, and new font-lock features for all inline and
	block elements.  Also add a new 'error' font-lock feature
	highlighting tree-sitter ERROR nodes.
	(markdown-ts--code-block-languages)
	(markdown-ts--code-block-non-ts-modes): New buffer-local alists
	for code block language tracking.
	(markdown-ts--harvest-mode-treesit-configuration): Rename from
	markdown-ts--harvest-treesit-configs with delay-mode-hooks.
	(markdown-ts--configure-current-buffer): Rename from
	markdown-ts--add-config-for-mode.
	(markdown-ts--language-at-node): New helper extracting language
	symbol from code_fence_content node.
	(markdown-ts--non-ts-fontify-cache): New buffer-local hash table
	caching fontification results for non-tree-sitter code blocks.
	(markdown-ts--fontify-non-ts-collect-faces): New function
	harvesting face properties from a mode in an indirect or
	temporary buffer.
	(markdown-ts--fontify-non-ts-code-block): New fontifier for
	non-tree-sitter modes via temporary buffer font-lock.
	(markdown-ts--code-block-language-mode): New function with
	heuristic mode name probing.
	(markdown-ts--code-block-ts-language): Rename from
	markdown-ts--convert-code-block-language with support for non-ts
	modes and recursive markdown handling.
	(markdown-ts-code-block-commands)
	(markdown-ts-code-block-thing-commands)
	(markdown-ts-code-block-region-commands): New command lists for
	code-block context execution.
	(markdown-ts--enable-code-block-in-context-mode)
	(markdown-ts--maybe-run-command-in-code-block)
	(markdown-ts--code-block-xref-find-definitions)
	(markdown-ts--run-command-in-code-block): New code block minor
	mode with temp-buffer command dispatch.
	(markdown-ts--code-block-newline): New command for newline
	inside code blocks, dispatching to the block's mode.
	(markdown-ts--range-settings): Update range configuration;
	remove :range-fn treesit-range-fn-exclude-children.
	(markdown-ts--remove-image-overlays)
	(markdown-ts--outline-view-change): New helpers for image
	overlay management during outline fold/unfold.
	(markdown-ts--outline-invisible-p): New helper testing whether a
	position is inside an outline-folded region.
	(markdown-ts--host-ranges-notifier): New function pruning stale
	code block overlays when the host parse tree changes.
	(markdown-ts--barf-if-not-mode): New helper signaling a
	user-error when the current buffer is not derived from
	markdown-ts-mode.
	(markdown-ts-code-block-in-context-mode): New minor mode enabled
	when point is within a fenced code block, activating
	markdown-ts-code-block-in-context-mode-map so eligible commands
	dispatch to the block's major mode.
	(markdown-ts--set-hide-markup): Clear image overlays when
	toggling markup visibility.
	(markdown-ts--set-inline-images)
	(markdown-ts-toggle-inline-images): New functions for toggling
	inline image display.
	(markdown-ts--parser-heading-max-level): New constant.
	(markdown-ts--heading-at-point, markdown-ts--heading-level)
	(markdown-ts--section-at-point): New heading navigation helpers.
	(markdown-ts-promote, markdown-ts-demote): New commands for
	heading and list item promotion/demotion with region support.
	(markdown-ts--promote-or-demote)
	(markdown-ts--promote-or-demote-region): New heading level
	adjustment functions.
	(markdown-ts-move-subtree-up, markdown-ts-move-subtree-down):
	New commands for moving sections and list items.
	(markdown-ts--section-folded-p)
	(markdown-ts--move-subtree-up-or-down): New subtree move with
	folding state preservation.
	(markdown-ts-toggle-checkbox): New command to toggle task list
	checkboxes.
	(markdown-ts--list-item-at-point): New helper with block quote
	marker handling.
	(markdown-ts--list-marker-width, markdown-ts--list-item-region)
	(markdown-ts--list-ordered-item-p): New list item helpers.
	(markdown-ts--list-promote-or-demote): New function with ordered
	list nesting guard.
	(markdown-ts--list-node-bol, markdown-ts--list-move): New list
	item movement functions.
	(markdown-ts-renumber-list): New command for sequential list
	renumbering with prefix argument support.
	(markdown-ts--list-item-new-marker)
	(markdown-ts--new-marker-for-line): New marker string generators
	for list item insertion.
	(markdown-ts--line-block-quote-depth): New helper counting block
	quote depth.
	(markdown-ts-newline): New RET command for context-aware
	newline.
	(markdown-ts-insert-list-item): New M-RET command that creates a
	new list item.
	(markdown-ts--fill-unfillable-block-query): New tree-sitter
	query for unfillable blocks.
	(markdown-ts--list-item-text-column): New helper for list item
	text alignment.
	(markdown-ts--fill-list-item): New function filling within list
	items without merging adjacent items.
	(markdown-ts--adaptive-fill): New adaptive fill function for
	list item continuation.
	(markdown-ts--fill-forward-paragraph): New paragraph motion
	respecting list items and unfillable blocks.
	(markdown-ts-fill-paragraph): New fill-paragraph-function with
	cond* dispatch for lists, block quotes, HTML comments, and
	unfillable blocks.
	(markdown-ts--fill-html-comment): New HTML comment filler with
	continuation alignment.
	(markdown-ts--block-quote-prefix): New helper preserving
	existing block quote marker style.
	(markdown-ts--fill-block-quote): New block quote filler with
	list item text column alignment.
	(markdown-ts-emphasis-alist): New alist of emphasis markers.
	(markdown-ts--emphasis-node-at-point): New tree-sitter based
	emphasis detection.
	(markdown-ts-remove-emphasis): New command removing emphasis at
	point or region.
	(markdown-ts-emphasize): New interactive emphasis insertion with
	region wrapping and word-at-point support.
	(markdown-ts-insert-structure): New command for inserting code
	blocks, block quotes, and dividers.
	(markdown-ts--insert-code-block): New function with language
	completion from known modes.
	(markdown-ts--insert-block-quote): New function with region
	wrapping.
	(markdown-ts--insert-divider): New function for horizontal
	rules.
	(markdown-ts--apply-ellipsis): New function applying custom
	ellipsis via display table.
	(markdown-ts--set-up): Rename from markdown-ts-setup.
	(markdown-ts-outline-cycle): New TAB command cycling outline
	visibility on headings.
	(markdown-ts-mode-map): New keymap for code block navigation,
	bindings for heading navigation, structure editing, emphasis,
	and list operations.
	(markdown-ts-code-block-in-context-mode-map): New keymap for
	code block context.
	(markdown-ts-mode-menu): New menu bar with Show/Hide, Navigate
	Headings, Edit Structure, and Editing sections.
	(markdown-ts-mode): Add outline-minor-mode, ellipsis, folding,
	fill-paragraph integration, code-block-context-mode hooks,
	comment settings, and outline-view-change-hook.  Use
	markdown-ts-mode directly in auto-mode-alist instead of
	markdown-ts-mode-maybe.
	(markdown-ts-mode-install-parsers): New command for installing
	required and optional tree-sitter language grammars.
	(markdown-ts-code-block-context-mode): New minor mode for code
	block context.
	(markdown-ts--find-code-block-delimiter)
	(markdown-ts--find-next-code-block-delimiter): New helpers for
	locating fenced code block delimiter nodes.
	(markdown-ts-move-to-next-code-block)
	(markdown-ts-move-to-previous-code-block): New commands for
	navigating between fenced code blocks.
	(markdown-ts--table-abutting-pos, markdown-ts--table-node-cell)
	(markdown-ts--table-node-row, markdown-ts--table-parse-error-p):
	New pipe table node helpers.
	(markdown-ts-at-table-p): New predicate returning non-nil when
	point is at or within a pipe table.
	(markdown-ts--enable-in-table-mode): New helper enabling
	markdown-ts-in-table-mode from post-command-hook.
	(markdown-ts--table-body-row-near-pos): New helper locating the
	nearest body row to a position.
	(markdown-ts--table-compute-node-column)
	(markdown-ts-table--goto-column): New helpers for column-based
	table navigation.
	(markdown-ts--table-aligners, markdown-ts--table-make-aligner)
	(markdown-ts--table-align-cell): New table cell alignment
	helpers.
	(markdown-ts-table-insert-table): New command to insert a pipe
	table with configurable rows and columns.
	(markdown-ts-table-delete-table): New command to delete the pipe
	table at point.
	(markdown-ts-table-previous-row, markdown-ts-table-next-row)
	(markdown-ts-table-previous-cell, markdown-ts-table-next-cell):
	New commands for navigating table rows and cells.
	(markdown-ts-table-insert-row-below)
	(markdown-ts-table-insert-row-above)
	(markdown-ts-table-clone-row-below)
	(markdown-ts-table-clone-row-above)
	(markdown-ts-table-insert-row): New commands for inserting and
	cloning table rows.
	(markdown-ts-table-delete-row, markdown-ts-table-move-row-up)
	(markdown-ts-table-move-row-down, markdown-ts-table-move-row):
	New commands for deleting and moving table rows.
	(markdown-ts-table-insert-column-left)
	(markdown-ts-table-insert-column-right)
	(markdown-ts-table-clone-column-left)
	(markdown-ts-table-clone-column-right)
	(markdown-ts-table-insert-column): New commands for inserting
	and cloning table columns.
	(markdown-ts-table-delete-column)
	(markdown-ts-table-move-column-left)
	(markdown-ts-table-move-column-right)
	(markdown-ts-table-move-column): New commands for deleting and
	moving table columns.
	(markdown-ts-table-align-column-left)
	(markdown-ts-table-align-column-center)
	(markdown-ts-table-align-column-right)
	(markdown-ts-table-align-column): New commands for setting
	column alignment.
	(markdown-ts-table-align-table): New command to align all
	columns in the table at point.
	(markdown-ts-table-transpose-table): New command to transpose
	the table at point.
	(markdown-ts-table-convert-csv-region)
	(markdown-ts-table-convert-tsv-region)
	(markdown-ts-table-convert-region): New commands to convert
	delimited text regions to pipe tables.
	(markdown-ts-table-export-table-csv)
	(markdown-ts-table-export-table-tsv)
	(markdown-ts-table-export-table): New commands to export the
	pipe table at point to CSV or TSV format.
	(markdown-ts-in-table-mode-map): New keymap for
	markdown-ts-in-table-mode.
	(markdown-ts--code-block-in-context-mode-ov): New buffer-local
	variable for code block context overlay.
	(markdown-ts--code-block-in-context-mode-update-ov): New
	function updating the code block context overlay.
	(markdown-ts-in-table-mode): New minor mode enabled when point
	is within a pipe table, activating markdown-ts-in-table-mode-map.
	(markdown-ts--in-table-mode-ov)
	(markdown-ts--in-table-mode-get-ov)
	(markdown-ts--table-tick-update)
	(markdown-ts--table-tick-stale-p)
	(markdown-ts--in-table-mode-update-ov): New helpers supporting
	markdown-ts-in-table-mode overlay management.
	(markdown-ts-table-mode): New minor mode providing table editing
	commands and auto-alignment.
	(markdown-ts-mode-maybe): Remove; auto-mode-alist now uses
	markdown-ts-mode directly.
	Auto-mode-alist: Add .markdown and .mdx extensions.

	* lisp/textmodes/markdown-ts-mode-x.el: New file providing extra
	features for markdown-ts-mode.
	(markdown-ts-commonmark-spec-url, markdown-ts-gfm-spec-url): New
	constants for CommonMark and GFM specification URLs.
	(markdown-ts-browse-commonmark-spec)
	(markdown-ts-browse-gfm-spec): New commands to browse the
	CommonMark and GFM specifications.
	(markdown-ts-convert): New customization group for Markdown
	conversion/export features.
	(markdown-ts-default-converter): New option to set the default
	format and converter for Markdown export.
	(markdown-ts-convert-display-function): New option specifying
	the function used to display converted output.
	(markdown-ts-converters): New variable listing format/converter
	configurations for pandoc, cmark, cmark-gfm, markdown, and
	markdown.pl.
	(markdown-ts-convert-file, markdown-ts-convert): New commands to
	convert Markdown buffers or files to HTML, PDF, and other
	formats via external converters.
	(markdown-ts-toc): New customization group for table of contents
	features.
	(markdown-ts-toc-generate-warn-if-none): New option controlling
	behavior when no TOC is found during generation.
	(markdown-ts-toc-update-before-save-mode-lighter): New option
	for the before-save TOC update minor mode lighter string.
	(markdown-ts-toc-slug-function): New option to select the slug
	algorithm used for TOC heading anchors.
	(markdown-ts--toc-handles, markdown-ts--toc-handle-classes): New
	variables defining TOC handle types and classes.
	(markdown-ts--toc-expand-candidate-handles, markdown-ts--tocs)
	(markdown-ts--tocs-sanity-check)
	(markdown-ts--toc-collect-candidates)
	(markdown-ts--toc-list-item-depth)
	(markdown-ts--toc-atx_header-normalize)
	(markdown-ts--toc-text-normalizers)
	(markdown-ts--toc-text-normalize): New internal helpers for TOC
	parsing and text normalization.
	(markdown-ts-toc-update-before-save-mode): New minor mode that
	regenerates tables of contents before saving.
	(markdown-ts-toc-clear-and-remove, markdown-ts-toc-clear): New
	commands to remove or clear TOC bodies.
	(markdown-ts-toc-insert-template): New command to insert a TOC
	template at point.
	(markdown-ts-toc-generate): New command to generate tables of
	contents in the current buffer.

	Includes fixes for: (bug#80613) (bug#80625) (bug#80690)

2026-05-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	nadvice.el: Make it easier to find how to change an interactive-form

	* lisp/emacs-lisp/nadvice.el (advice--how-alist): Add ':interactive-only'.
	* doc/lispref/functions.texi (Advice Combinators): Document it.
	(Core Advising Primitives): Use it.

2026-05-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/emacs-lisp/lisp-mode.el (lisp-fdefs): Avoid obsolete "face vars"

2026-05-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	keyboard.c: Allow SIGINT to `quit` in batch mode, instead of exit

	In terminal sessions, SIGINT is turned into a `quit` ELisp signal,
	but in batch it has traditionally killed Emacs.  It can be very
	useful to cause a `quit` from outside the process when running
	in batch (e.g. for "batch" sessions that provide a REPL via stdin/out),
	so add a new var 'kill-emacs-on-sigint' to control that behavior.
	(bug#80942)

	* src/keyboard.c (handle_interrupt_signal): Obey `kill_emacs_on_sigint`.
	(init_keyboard): Use `deliver_interrupt_signal` for SIGINT also for
	batch sessions.
	(syms_of_keyboard): New variable `kill_emacs_on_sigint`.

	* test/src/keyboard-tests.el (keyboard-sigint-to-quit): New test.

	* doc/emacs/cmdargs.texi (Initial Options): Mention the effect of
	`kill-emacs-on-sigint` in batch mode.

2026-05-04  Michael Albinus  <michael.albinus@gmx.de>

	Adaot tramp-tests.el

	* test/lisp/net/tramp-tests.el (ert-remote-temporary-file-directory):
	Ensure that it is expanded.

2026-05-04  Michael Albinus  <michael.albinus@gmx.de>

	* admin/notes/documentation: Recommend not using "it's".

2026-05-04  João Távora  <joaotavora@gmail.com>

	Jsonrpc: add new tests using Python subprocesses

	Most of these tests are for the scontrol/"anxious continuation"
	mechanism (bug#80623)

	The new ERT tests use Python subprocesses via stdin/stdout pipe as
	JSONRPC endpoints.  A shared framing library lives in
	jsonrpc-resources/common.py.

	* test/lisp/jsonrpc-tests.el (jsonrpc--test-dir): New constant.
	(jsonrpc--with-python-fixture): New macro.
	(scontrol-remote-during-sync-1)
	(scontrol-remote-during-sync-2)
	(scontrol-anxious-nested)
	(scontrol-remote-error)
	(shutdown-clean-after-notification): New tests.

	* test/lisp/jsonrpc-resources/common.py: New file.

	* test/lisp/jsonrpc-resources/server-remote-during-sync-1.py: New file.

	* test/lisp/jsonrpc-resources/server-remote-during-sync-2.py: New file.

	* test/lisp/jsonrpc-resources/server-anxious-nested.py: New file.

	* test/lisp/jsonrpc-resources/server-remote-error.py: New file.

	* test/lisp/jsonrpc-resources/server-harakiri.py: New file.

2026-05-04  João Távora  <joaotavora@gmail.com>

	Jsonrpc: rework sync request handling (bug#80623)

	When the remote endpoint is handling a local request 'LR' it can
	sometimes make a remote sync request 'RR' as part of its handling.  Some
	endpoints (like Go's gopls) wait for Emacs's reply to 'RR' before
	responding to 'LR'.  Others (like Julia's JETLS) respond to 'LR'
	immediately, and only then wait for Emacs's reply to 'RR'.  Both
	approaches are valid.  However, in the latter case, the handling of 'RR'
	(which could well be waiting for user input from the minibuffer to
	complete) is vulnerable to 'throw' from process filters handling (which
	is just what happens when the endpoints replies to 'LR'), so if that
	happens it will unexpectedly be aborted when the reply to 'LR' comes in,
	suprising the user and causing a spurious -32603 reply to be sent.

	To solve this problem, this commit first refactors the sync
	request/anxious queue handling and replace plain integer keys of the
	rebaptized "scontrol" alist with structured (:local ID) / (:remote ID)
	pairs, using `equal' for comparisons.  This is to introduce some
	clarity/sanity into this somewhat hairy code.

	Then, the 'RR' situation is fixed: we push a (:remote ID) entry onto the
	top of the 'jsonrpc-connection--control' stack and only then call
	rdispatcher.  Any 'LR' reply arriving during dispatch is deferred as an
	"anxious" continuation rather than firing its `throw' immediately.  When
	rdispatcher is done, we call jsonrpc--continue at a safe point, this
	will run any "anxious" continuations.

	* lisp/jsonrpc.el (jsonrpc-connection): Rename -sync-request-alist to
	-scontrol; accessor from jsonrpc--sync-request-alist to
	jsonrpc--scontrol; update docstring for new key structure.

	(jsonrpc-connection-receive): Update with-slots binding to scontrol.
	Tighten anxious check to match (:local ID) keys with `equal'.  In
	remote-request branch, push (:remote ID) entry before rdispatcher and
	call jsonrpc--continue after jsonrpc--reply.

	(jsonrpc-request): Pass (:local ID) to jsonrpc--continue.

	(jsonrpc--continue): Use jsonrpc--scontrol; change `=' to `equal' in
	sanity check.
	p
	(jsonrpc--async-request-1): Push (:local ID) entry.

	(jsonrpc--log-event): Use jsonrpc--scontrol.

2026-05-04  Dmitry Gutov  <dmitry@gutov.dev>

	Re-add a call to clear_under_internal_border in clear_garbaged_frames

	* src/xdisp.c (clear_garbaged_frames): Re-add the call to
	clear_under_internal_border, reverting that part of commit
	a6a3b32208c5 as not essential to the fix (bug#80662).

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Ensure package archives are loaded for 'package-isolate'

	* lisp/emacs-lisp/package.el (package-isolate): Use
	'package--archive-contents' instead of the actual variable, to
	ensure that we load the archive contents if missing.  This is
	likely the case if 'package-isolate' is the first package
	function invoked during a session.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Add for <picture> to 'html-tag-alist' and 'html-tag-help'

	* lisp/textmodes/sgml-mode.el (html-tag-alist): Add very basic skeleton.
	(html-tag-help): Add description.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Add for <details> to 'html-tag-alist' and 'html-tag-help'

	* lisp/textmodes/sgml-mode.el (html-tag-alist): Add skeleton.
	(html-tag-help): Add description.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Prevent indentation within whitespace sensitive HTML tags

	* lisp/textmodes/sgml-mode.el (sgml-whitespace-sensitive-tags):
	Add new variable.
	(sgml-calculate-indent): Check if in the context of a tag
	specified by 'sgml-whitespace-sensitive-tags'.
	(html-mode): Set 'sgml-whitespace-sensitive-tags' to not adjust
	the indentation within <pre> and <textarea> tags.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Use 'read-shell-command' to read SGML validation command

	* lisp/textmodes/sgml-mode.el (sgml-validate): Update
	interactive spec.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Raise an error if 'sgml-validate-command' is not configured

	* lisp/textmodes/sgml-mode.el (sgml-validate-command): If no
	known program is installed, fall back to nil as the default
	value instead of a warning message.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Implement 'sgml-name-8bit-mode' as a proper minor mode

	* lisp/textmodes/sgml-mode.el (sgml-name-8bit-mode): Merge
	'defcustom' and 'defun' into a 'define-minor-mode'.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Refine SGML offset user option types

	* lisp/textmodes/sgml-mode.el (sgml-basic-offset)
	(sgml-attribute-offset): Allow natural numbers, not arbitrary
	integers.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Allow setting 'sgml-xml-mode' buffer locally

	* lisp/textmodes/sgml-mode.el (sgml-xml-mode): Add :safe property.

2026-05-03  Philip Kaludercic  <philipk@posteo.net>

	Allow changing SGML "quick keys" after loading sgml-mode.el

	* lisp/textmodes/sgml-mode.el (sgml-quick-keys): Replace with
	user option, that adjusts 'sgml-mode-map'.
	(sgml-mode-map): Don't insert quick keys.
	(html-quick-keys): Replace with user option, that adjusts
	'html-mode-map'.
	(html-mode-map): Don't insert quick keys.

2026-05-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	(package--builtin-alist): Don't use `defconst` since we later change it

	* lisp/emacs-lisp/package.el (package--builtin-alist): Use `defvar`.

2026-05-03  Juri Linkov  <juri@linkov.net>

	* lisp/treesit.el (treesit-outline-level): Add guard condition.

2026-05-03  Manuel Giraud  <manuel@ledu-giraud.fr>

	Gnus logo in server buffer's mode line (bug#80850)

	* lisp/gnus/gnus-srvr.el (gnus-server-mode): Initialize needed
	format specifications and call 'gnus-set-mode-line' for the
	server buffer.
	* lisp/gnus/gnus-sum.el (gnus-set-mode-line): Handle when WHERE
	is set to 'server.
	* lisp/gnus/gnus.el (gnus-updated-mode-lines): Add server.

2026-05-02  Eshel Yaron  <me@eshelyaron.com>

	Remove 'completion-preview--is-calling'

	We decided to leave it out for now, see discussion at
	https://yhetil.org/emacs/jwvqzntzvvg.fsf-monnier+emacs@gnu.org/
	This brings completion-preview.el back to how it were before
	commit a24ff52a79b.

	* lisp/completion-preview.el (completion-preview--is-calling):
	Delete.
	(completion-preview--capf-wrapper): Adapt.

2026-05-02  Stephen Berman  <stephen.berman@gmx.net>

	Fix 'vc-dir-resynch-file' (bug#80803)

	* lisp/vc/vc-dir.el (vc-dir-resynch-file): Apply 'file-truename'
	instead of 'expand-file-name' to FNAME argument to prevent
	spurious display of symlinked files in *vc-dir* buffer.

2026-05-02  Eshel Yaron  <me@eshelyaron.com>

	Demote 'completion-preview-is-calling'

	See discussion at
	https://yhetil.org/emacs/87pl3egzww.fsf@mail.eshelyaron.com/

	* lisp/completion-preview.el (completion-preview-is-calling):
	Rename to...
	(completion-preview--is-calling): ...this.
	(completion-preview--capf-wrapper): Update accordingly.
	* etc/NEWS: Remove announcement.

2026-05-02  João Távora  <joaotavora@gmail.com>

	Eglot: find well behaved UTF char for code actions (bug#80326)

	* lisp/progmodes/eglot.el (eglot-code-action-indicator): No lighbulb, no
	fancy lightning bolt, just use zigzags which seem to display well on
	typical fonts and typically have a width of 1.

2026-05-02  Sean Whitton  <spwhitton@spwhitton.name>

	Project prompters always default to current project, if any

	* lisp/progmodes/project.el (project-prompter)
	(project-prompt-project-dir, project-prompt-project-name):
	Delete ALLOW-EMPTY parameter.  Default to the current project if
	there is one.
	* lisp/vc/vc.el (project-root): Declare.
	(vc--prompt-other-working-tree): Replace ALLOW-EMPTY parameter
	with new ALLOW-CURRENT parameter.
	(vc-working-tree-switch-project): Allow selecting the current
	working tree, for symmetry with project-switch-project.
	* etc/NEWS: Update.

2026-05-02  Philip Kaludercic  <philipk@posteo.net>

	Mark myself as maintainer of sgml-mode

	* admin/MAINTAINERS: Update my entry.
	* lisp/textmodes/sgml-mode.el: Update "Maintainer" header.

2026-05-02  Philip Kaludercic  <philipk@posteo.net>

	Don't break line when inserting <code> tags

	* lisp/textmodes/sgml-mode.el (html-tag-alist): Remove '\n' from
	the completion rules for "code" tag.  (Bug#80771)

2026-05-02  Philip Kaludercic  <philipk@posteo.net>

	* etc/themes/newcomers-presets-theme.el: Fix checkdoc issue

2026-05-02  Eli Zaretskii  <eliz@gnu.org>

	* src/.gdbinit: Ignore SIGPIPE.  (Bug#80911)

2026-05-02  Paul Eggert  <eggert@cs.ucla.edu>

	Work around GCC bug 125116

	* configure.ac: When configured with --enable-gcc-warnings,
	use the -Wno-analyzer-allocation-size option if available.
	This works around a false positive bug in
	GCC 16.0.1 20260321 (Red Hat 16.0.1-0) x86-64; see
	<https://gcc.gnu.org/bugzilla/show_bug.cgi?id=125116>.

2026-05-01  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.13.2-10-gf7894ca4

	Update to Transient v0.13.1-10-gc168d396

2026-05-01  Dmitry Gutov  <dmitry@gutov.dev>

	Resize child frames with GTK3 immediately too

	* src/gtkutil.c (xg_frame_set_char_size): Resize child frame and
	its GTK widget hierarchy immediately.  Update the "desired" Cairo
	surface dimensions.  Skip waiting for events. (bug#80662)
	Remove the unnecessary call to clear_under_internal_border.

2026-05-01  Dmitry Gutov  <dmitry@gutov.dev>

	Simplify the fullscreen adjustment in xg_frame_set_char_size

	* src/gtkutil.c (xg_frame_set_char_size): Simplify.  Use the
	fullscreen value check to alter the values of outer_width and
	outer_height rather than have several larger branches (bug#80662).

2026-05-01  Dmitry Gutov  <dmitry@gutov.dev>

	Remove the effect of x_gtk_resize_child_frames=hide

	* src/gtkutil.c (xg_frame_set_char_size): Remove the effect of
	x_gtk_resize_child_frames, effectively reverting that part of
	c49d379f17bc (bug#80662).

	* src/pgtkfns.c (syms_of_pgtkfns): Remove defsyms Qhide and
	Qresize_mode, never used with PGTK.

	* src/xfns.c (x-gtk-resize-child-frames): Update docstring.

2026-05-01  Dmitry Gutov  <dmitry@gutov.dev>

	Don't wait out the whole event timeout unnecessarily

	* src/xterm.c (x_wait_for_event): If f->wait_event_type has been
	cleared (in handle_one_xevent), don't go into pselect wait.

	* src/androidterm.c (android_wait_for_event): Likewise.

2026-05-01  Dmitry Gutov  <dmitry@gutov.dev>

	Try to resize or resize-and-move child frames in one update

	This pertains to X11 toolkit builds.  Other ports (including
	PGTK) seem to have mostly atomic window updates already.

	* src/xterm.c (x_set_window_size_1): Resize the Xt widget eagerly,
	so the next redraw is not clipped.  Update the "desired" Cairo
	surface dimensions.  Skip waiting for next XEvent.  Do all that
	for child frames only.  Update old comments (bug#80662).
	(x_set_window_size_and_position_1): Same.  Also clear the widget's
	cached position coordinates (we don't keep them up to date).
	(x_set_window_size, x_set_window_size_and_position): Skip
	redrawing the border on child frames, it will happen during
	redisplay anyway.

	* src/gtkutil.c (xg_frame_set_size_and_position): On child
	frames, resize the GTK widget hierarchy immediately.  Update the
	"desired" Cairo surface dimensions.  Skip waiting for events.

	* src/widget.c (EmacsFrameResize):
	When resize should be a no-op, exit early (minor optimization).
	(EmacsFrameExpose): Redraw the border on the last Expose event.

	* src/xdisp.c (clear_garbaged_frames): Don't redraw borders here.

	* src/xfns.c (x_window): Undo the previous change in bit_gravity
	in the no-toolkit build.  StaticGravity works the best for it
	thanks to no nesting in window configuration.

2026-05-01  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify GCC 16.0.1 -Wanalyzer-null-dereference in xdisp.c

	* src/xdisp.c (glyph_string_containing_background_width):
	Although it’s not immediately obvious whether the GCC 16 warning
	is valid, adding an eassume here shouldn’t hurt.

2026-04-30  F. Jason Park  <jp@neverwas.me>

	Only perform erc-log-insert-log-on-open setup once

	* etc/ERC-NEWS: Add entry for option `erc-log-insert-log-on-open'.
	Mention deprecation of `erc-log-setup-logging'.
	* lisp/erc/erc-log.el (erc-log-insert-log-on-open): Expand type from
	boolean to choice of boolean, predicate, and new function item
	`erc-log-new-target-buffer-p'.
	(erc-log-mode, erc-log-enable, erc-log-disable): Replace
	`erc-log-setup-logging' on `erc-connect-pre-hook' with
	`erc-log--insert-log-on-open' at depth 80.  Replace calls to
	`erc-log-setup-logging' with ones to `erc-log--setup'.
	(erc-log-new-target-buffer-p): New function.  While the name could
	perhaps do more to indicate that it's only useful when called from
	`erc-open', that's the only place ERC typically sets up new target
	buffers.
	(erc-log-setup-logging): Deprecate and replace body with adapter that
	calls `erc-log--setup' and `erc-log--insert-log-on-open'.
	(erc-log--setup): New function whose body is mostly from the
	"nondestructive" portion of `erc-log-setup-logging'.  Instead of moving
	the `erc-saved-last-position' marker to the old value, expect it not to
	have been initialized by `erc-initialize-log-marker' because
	`erc-connect-pre-hook' now runs after this code, which is now
	incorporated more judiciously into the module's "enable body".
	(erc-log--insert-log-on-open): New function whose body is mostly from
	the "destructive" portion of the previous incarnation of
	`erc-log-setup-logging'.  Unlike the original, if option
	`erc-log-insert-log-on-open' is a function, call it to decide whether to
	insert a log file atop its buffer.  Also, don't advance the marker
	`erc-last-saved-position' to the prompt area, where it can get stuck and
	prevent logs from being saved when `erc-log-insert-log-on-open' is
	non-nil.  Thanks to Libera user Lionyx for reporting the bug, which has
	been around since at least ERC 5.4 and Emacs 28.1.
	(erc-log-disable-logging): Remove `erc-save-buffer-in-logs' from
	`write-file-functions' to undo its buffer-local addition in what is now
	`erc--log-setup'.
	* test/lisp/erc/erc-scenarios-log-options.el: New file.  (Bug#79665)

2026-04-30  F. Jason Park  <jp@neverwas.me>

	Restore erc-last-saved-position from previous session

	* lisp/erc/erc-log.el (erc-log-setup-logging): Restore
	`erc-last-saved-position' from previous session.  By default, a
	non-/QUIT disconnect does not write out any remaining buffer text to
	logs, instead leaving it until the buffer or Emacs is killed.  But if a
	successful reconnect occurs beforehand, the uncommitted portion must be
	seen to somehow.  Before this change, it would be lost because the
	function `erc-initialize-log-marker' remakes the marker at the prompt
	instead of recovering the previous value as now done here.  Moreover,
	the traditional workaround of customizing `erc-log-write-after-insert'
	and `erc-log-write-after-send' to t should not be required to prevent
	gaps in any decent IRC client.
	* test/lisp/erc/erc-scenarios-log.el (erc-scenarios-log--reconnect): New
	function.
	(erc-scenarios-log--reconnect/auto, erc-scenarios-log--reconnect/manual):
	New tests.
	;; * test/lisp/erc/resources/join/reconnect/foonet-again.eld: Add QUIT.

2026-04-30  F. Jason Park  <jp@neverwas.me>

	Define variable alias for erc-completion-mode

	* lisp/erc/erc-pcomplete.el (erc-completion-mode): New alias for the
	variable `erc-pcomplete-mode' to complement the function alias of the
	corresponding minor-mode command.  Given that user code operating on the
	value of `erc-modules' needs to detect whether members are active, it
	only makes sense to address this specially.  Before this change,
	applying `bound-and-true-p' to `erc-completion-mode' would always return
	nil, even when the module was active.  For normal aliases, that's indeed
	expected because `define-erc-module' doesn't automatically define a mode
	variable for a non-nil ALIAS argument.  Although in the long term it
	probably should, while also obsoleting the "new" alias simultaneously,
	that would likely break some user code and doubtless complicate things
	majorly for `pcomplete', the one in-tree outlier.  The latter module
	would then require changing either its preferred name, the one
	advertised by `erc-modules' in its Custom definition, to `pcomplete' or
	its primary name to `completion'.  Both are quite churn-inducing.

2026-04-30  Eshel Yaron  <me@eshelyaron.com>

	New variable 'completion-preview-is-calling'

	* lisp/completion-preview.el (completion-preview-is-calling):
	New variable.
	(completion-preview--capf-wrapper): Bind it to t when calling
	the CAPF.
	* etc/NEWS: Announce it.

2026-04-30  Michael Albinus  <michael.albinus@gmx.de>

	Precise quoting of file names with a leading tilde

	* doc/emacs/files.texi (File Names, Quoted File Names):
	Precise quoting of file names with a leading tilde.

2026-04-30  Eli Zaretskii  <eliz@gnu.org>

	Fix value of 'default-line-height'

	* lisp/simple.el (default-line-height): Fix use of buffer-local
	value of 'line-spacing'.  (Bug#80929)

2026-04-30  Randy Taylor  <dev@rjt.dev>

	Always compile w32image.c on MinGW (Bug#80924)

	This enables features unrelated to native image APIs, such as
	'w32-export-frame' and 'yank-media', which need to call GDI+
	functions.
	* configure.ac (HAVE_W32) [!CYGWIN]: Always include w32image.o in
	W32_OBJ.
	* etc/NEWS: Drop 'yank-media' '--without-native-image-api' caveat.
	* src/emacs.c (main):
	* src/w32select.c (convert_dibv5_to_png):
	* src/w32term.c (w32_draw_image_foreground): Replace
	HAVE_NATIVE_IMAGE_API with WINDOWSNT.
	* src/w32.c (term_ntproc): Remove redundant HAVE_NATIVE_IMAGE_API guard.
	* src/w32fns.c (Fw32_export_frame) [!WINDOWSNT]: Return nil on Cygwin.

2026-04-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	(seq-concatenate): Fix docstring (bug#80810)

	* lisp/emacs-lisp/seq.el (seq-concatenate): Remove confusing
	`(fn TYPE SEQUENCE...)` which made `help-function-arglist`
	return less informative results and wasn't even consistent with
	the rest of the docstring.

	* lisp/emacs-lisp/shortdoc-doc.el (sequence): Revert last
	change, since it's now redundant.

2026-04-30  Sean Whitton  <spwhitton@spwhitton.name>

	cl-lambda-list, cl-lambda-list1: Fix &key spec

	* lisp/emacs-lisp/cl-macs.el (cl-lambda-list, cl-lambda-list1):
	Fix &key specification to support empty lists of keyword
	arguments (bug#80878).  Fix due to Thuna <thuna.cing@gmail.com>.

2026-04-30  Timon Reinold  <tirei+gn@agon.one>  (tiny change)

	eww-handle-link: Split HTML rel on spaces

	* lisp/net/eww.el (eww-handle-link): The HTML rel attribute's
	value is a space-separated set of keywords, so split it before
	matching against known keywords (bug#80816).

2026-04-30  Collin Funk  <collin.funk1@gmail.com>

	Pacify -Wunused-but-set-variable from gcc 16 and clang 13

	* src/coding.c: Remove file wide ignore pragma for
	-Wunused-but-set-variable.
	(detect_coding_XXX) <consumed_chars>: Mention that this variable might
	need to be declared with the MAYBE_UNUSED attribute.
	(detect_coding_utf_8, detect_coding_emacs_mule, detect_coding_iso_2022)
	(encode_designation_at_bol, detect_coding_sjis, detect_coding_big5)
	(detect_coding_ccl, detect_coding_charset) <consumed_chars>: Use the
	MAYBE_UNUSED attribute.

2026-04-30  Vladimir Kazanov  <vekazanov@gmail.com>

	Add ERT coverage for read_key_sequence behaviour

	* test/src/keyboard-tests.el
	(keyboard-tests--rks-fake-posn)
	(keyboard-tests--rks-observe)
	(keyboard-tests--rks-execute)
	(keyboard-tests--rks-with-function-key-bindings)
	(keyboard-tests--rks-with-event-kinds)
	(keyboard-tests--rks-call-with-live-window-maps): Test helpers.
	(keyboard-tests-rks-prefix-then-key)
	(keyboard-tests-rks-unbound-returns-sequence)
	(keyboard-tests-rks-bound-sequence-ends-read)
	(keyboard-tests-rks-decode-fires-without-binding)
	(keyboard-tests-rks-input-decode-map)
	(keyboard-tests-rks-function-key-map)
	(keyboard-tests-rks-function-key-map-on-undefined)
	(keyboard-tests-rks-key-translation-before-function-key)
	(keyboard-tests-rks-function-key-skipped-when-bound)
	(keyboard-tests-rks-input-decode-after-function-key)
	(keyboard-tests-rks-key-translation-overrides-bound-sequence)
	(keyboard-tests-rks-upcase-fallback)
	(keyboard-tests-rks-no-upcase-fallback)
	(keyboard-tests-rks-dont-downcase-last)
	(keyboard-tests-rks-shifted-function-key-fallback)
	(keyboard-tests-rks-switch-frame-delayed)
	(keyboard-tests-rks-unbound-down-mouse-dropped)
	(keyboard-tests-rks-mode-line-fake-prefix)
	(keyboard-tests-rks-mode-line-fake-prefix-continued)
	(keyboard-tests-rks-clicked-buffer-switch)
	(keyboard-tests-rks-help-char): Tests covering for read_key_sequence.

2026-04-30  Yuan Fu  <casouri@gmail.com>

	In tree-sitter, signal if predicate function causes reparse

	A reparse will make the TSTreeCursor or TSNode to possibly point
	to freed memory (because the TSTree they point to is freed.)

	* src/treesit.c (treesit_pred_with_guard): New function.
	(treesit_predicate_pred):
	(treesit_eval_predicates):
	(Ftreesit_query_capture):
	(treesit_traverse_match_predicate):
	(treesit_build_sparse_tree): Add guard that signals if buffer is
	changed when calling predicate function.
	(Qtreesit_buffer_changed): New symbol.

2026-04-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	(loaddefs-generate--make-autoload): Fix autoload for `emoji-insert`

	To decide if a `defalias` will define a command, we need to look inside
	the `lambda` and search for an interactive spec.  Until now we assumed
	`defalias`s argument would take the shape of `(function (lambda ...))`,
	which failed miserably for `transient-define-prefix` which
	macroexpands to `(defalias 'foo (lambda ...))` instead.
	So make sure we macroexpand the arg to turn the `(lambda ...)` into
	`(function (lambda ...))` before we try to dig into it.

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate--make-autoload):
	Macroexpand the `defalias` argument before checking if it's an
	interactive function.

2026-04-29  Daniel Colascione  <dancol@dancol.org>

	Make TS query cache work, grow less

	We were using the wrong key when inserting entries into
	treesit--query-cache, making the cache both ineffective and
	liable to grow without bound.  On very long sessions, the cache
	could end up using hundreds.

	* lisp/treesit.el (treesit--compile-query-with-cache): Use
	correct cache key.

2026-04-29  Roi Martin  <jroi.martin@gmail.com>

	Fix warning when building Calc manual

	These warnings are emitted at least by Texinfo 7.2.
	* doc/misc/calc.texi (Introduction): Conditionally set prev node to
	avoid warning.
	(Interactive Tutorial): Update chapter title to match node name and
	menu entry.
	(Top): Add description to `Interactive Tutorial' menu entry.
	(Bug#80923)

2026-04-29  Sean Whitton  <spwhitton@spwhitton.name>

	New VC commands for remote unintegrated changes

	* lisp/vc/vc.el (vc--outgoing-base, vc--outgoing-base-mergebase):
	New FORCE-TOPIC parameter.
	(vc--maybe-read-outgoing-base): New NO-DOUBLE parameter.
	(vc-root-diff-remote-unintegrated, vc-diff-remote-unintegrated)
	(vc-log-remote-unintegrated, vc-root-log-remote-unintegrated):
	New commands (bug#80434).
	* lisp/vc/vc-dir.el (vc-dir-mode-map):
	* lisp/vc/vc-hooks.el (vc-prefix-map): Bind them.
	* doc/emacs/vc1-xtra.texi (Unintegrated Changes):
	* etc/NEWS: Document them.

2026-04-29  Sean Whitton  <spwhitton@spwhitton.name>

	New commands to report diffs of all local changes

	* lisp/vc/vc.el (vc-root-diff-outgoing-and-edited)
	(vc-diff-outgoing-and-edited): New commands (bug#80434).
	* lisp/vc/vc-dir.el (vc-dir-mode-map):
	* lisp/vc/vc-hooks.el (vc-prefix-map): Bind them.
	* doc/emacs/maintaining.texi (VC Change Log):
	* etc/NEWS: Document them.

2026-04-29  João Távora  <joaotavora@gmail.com>

	In fido-vertical-mode, let C-s and C-r recover their original use

	Fido-mode is meant for ido-mode emulation, so it makes some
	sense C-r and C-s moves forward and backward in the list as
	ido-mode once did.  The price to pay is losing easy access to
	isearch-backward/forward in completions.  In fido-vertical-mode,
	this price is unreasonably high given C-p and C-n are the
	natural bindings for moving about in the vertical list.

	* lisp/icomplete.el (icomplete-fido-mode-map): Disable C-s and C-r
	in fido-vertical-mode.

2026-04-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/emacs-lisp/crm.el (crm-complete-and-exit): Simplify docstring

2026-04-28  Yuan Fu  <casouri@gmail.com>

	Use treesit-language-available-p for language check (bug#80909)

	* lisp/treesit.el (treesit-ensure-installed): Use
	treesit-language-available-p for checking if a language is
	installed.  treesit-ready-p also checks for buffer size, etc, so
	it's not the right check.

2026-04-28  Yuan Fu  <casouri@gmail.com>

	Better heuristic in treesit-font-lock-fontify-region in multi-parser

	* lisp/treesit.el (treesit-font-lock-fontify-region): Use
	primary parser.

2026-04-27  Jonas Bernoulli  <jonas@bernoul.li>

	Use plain autoload cookie with transient-define-prefix

	(emoji-search, emoji-list-select): Use plain autoload cookie with
	transient-define-prefix

2026-04-27  Jonas Bernoulli  <jonas@bernoul.li>

	Set indent property for with-connection-local-variables

	* lisp/files-x.el (with-connection-local-variables): Set indent
	property.

2026-04-27  Jonas Bernoulli  <jonas@bernoul.li>

	Fix defining a few faces as empty

	e72afa9dbf92f45 replaced nil, which is invalid as a face definition,
	with ((t (:inherit default))), but that does not actually result in
	an "empty" face, which doesn't set any attributes.  Instead it doubles
	down on all attributes set for the default face.  Replace that with
	((t)), which accomplishes what appears to have been the intention.

	* lisp/net/shr.el (shr-h4, shr-h5, shr-h6):
	* lisp/nxml/nxml-mode.el (nxml-text):
	* lisp/progmodes/make-mode.el (makefile-shell): Use empty face
	definition ((t)), instead of ((t (:inherit default))).

2026-04-27  Jonas Bernoulli  <jonas@bernoul.li>

	Call format-spec substitution functions in current buffer

	* lisp/format-spec.el (format-spec): Call format-spec substitution
	functions in current buffer.  I.e., in the same buffer in which
	substitution expressions are evaluated.  Previously functions were
	instead called in the temporary buffer used to deal with FORMAT.

2026-04-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	(completion--file-name-table): Improve completion of `/a/~b/c`

	The solution used is far from perfect, but hopefully it helps more
	often than it hurts.  And since it affects only completion, we hope
	the cases where it hurts won't be too serious.  (bug#32215)

	* lisp/minibuffer.el (completion--sifn-regardless-of-system-users):
	New function.
	(completion--file-name-table): Use it.

2026-04-27  Eli Zaretskii  <eliz@gnu.org>

	Fix vc-tests for SRC

	* lisp/vc/vc-src.el (vc-src-register): Support "registering"
	directories in FILES.
	(vc-src-rename-file): Fix implementation and support renaming
	directories.

	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-file)
	(vc-test-src-version-diff): Skip parts that don't work with SRC.
	(Bug#80862)

2026-04-27  Sean Whitton  <spwhitton@spwhitton.name>

	Rename outstanding changes commands to "unintegrated changes"

	* doc/emacs/vc1-xtra.texi (Outstanding Changes): Rename node
	from this ...
	(Unintegrated Changes): ... to this (bug#80434).  References
	changed.
	* etc/NEWS: Document the change.
	* lisp/vc/vc-git.el (vc-git-topic-outgoing-base)
	(vc-git-log-view-mode):
	* lisp/vc/vc-hg.el (vc-hg-print-log, vc-hg-log-view-mode):
	* lisp/vc/vc.el (vc-root-diff-outstanding, vc-diff-outstanding)
	(vc-log-outstanding, vc-root-log-outstanding):
	Rename from these ...
	(vc-root-diff-unintegrated, vc-diff-unintegrated)
	(vc-log-unintegrated, vc-root-log-unintegrated):
	... to these (bug#80434).  All uses changed.
	(vc-log-view-type): Rename 'log-outstanding' type to
	'log-unintegrated'.  All uses changed.

2026-04-27  Sean Whitton  <spwhitton@spwhitton.name>

	VC Annotate for Mercurial repositories shows changeset hashes

	* lisp/vc/vc-hg.el (vc-hg-annotate-show-revision-numbers): New
	option.
	(vc-hg-annotate-command): If it's nil, show changeset hashes not
	revision numbers by passing "-c" not "-n" to 'hg annotate'.
	(vc-hg-annotate-re): Update.
	* etc/NEWS: Document the change.

2026-04-27  Chris Roberts  <git@chobert.org>  (tiny change)

	sqlite-close: no-op for already closed connections

	This behavior is more expected than throwing an error,
	as passing NULL (closed db connection) to 'sqlite3_close'
	is a "harmless no-op" according to the documentation.
	* src/sqlite.c (sqlite-close): Ignore already closed connections.
	(Bug#80908)

2026-04-27  Philip Kaludercic  <philipk@posteo.net>

	Add lexical-binding cookies to multi-file-0.2.3.tar

	* test/lisp/emacs-lisp/package-resources/multi-file-0.2.3.tar:
	Update multi-file.el and multi-file-sub.el files.

2026-04-27  Philip Kaludercic  <philipk@posteo.net>

	Do not warn about 'lexical-binding' if buffer is not compiled

	* lisp/emacs-lisp/bytecomp.el (byte-compile-file): Check
	'no-byte-compile' before issuing a warning.  This prevents
	false-positives when running into .dir-locals.el or -pkg.el
	files.  (Bug#80352)

2026-04-27  Philip Kaludercic  <philipk@posteo.net>

	Do not regard selected packages as removable

	* lisp/emacs-lisp/package.el (package--removable-packages):
	Handle the fact that 'package--dependencies' doesn't return the
	package itself as a dependency, so we have to check
	'package-selected-packages' separately.  Also fix the way we
	check the return value of 'package--dependencies', keeping in
	mind that the value is an alist.  (Bug#80907)

2026-04-27  Philip Kaludercic  <philipk@posteo.net>

	Ensure that 'package--builtin-alist' can be populated

	This is a partial reversion of 931e04a34ba.

	* lisp/emacs-lisp/package.el (package--builtin-alist): Add a
	function that loads 'finder-inf', which in turn will populate
	'package--builtins', if necessary, caching the result.
	(package--upgradeable-packages, describe-package-1)
	(package-menu--refresh, package--mapc, package-get-descriptor):
	Use the function instead of the variable.

2026-04-27  Jonas Bernoulli  <jonas@bernoul.li>

	(transient--suspend-text-conversion-style): Avoid static-if

	safer version/platform conditional.

2026-04-27  Eli Zaretskii  <eliz@gnu.org>

	diff-kill-creations-deletions: Look for /dev/null on all platforms

	* lisp/vc/diff-mode.el (diff-kill-creations-deletions): Look for
	/dev/null on platforms when null-device is something else.

2026-04-27  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter embedded parser range

	If a host parser has some ranges, and an embedded parser also
	has some ranges, the final range used by the embedded parser
	should be an intersection of the two.  This patch adds this
	logic.

	* lisp/treesit.el (treesit--range-verbose): New variable.
	(treesit--intersect-ranges):
	(treesit--set-embed-ranges): New function.
	(treesit--update-ranges-non-local):
	(treesit--update-ranges-local): Use the new functions.
	* test/src/treesit-tests.el:
	(treesit-intersect-ranges): New test.

2026-04-27  Yuan Fu  <casouri@gmail.com>

	Add treesit-query-with-fallback

	* lisp/treesit.el (treesit-font-lock-rules): Handle
	treesit-query-with-fallback.
	(treesit-query-with-fallback): New function.
	* doc/lispref/modes.texi (Parser-based Font Lock): Mention
	treesit-query-with-fallback.

2026-04-27  Yuan Fu  <casouri@gmail.com>

	Fix treesit-range-fn-exclude-children

	* lisp/treesit.el (treesit-range-fn-exclude-children): Exclude
	0-length ranges.

2026-04-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	(register--get-method-type): Fix one more case (bug#80894)

	* lisp/register.el (register--get-method-type): Refine the cl-generic hack
	yet a but further.
	* test/lisp/register-tests.el (register--jumpable-p): Fix the test.

2026-04-26  Aaron L. Zeng  <azeng@janestreet.com>

	Support Elisp debugging and backtraces in code called by modules

	* src/lisp.h (handlertype) <CATCHER_ALL_DEBUGGABLE>: New enumeration
	value.
	* src/emacs-module.c (MODULE_HANDLE_NONLOCAL_EXIT):
	* src/eval.c (Fthrow, signal_or_quit): Use it.

	* test/src/emacs-module-tests.el
	(mod-test-non-local-exit-funcall-debug-on-error): New test.

	Bug#80714

2026-04-26  Kai Ma  <justksqsf@gmail.com>

	New user option compilation-search-extra-path

	* lisp/progmodes/compile.el (compilation-search-extra-path): New
	option (bug#80279).
	(compilation-start): Use it.
	(compilation-search-path):
	* doc/emacs/building.texi:
	* etc/NEWS: Document it, and also compilation-search-path.

2026-04-26  Eli Zaretskii  <eliz@gnu.org>

	Fix renaming files and directories under RCS

	* lisp/vc/vc-rcs.el (vc-rcs-register): Filter out directories from
	FILES.
	(vc-rcs-rename-file): Support OLD being a directory.

	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-file)
	(vc-test--rename-directory): Re-enable these tests for RCS.
	(vc-test--rename-directory): Disable 'yes-or-no-p' questions that
	RCS asks when it needs to create the RCS/ subdirectory: this lets
	the test run without user interaction.

2026-04-26  Sean Whitton  <spwhitton@spwhitton.name>

	vc-delete-file: Narrow binding of default-directory

	* lisp/vc/vc.el (vc-delete-file): In the delete-file branch,
	narrow the binding of default-directory to cover only the call
	into the backend.
	Suggested by Aaron L. Zeng <azeng@janestreet.com> in bug#80875.

2026-04-26  Sean Whitton  <spwhitton@spwhitton.name>

	VC: Support deleting directories

	* lisp/vc/vc.el (delete-files): Specify that implementations of
	this should handle deleting directories.
	* lisp/vc/vc-git.el (vc-git-delete-files):
	* lisp/vc/vc-hg.el (vc-hg-delete-files):
	* lisp/vc/vc.el (vc-delete-file): Handle deleting directories.

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Use 'package-get-descriptor' in 'package--query-desc'

	* lisp/emacs-lisp/package.el (package--query-desc): Replace
	manual 'assoc' call.

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Improve 'package-get-descriptor' performance

	* lisp/emacs-lisp/package.el (package-get-descriptor): Use
	'assq' to look up element in package alists instead of iterative
	over them manually.  This was initially not possible, since we
	merged all alists into one, which would require using a consing
	function like 'map-merge-with' to look up all package descriptor
	objects we want to consider in a single 'assq' call.  As we
	ended up not merging lists, we can assume that there are no
	duplicate keys in the alists, making the efficient 'assq'
	viable.

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Prevent force reloading of package archive contents

	* lisp/emacs-lisp/package.el (package--compatible-packages):
	Drop 'package-read-all-archive-contents' call, as
	'package--build-compatibility-table' will load the archive
	contents on demand via 'package--mapc' anyway.  (Bug#80902)

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Replace 'package--builtin-alist' function with constant

	* lisp/emacs-lisp/package.el (package--builtin-alist):
	(package--upgradeable-packages, package--mapc)
	(package-get-descriptor):
	* lisp/emacs-lisp/package.el (package--builtin-alist): Replace
	function with constant, as the result of the function is always
	the same within an Emacs session, since the set of built-in
	packages don't change during execution.
	(package--upgradeable-packages, package--mapc)
	(package-get-descriptor): Use variable instead of function.
	(package-menu--refresh, describe-package-1): Lookup desc in
	alist instead of calling 'package--from-builtin'.

	(Bug#80902)

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Restore previous 'package-get-descriptor' signature

	* lisp/emacs-lisp/package.el (package-get-descriptor): Allow
	SOURCES to not be specified for the sake of backwards
	compatibility.

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Adjust default value of 'user-lisp-ignored-directories'

	* lisp/startup.el (user-lisp-ignored-directories): Ignore all
	directories that VC would also exclude.  (Bug#80853)

2026-04-25  Philip Kaludercic  <philipk@posteo.net>

	Clarify how to customize 'user-lisp-ignored-directories'

	* lisp/startup.el (user-lisp-ignored-directories): Update docstring.

	(Bug#80853)

2026-04-25  Yuan Fu  <casouri@gmail.com>

	Make :range-fn in treesit-range-rules actually work

	* lisp/treesit.el (treesit--range-start):
	(treesit--range-end):
	(treesit--flatten-ranges): New helpers.
	(treesit-query-range):
	(treesit-query-range-by-language): Don't flatten the ranges
	returned by each range-fn.
	(treesit--update-ranges-non-local):
	(treesit--update-ranges-local): Handle the case where the range
	is a complicated ((START . END)...).
	* test/src/treesit-tests.el (treesit-range-helper): New test.

2026-04-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	register.el: Allow jumping to kmacros again (bug#80894)

	* lisp/register.el (register--get-method-type): Fix handling for
	OClosure args.
	* test/lisp/register-tests.el (register--jumpable-p): New test.

2026-04-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	(Info-documentlanguage): Keep Info-related code in `info.el`

	* lisp/simple.el (Info-documentlanguage): Move from here...
	* lisp/info.el (Info-documentlanguage): ...to here.

2026-04-25  Eli Zaretskii  <eliz@gnu.org>

	Fix line-truncation on horizontally-split TTY frames

	* src/term.c (append_glyph, append_composite_glyph)
	(append_glyphless_glyph): Account for the right-border glyph
	when computing the end glyph of TEXT_AREA.  (Bug#80900)

2026-04-25  Michael Albinus  <michael.albinus@gmx.de>

	Some minor Tramp fixes

	* doc/misc/tramp.texi (Customizing Methods): Add comment.

	* lisp/net/tramp-sh.el (tramp-open-connection-setup-interactive-shell):
	Comment out setting `command-line-max-length', it doesn't work reliably.

	* test/lisp/net/tramp-tests.el (tramp-test03-file-error)
	(tramp-test26-file-name-completion-boundaries): Adapt tests.

2026-04-24  Pip Cet  <pipcet@protonmail.com>

	Don't modify kbd_fetch_ptr in x_delete_selection_requests (bug#80863)

	This code may be called from within the loop in process_special_events
	which assumed kbd_fetch_ptr remains unchanged.  This caused a buffer
	underflow which resulted in the entire kbd buffer being replayed.

	* src/xterm.c (x_delete_selection_requests): Simply clear deleted
	events rather than rotating the kbd buffer.

2026-04-24  Martin Rudalics  <rudalics@gmx.at>

	;; Clarify doc on 'dedicated' 'display-buffer' action alist entry

	* doc/lispref/windows.texi (Buffer Display Action Alists):
	Clarify that only new windows can be marked as dedicated via the
	action alist entry.

2026-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	(work-buffer--release): Fix bug#80813

	* lisp/emacs-lisp/subr-x.el (work-buffer--release): Make sure the
	buffer is not left read-only.  Clarify potential limitations to
	the cleanup performed, especially w.r.t indirect buffers.
	Don't bother binding `deactivate-mark` since that variable is buffer-local
	nowadays anyway.

2026-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	(comint--fontify-input-fontify-region): Silence messages (bug#80870)

	`syntax-propertize` currently doesn't support propertizing only
	parts of a buffer.  Maybe we should improve it, maybe via
	something like `font-lock-dont-widen` or the `syntax-ppss` support for
	narrowing, but in the mean time, teach comint to avoid holes in
	the propertization.

	* lisp/comint.el (comint--dummy-fontify-syntax): New function.
	(comint--fontify-input-fontify-region): Use it to silence the
	new "Cannot syntax-propertize" message in `syntax.el`.
	Also, refine args to reflect the fact that it's an advice.

2026-04-23  Sean Whitton  <spwhitton@spwhitton.name>

	vc-hg-after-dir-status: Rewrite to handle current 'hg status' output

	* lisp/vc/vc-hg.el (vc-hg-after-dir-status): Rewrite to handle
	renames where the "R" line comes arbitrarily later in the
	output.
	* test/lisp/vc/vc-hg-tests.el
	(vc-hg-test--after-dir-status-expect): New function.
	(vc-hg-after-dir-status): New test.

2026-04-23  Lee Thompson  <lee.p.thomp@gmail.com>

	Add language-environment and input methods for Syriac

	* lisp/leim/quail/syriac.el: New file
	* lisp/language/misc-lang.el: ("Syriac"): New language environment.
	("Arabic"): Add comment explaining usage of `arabic-shape-gstring'
	for Syriac as well as Arabic.
	* etc/NEWS: Announce the new language environment and input methods.
	* etc/HELLO: Add a Syriac greeting.
	(Bug#80451)

2026-04-23  Peter Oliver  <git@mavit.org.uk>

	Document setrgbb, setrgbf, and Tc terminal capabilities

	* doc/misc/efaq.texi (Colors on a TTY): Mention the unofficial
	setrgbb, setrgbf, and Tc terminal capabilities, and give an
	example custom terminfo defintion using them.  (Bug#70941)

2026-04-23  Peter Oliver  <git@mavit.org.uk>

	Simplify Tc/COLORTERM=truecolor escape sequence

	This should be more readable to most people, since C is
	more widely familiar than the terminfo language.
	* src/term.c (init_tty): Do the conversion from a single integer
	24-bit color value to three 8-bit RGB values up-front.
	(Bug#70941)

2026-04-23  Tim Ruffing  <crypto@timruffing.de>

	Support setrgbb/setrgbf for setting 24-bit color

	* src/term.c (turn_on_face): Account for TF_rgb_separate.
	(init_tty): Support setrgbf/setrrgbb and set TF_rgb_separate
	accordingly.
	* src/termchar.h: Update commentary.
	(Bug#70941)

2026-04-23  Peter Oliver  <git@mavit.org.uk>

	Use expected escape sequence for terminfo Tc and COLORTERM=truecolor

	When the non-standard terminfo capability Tc is present, or the
	environment variable COLORTERM is set to truecolor, use a
	hard-coded escape sequence that addresses all colors directly by
	their RGB values.

	Previously we used escape sequences cribbed from terminfo's
	setaf/setab for direct color, that expect that we will only try to
	use colors 000000 to 000007 for the first eight indexed colors.
	This isn't something we currently handle.

	* doc/misc/efaq.texi (Colors on a TTY): Fix off-by-one error in list
	of indexed colors for terminfo RGB terminals.
	* src/term.c (init_tty): Don’t use any indexed colors with terminfo
	Tc capability or COLORTERM=truecolor environment variable (bug#70941).

2026-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	(loaddefs--defining-macros): Delete var

	Now that Transient-0.13.0 has been merged, we don't need to
	treat its macros specially any more because they come with the
	appropriate `autoload-macro` property.

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs--defining-macros): Delete var.
	(loaddefs-generate--make-autoload): Delete corresponding code.

2026-04-22  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.13.0-10-g5b2ff26f

2026-04-22  Roi Martin  <jroi.martin@gmail.com>

	Test that ERT creates a list of executed tests from erts files

	* test/lisp/emacs-lisp/ert-resources/erts-file-test-list-fail.erts:
	* test/lisp/emacs-lisp/ert-resources/erts-file-test-list.erts: New erts
	files.
	* test/lisp/emacs-lisp/ert-tests.el (ert-test-list-of-erts-file-tests):
	New test.

2026-04-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	(mail-citation-prefix-regexp): Fix excessive backtracking (bug#80808)

	* lisp/mail/sendmail.el (mail-citation-prefix-regexp): Simplify regexp
	and fix docstring to reflect reality since commit 0b8ee42164cc4569.

2026-04-22  João Távora  <joaotavora@gmail.com>

	Eglot: add eglot--server-buffer-name and use it consistently

	* lisp/progmodes/eglot.el (eglot--server-buffer-name): New function.

	(eglot--connect): Rename events and stderr buffers after serverInfo
	arrives to include the server's self-reported name.

	(eglot-show-workspace-configuration, eglot-describe-connection)
	(eglot--define-hierarchy-command): Use eglot--server-buffer-name.

	(eglot--propose-changes-as-diff): Add SERVER argument; use
	eglot--server-buffer-name.

	(eglot--apply-workspace-edit): Add SERVER argument; pass server to
	eglot--propose-changes-as-diff.

	(eglot-handle-request workspace/applyEdit, eglot-execute)
	(eglot-rename): Pass server to eglot--apply-workspace-edit.

2026-04-22  João Távora  <joaotavora@gmail.com>

	Eglot: add eglot--server-name helper

	* lisp/progmodes/eglot.el (eglot--server-name): New function.
	(eglot--list-connections-entries, eglot-describe-connection): Use it.

2026-04-21  Michael Albinus  <michael.albinus@gmx.de>

	Improve files-tests.el for quoted file names

	* test/lisp/files-tests.el
	(files-tests-file-name-non-special--temp-file-prefixes): New defconst.
	(files-tests-file-name-non-special--subprocess)
	(files-tests-file-name-non-special--buffers): Loop over it.
	(files-tests--with-temp-non-special)
	(files-tests--with-temp-non-special-and-file-name-handler): Simplify.
	(files-tests-file-name-non-special-make-symbolic-link):
	Pacify compiler warning.

2026-04-21  Juri Linkov  <juri@linkov.net>

	Rebind 'tab-bar-mouse-close-tab' from <down-mouse-2> to <mouse-2>

	* lisp/tab-bar.el (tab-bar-map): Unbind <mouse-2> from 'ignore'.
	Bind 'tab-bar-mouse-close-tab' to <mouse-2> instead of <down-mouse-2>
	(bug#80858).

2026-04-21  Eli Zaretskii  <eliz@gnu.org>

	Fix 'toggle-truncate-lines' when 'visual-line-mode' is ON

	* lisp/simple.el (toggle-truncate-lines): Force 'truncate-lines'
	non-nil, even if visual-line-mode needs to be turned off.
	(Bug#80741)

2026-04-21  Leo C. Stein  <leo.stein@gmail.com>

	Add missing Greek subscripts to TeX input method

	* lisp/leim/quail/latin-ltx.el: Add a regex to match Greek
	subscripts. Currently there are only five in unicode: beta, gamma,
	rho, phi, and chi. They can now be input with the TeX input method
	as, e.g., _\beta .  (Bug#80791)

2026-04-21  Eli Zaretskii  <eliz@gnu.org>

	Fix unsafe use of SDATA in 'display_tty_menu_separator'

	* src/xdisp.c (display_tty_menu_separator): Pass Lisp string to
	display_string, not a pointer to its SDATA.  This is safer
	GC-wise.

2026-04-21  Roi Martin  <jroi.martin@gmail.com>

	Show executed tests from erts files via the ERT results buffer

	* lisp/emacs-lisp/ert.el: Add key binding.
	(ert--erts-file-test-execution-observer): New variable.
	(ert--signal-erts-file-test-execution): New function.
	(ert-test-result): Add field.
	(ert-run-test): Collect tests from erts files.
	(ert-results-mode-menu): Add entry.
	(ert--erts-file-test-name-button): New button type.
	(ert--erts-file-test-name-button-action): New function.
	(ert-results-pop-to-erts-file-tests-for-test-at-point): New function.
	(ert-test--erts-test): Record execution of test from erts file.
	* doc/misc/ert.texi (Running Tests Interactively): Update manual.
	* etc/NEWS: Update NEWS.  (Bug#80806)

2026-04-21  João Távora  <joaotavora@gmail.com>

	Eglot: handle visited file name changes (typically C-x C-w)

	When the user renames a buffer's file via set-visited-file-name,
	notify the server with didClose (old URI) and didOpen (new URI).
	The TextDocumentIdentifier cache still holds the old URI when
	after-set-visited-file-name-hook fires, so didClose uses it
	correctly; didOpen then clears and rebuilds it from the new name.

	* lisp/progmodes/eglot.el (eglot--managed-mode): Hook and unhook
	eglot--after-set-visited-file-name-hook.
	(eglot--after-set-visited-file-name-hook): New function.

2026-04-21  João Távora  <joaotavora@gmail.com>

	Eglot: use Unicode box-drawing chars in hierarchy buffers

	Use box-drawing characters for the tree guides in hierarchy
	buffers when the display supports them.

	* lisp/progmodes/eglot.el (eglot--hierarchy-2): Rework.

2026-04-21  Philip Kaludercic  <philipk@posteo.net>

	Extend utility of 'package-get-descriptor'

	The general idea here is to make it easier to handle situations
	where you might have a symbol designating a package name or a
	'package-desc' object, but you really want the latter.

	* lisp/emacs-lisp/package.el (package--get-deps): Remove
	function superseded by 'package--dependencies'.
	(package--builtin-alist, package--archive-contents): Add new
	functions.
	(package--removable-packages): Use 'package--dependencies'.
	(package--dependencies): Check for circular dependencies.
	(package-upgrade, package--upgradeable-packages)
	(package--user-installed-p, package-reinstall, package-recompile)
	(describe-package-1, package-desc-status, package--mapc)
	(package-menu--find-upgrades): Use 'package-get-descriptor'.
	(package-get-descriptor): Add optional arguments to allow for
	different kinds of queries.

	* lisp/emacs-lisp/package-vc.el
	(package-vc-install-selected-packages)
	(package-vc--generate-description-file)
	(package-vc-install-dependencies, package-vc--read-package-desc)
	(package-vc-install, package-vc-checkout): Use
	'package-get-descriptor'.

2026-04-20  João Távora  <joaotavora@gmail.com>

	Eglot: unbreak diagnostics in symlinked projects

	Now that 'eglot-uri-to-path' tries to return
	"project-root-familiar" paths, unresolving the absolute path
	name, it's important to update 'eglot--find-buffer-visiting' to
	consider the two alternative ways to refer to a file.  IOW, this
	was already a bug, but the latest changes to 'eglot-uri-to-path'
	made it more evident.

	* lisp/progmodes/eglot.el (eglot--find-buffer-visiting): Also
	consider buffer-file-name.

2026-04-20  Martin Rudalics  <rudalics@gmx.at>

	Fix control window setup in 'ediff-setup-windows-plain-compare' (Bug#80809)

	* lisp/vc/ediff-wind.el (ediff-setup-windows-plain-compare): Do
	not call 'display-buffer-in-direction' directly (Bug#80809).

2026-04-20  Roland Winkler  <winkler@gnu.org>

	proced-format: Simplify last change

	* lisp/proced.el (proced-current-process): Rename from
	proced-format-current-process.
	(proced-format): Use it.  Simplify.

2026-04-20  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.8.3

2026-04-20  Yuan Fu  <casouri@gmail.com>

	Make sure treesit-fill-reindent-defun handles nil defun (bug#80860)

	* lisp/treesit.el (treesit-fill-reindent-defun): Display error
	when there's no defun at point.

2026-04-20  Yuan Fu  <casouri@gmail.com>

	* src/treesit.c (Ftreesit__linecol_at): Add treesit_check_position.

2026-04-20  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter variable name

	* lisp/treesit.el:
	(treesit-languages-require-line-column-tracking): This is what
	treesit.c uses.
	* src/treesit.c: Fix comment typo.

2026-04-19  Michael Albinus  <michael.albinus@gmx.de>

	Some minor Tramp changes

	* lisp/net/tramp-sh.el (tramp-get-remote-arg-max): New defun.
	(tramp-open-connection-setup-interactive-shell): Use it.

	* lisp/net/tramp.el (tramp-multi-hop-p-hook): New defvar.
	(tramp-multi-hop-p): Use it.
	(tramp-handle-make-process): Set TERM environment.

2026-04-19  Paul Eggert  <eggert@cs.ucla.edu>

	emacs server sending long-line simplification

	Now that emacsclient can receive long lines without problems,
	don’t bother splitting long lines when sending to it.
	* lisp/server.el (server-msg-size): Now obsolete.
	(server-reply-print): Send qtext without trying to break it
	into pieces (Bug#80807#49).

2026-04-19  Paul Eggert  <eggert@cs.ucla.edu>

	Pacify clang 21.1.8 + gdk-pixbuf 2.44

	* src/pgtkfns.c (xg_set_icon_from_xpm_data):
	* src/xfns.c (xg_set_icon_from_xpm_data):
	Also pacify clang when --enable-gcc-warnings is used.

2026-04-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	(js-jsx--detect-after-change): Fix test regression

	Commit 6942d508f0c made js-mode-regexp-syntax-bug-25529 fail,
	because it changes the moment and place in which
	`syntax-propertize` gets called, uncovering a bug where
	`js-jsx--detect-after-change` narrows the buffer, then calls
	`re-search-forward` which calls `syntax-propertize`, so we end
	up doing `syntax-propertize` while narrowed which can fail in
	all kinds of ways.

	* lisp/progmodes/js.el (js-jsx--detect-and-enable): Change optional arg
	to BEG and END.
	(js-jsx--detect-after-change): Use them to avoid narrowing.

	* lisp/emacs-lisp/syntax.el (syntax-propertize): Emit a message
	when called narrowed and the narrowing starts later than the
	nearest already propertized position.

2026-04-18  Eli Zaretskii  <eliz@gnu.org>

	Merge from origin/emacs-30

	8f535370b9e * src/image.c (svg_load_image): Fix off-by-one mistake (b...
	fe90f2d87ec * test/infra/gitlab-ci.yml (default): User docker 28.5.2.

	# Conflicts:
	#	src/image.c

2026-04-18  Philip Kaludercic  <philipk@posteo.net>

	Suppress queries when installing package from file

	* lisp/emacs-lisp/package.el (package-install-file): Assume it
	is OK to set the visited file name, since we are not actually
	touching anything on disk, and prevent the modified flag from
	preventing us to kill the temporary buffer.  The flag is set by
	tar-mode.

2026-04-18  Philip Kaludercic  <philipk@posteo.net>

	Use git-diff(1) in 'package-review-diff-command' if available

	* lisp/emacs-lisp/package.el (package--review-git-diff-command):
	Add new constant to avoid duplicating the exact command as the
	default value and in the type of the user option.
	(package-review-diff-command): Use git-diff(1) if Git is
	installed, and fall back to regular diff(1) otherwise.  The
	previous default value has been moved to the user option, as a
	suggested alternative.
	(package-review): Support the ability to use symbols, that get
	replaced and expanded into the list of switches.

	(Bug#80684)

	Co-Authored-By: Daniel Mendler <mail@daniel-mendler.de>

2026-04-18  Eli Zaretskii  <eliz@gnu.org>

	* src/image.c (svg_load_image): Fix off-by-one mistake (bug#80851).

2026-04-18  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode-set-style when STYLE is a function (bug#80777)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-set-style): Prepend the
	language symbol in front of the styles.

2026-04-18  Rahguzar  <rahguzar@mailbox.org>

	proced-format: Use internal var for speed-up (bug#77775).

	* lisp/proced.el (proced-format-current-process): New variable.
	* lisp/proced.el (proced-format-pid, proced-format): Use it.

2026-04-18  Rahguzar  <rahguzar@mailbox.org>

	proced-format: Use process-alist for standard attributes (bug#77775).

	* lisp/proced.el (proced-format): Use process-alist for standard
	attributes.

2026-04-17  Sean Whitton  <spwhitton@spwhitton.name>

	vc-hg--checkin: Use vc-hg--active-bookmark-internal

	* lisp/vc/vc-hg.el (vc-hg--active-bookmark-internal): Make it
	work when default-directory is not the repository root.
	(vc-hg--checkin): Use vc-hg--active-bookmark-internal instead of
	vc-hg--working-branch.

2026-04-17  Stephen Berman  <stephen.berman@gmx.net>

	Restrict Dired handling of newlines in file names

	* lisp/dired.el (dired--ls-accept-b-switch-p): New function.
	(dired-internal-noselect): Use it in the condition on displaying
	warning about filenames with newlines.
	(dired--set-auto-toggle-b-switch): Use it to conditionalize
	calling 'dired--toggle-b-switch'.
	(dired-auto-toggle-b-switch, dired--toggle-b-switch): Improve doc
	string.

	* test/lisp/dired-tests.el (dired-test-filename-with-newline-1)
	(dired-test-filename-with-newline-2): Skip unless Dired uses an
	'ls' that supports the '-b' switch.

	* etc/NEWS: Adjust accordingly the announcements of the Dired
	warning and the new user option for file names with newlines.

2026-04-17  Aaron L. Zeng  <azeng@janestreet.com>  (tiny change)

	vc-hg--checkin: When committing a patch, advance active hg bookmark

	* lisp/vc/vc-hg.el (vc-hg--checkin): When committing a patch,
	advance any active hg bookmark (bug#80848).

2026-04-17  Michael Albinus  <michael.albinus@gmx.de>

	Extend integration of external operations in Tramp

	* doc/misc/tramp.texi (Extension packages): Use another format
	char in example.
	(New operations): Document different argument types.  Extend example.

	* lisp/net/tramp.el: Use consequently `eq', `assq', `memq'.
	(tramp-file-name-for-operation-external): Extend docstring.
	(tramp-file-name-for-operation): Make more use of
	`tramp-file-name-for-operation-external'.
	(tramp-add-external-operation): New optional argument `arg-type'.

	* test/lisp/net/tramp-tests.el (tramp--handle-test-operation):
	Rename from `tramp--handler-for-test-operation'.
	(tramp--handle-process-id)
	(tramp--test-operation-file-name-for-operation): New defuns.
	(tramp-test49-external-backend-function): Extend test.

2026-04-17  Paul Eggert  <eggert@cs.ucla.edu>

	Append newline to server -error commands

	Problem reported by Zhengyi Fu (bug#80844).
	* lisp/server.el (server--process-filter-1, server-return-error)
	(server-edit-abort): Append newline to -error commands, too.
	Otherwise emacsclient has no reliable way to find the end of the
	error command’s argument, except to wait for EOF which is
	undesirable since the Emacs server keeps the socket open
	for a while, waiting for emacsclient to exit.

2026-04-17  Yuan Fu  <casouri@gmail.com>

	Make sure range (1, 1) doesn't capture anything (bug#80798)

	* src/treesit.c (Ftreesit_query_capture): Return Qnil if
	querying (1, 1).

2026-04-17  Yuan Fu  <casouri@gmail.com>

	Accept marker as position in treesit.c functions (bug#80830)

	* src/treesit.c (treesit_check_positive_integer): Remove.
	(treesit_check_position):
	(Ftreesit_node_first_child_for_pos):
	(Ftreesit_node_descendant_for_range):
	(Ftreesit_query_capture):
	(Ftreesit__linecol_at): Use fix_position.

	* test/src/treesit-tests.el:
	(treesit-query-marker-position): Test.

2026-04-17  João Távora  <joaotavora@gmail.com>

	Eglot: add M-x eglot-describe-connection

	Also add more bindings to M-x eglot-list-connections

	* lisp/progmodes/eglot.el (eglot-list-connections-mode-map): Add
	bindings for e, w, RET.
	(eglot-events-buffer-of-listed-connection)
	(eglot-show-workspace-configuration-of-listed-connection)
	(eglot-describe-listed-connection): New commands.
	(eglot-describe-connection): New command.

	* doc/misc/eglot.texi: Document new keys and eglot-describe-connection.

	* etc/EGLOT-NEWS: Announce.

2026-04-16  Sean Whitton  <spwhitton@spwhitton.name>

	vc-file-tree-walk: Stop emitting messages

	* lisp/vc/vc.el (vc-file-tree-walk, vc-file-tree-walk-internal):
	Stop emitting messages about traversing directories.

2026-04-16  Sean Whitton  <spwhitton@spwhitton.name>

	vc-file-tree-walk-internal: Use vc-registered

	* lisp/vc/vc.el (vc-file-tree-walk-internal): Use vc-registered
	not vc-backend, for robustness.

2026-04-16  Sean Whitton  <spwhitton@spwhitton.name>

	vc-rename-file: Fix skipping calling into the backend

	* lisp/vc/vc.el (vc-rename-file): Replace broken attempted use
	of vc-dir-status-files with walking OLD using vc-file-tree-walk.
	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-directory):
	Assert that the files are registered or not as appropriate.  New
	test case in which there are only registered files.

2026-04-16  João Távora  <joaotavora@gmail.com>

	Jsonrpc: simplify previous change

	* lisp/jsonrpc.el (jsonrpc--save-excursion-maybe): Delete.
	(jsonrpc--forwarding-buffer, jsonrpc--log-event): Use simple
	save-excursion.

2026-04-16  João Távora  <joaotavora@gmail.com>

	Eglot: adjust previous change to eglot-uri-to-path

	* lisp/progmodes/eglot.el (eglot-uri-to-path): Tweak.

2026-04-16  Juri Linkov  <juri@linkov.net>

	Update 'crm-complete-and-exit' from 'minibuffer-complete-and-exit'

	* lisp/emacs-lisp/crm.el (crm-complete-and-exit):
	Add new arg 'no-exit'.  Call 'minibuffer-choose-completion'
	when 'completion--selected-candidate' returns non-nil (bug#80821).

2026-04-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	src/syntax.c (update_syntax_table): Remove redundant assignment

2026-04-16  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Announce ert-play-keys in etc/NEWS.

2026-04-16  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	ert-play-keys function

	* lisp/emacs-lisp/ert-x.el (ert-play-keys): new defun.

	* test/lisp/simple-tests.el (undo-test-kill-c-a-then-undo)
	(undo-test-point-after-forward-kill): Use new function
	`ert-play-keys' and `(ert-with-test-buffer (:selected t) ...)'
	rather (with-temp-buffer (switch-to-buffer (current-buffer) ...)'.

	* test/lisp/erc/erc-scenarios-spelling.el
	(erc-scenarios-spelling--auto-correct): Use new function
	`ert-play-keys' and `(ert-with-buffer-selected ...)' rather than
	`execute-kbd-macro' and `(with-current-buffer
	... (set-window-buffer nil (current-buffer) ...)'.

	* doc/misc/ert.texi (Helper Functions): Document ert-play-keys,
	and differences between ert-simulate-command, ert-simulate-keys
	& ert-play-keys.

	* test/lisp/emacs-lisp/ert-x-tests.el
	(ert-x-tests-play-keys)
	(ert-x-tests-simulate-command, ert-x-tests-simulate-keys): New
	tests.

2026-04-16  João Távora  <joaotavora@gmail.com>

	Eglot: add shutdown/reconnect bindings to eglot-list-connections buffer

	* lisp/progmodes/eglot.el (eglot-list-connections-mode-map): New
	defvar.

	* lisp/progmodes/eglot.el (eglot--list-connections-entries): New
	function, extracted from eglot-list-connections.

	* lisp/progmodes/eglot.el (eglot--list-connections-cmd): New macro.

	* lisp/progmodes/eglot.el (eglot-shutdown-listed-connection)
	(eglot-reconnect-listed-connection): New commands.

	* lisp/progmodes/eglot.el (eglot-list-connections): Use
	eglot--list-connections-entries.

	* doc/misc/eglot.texi: Document eglot-list-connections and new keys.

	* etc/EGLOT-NEWS: Announce.

2026-04-16  João Távora  <joaotavora@gmail.com>

	Jsonrpc: don't suddenly jump point in events buffer

	* lisp/jsonrpc.el (jsonrpc--save-excursion-maybe): New macro.

	* lisp/jsonrpc.el (jsonrpc--log-event, jsonrpc--forwarding-buffer):
	Use it.

2026-04-16  João Távora  <joaotavora@gmail.com>

	Eglot: un-canonicalize server URIs to project's root

	Some LSP servers prefer to canonicalize all document URIs to
	their "true name", chasing all fs symbolic links.  If the user
	is visiting a project under a symlink, say ~/myprojects/foo
	which points to /data/true/projects/foo.  When visiting a
	~/myprojects/foo/f.c and trying to jump to a nearby file f.h via
	LSP 'xref-find-definitions', the path should probably be
	~/myproject/foo/f.h, not /data/true/projects/foo/f.h.

	Even though Emacs can recognize that the two files are the same,
	'buffer-file-name' is not.  This confuses tools like C-x C-f,
	ibuffer, and ultimately the users themselves who probably
	oblivious to the true place of the project.  After all they
	started Eglot under a syminked file.

	* lisp/progmodes/eglot.el (eglot-lsp-server): Add trueroot slot.
	(eglot-uri-to-path): Rework to consider trueroot and project root.

2026-04-15  Toby Dylan Hocking  <toby.hocking@r-project.org>  (tiny change)

	Make | optional for 'gnu' regexp in compilation-mode (bug#80681)

	* lisp/progmodes/compile.el
	(compilation-error-regexp-alist-alist): Make leading '|'
	optional when there are leading spaces (bug#80681).
	* etc/compilation.txt (GNU style): New error with two leading
	spaces.
	* test/lisp/progmodes/compile-tests.el
	(compile-test-error-regexps): Increment expected
	compilation-num-errors-found.
	(compile-tests--test-regexps-data): New error test case for
	'gnu' with two leading spaces.  Change expected match for
	'cucumber' to match again 'gnu'.

2026-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	vc-rename-file: Fix case of directory with only untracked files

	* lisp/vc/vc.el (vc-rename-file): Don't call into the backend if
	moving a directory containing only untracked files.
	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-directory):
	New test for this case.

2026-04-15  Juri Linkov  <juri@linkov.net>

	Handle the symbol property 'isearch-exit' in 'isearch-occur' (bug#80785)

	* lisp/isearch.el (isearch-occur): When the command has
	a non-nil symbol property 'isearch-exit', exit the search
	before running the command.

2026-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	Fix renaming whole directories with Mercurial

	* lisp/vc/vc-hg.el (vc-hg-rename-file): Use 'hg mv --after'.
	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-directory):
	New test.

2026-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	vc-rename-file: New OK-IF-ALREADY-EXISTS parameter

	* lisp/vc/vc.el (vc-delete-file): New NOCONFIRM parameter.
	(vc-rename-file): New OK-IF-ALREADY-EXISTS parameter.
	* lisp/dired-aux.el (dired-rename-file): Pass it.
	* test/lisp/vc/vc-tests/vc-tests.el (vc-test--rename-file): Test
	it.  Also test moving files into an existing directory.

2026-04-14  Juri Linkov  <juri@linkov.net>

	New faces 'tab-line-active' and 'tab-line-inactive' (bug#80742)

	This is intended to parallel the 'mode-line-active/inactive'
	and 'header-line-active/inactive' distinction.

	* doc/emacs/display.texi (Standard Faces): Document the new faces.

	* lisp/faces.el (tab-line-active, tab-line-inactive): Add new faces.

	* lisp/tab-line.el (tab-line-faces): Add new faces
	to MEMBERS arg of 'defgroup'.
	(tab-line-auto-hscroll): Use one of the faces
	depending on 'mode-line-window-selected-p'.

	* src/dispextern.h (CURRENT_TAB_LINE_ACTIVE_FACE_ID_3)
	(CURRENT_TAB_LINE_ACTIVE_FACE_ID): New macros
	based on header-line equivalents.
	(CURRENT_TAB_LINE_HEIGHT): Use CURRENT_TAB_LINE_ACTIVE_FACE_ID.
	(face_id): Use TAB_LINE_ACTIVE_FACE_ID and
	TAB_LINE_INACTIVE_FACE_ID instead of TAB_LINE_FACE_ID.

	* src/xdisp.c (window_box_height, pos_visible_p, init_iterator)
	(window_text_pixel_size, display_mode_lines, display_mode_line)
	(format-mode-line): Replace all uses of TAB_LINE_FACE_ID with
	either a new macro or the new face IDs.

	* src/xfaces.c (lookup_basic_face, realize_basic_faces):
	Map new face IDs to their lisp symbols.
	(syms_of_xfaces): New lisp symbols.

2026-04-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	(loaddefs-generate--make-autoload): Avoid `%s` on compound values

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate--make-autoload):
	Avoid `%s` on compound values.

2026-04-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	SETUP_SYNTAX_TABLE: syntax-propertize more lazily (bug#80600)

	Many regexps do not pay attention to syntax tables at all
	because they don't use things like \s, \b, \<, or \_<.
	So delay the actual initialization of the machinery for
	`syntax-table` properties (especially the call to `syntax-propertize`)
	until the first time we actually need to consult the syntax of
	a character.

	* src/syntax.c (uninitialized_interval): New constant.
	(RE_SETUP_SYNTAX_TABLE_FOR_OBJECT, SETUP_SYNTAX_TABLE):
	Set `forw/backward_i` to that new constant to indicate they haven't
	actually be initialized yet.
	Set `start` and `stop` fields right away, instead of delegating it to
	`update_syntax_table`, so that `e_property` and `b_property`
	can be set independently.
	(update_syntax_table): Remove the `init` argument.  Instead, discover
	the need for initialization based on the fact that `forw/backward_i`
	are uninitialized.  Presume `start` and `stop` fields have been
	set already.
	(parse_sexp_propertize): Update call accordingly.
	(update_syntax_table_forward): Remove the `init` argument.

	* src/syntax.h (update_syntax_table, update_syntax_table_forward):
	Remove the `init` argument.
	(UPDATE_SYNTAX_TABLE_FORWARD, UPDATE_SYNTAX_TABLE_BACKWARD):
	Update calls accordingly.

2026-04-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/international/mule.el (auto-coding-alist): Fix name (bug#80818)

2026-04-13  Eli Zaretskii  <eliz@gnu.org>

	Fix hangs on MS-Windows when deleting a pipe process

	* src/w32.c (sys_close): Don't close a descriptor from which the
	reader thread is reading, to avoid hanging Emacs.  (Bug#80770)

2026-04-13  Eli Zaretskii  <eliz@gnu.org>

	Fix MinGW64 build broken by changes in emacsclient.c

	* nt/gnulib-cfg.mk (getdelim, getline): Do not omit.  It is now
	needed for 'emacsclient', but MinGW64 doesn't have it in its runtime
	libraries (mingw.org's MinGW does have it).  (Bug#80770)

2026-04-13  Eli Zaretskii  <eliz@gnu.org>

	Revert "; Fix node names in modus-themes.org"

	This reverts commit d4002877d3b4d7dcc3c7d5e6ecdef10aad06b8a6.
	It is no longer needed with the latest Org v9.8.2.

2026-04-13  Eli Zaretskii  <eliz@gnu.org>

	Revert "; Fix last change."

	This reverts commit 670bb34d91179eef087b6964edb445244180e8f6.
	It is no longer needed with the latest Org 9.8.2.

2026-04-13  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient receiving long-line fixes

	Do not mishandle long lines, or lines containing NUL,
	when receiving data.
	* lib-src/emacsclient.c (check_socket_timeout, main):
	Use ssize_t for return values from recv,
	since in theory the value could exceed INT_MAX now.
	(main): Do not use a fixed-size buffer for receiving data;
	instead, grow the buffer as needed (admittedly unlikely).
	When a partial line is received via recv, do not discard its data;
	instead, keep reading, possibly with a grown buffer.
	Do not ignore received data after a null byte is received.
	Add a comment about when received data is ignored due to a goto.

2026-04-13  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient send_buffer size--

	* lib-src/emacsclient.c (send_to_emacs_len):
	No need to add 1 to SEND_BUFFER_SIZE.

2026-04-13  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient config+sending long-line fixes

	Do not mishandle long lines, or lines containing NUL,
	when getting configuration or sending data.
	* lib-src/emacsclient.c (send_to_emacs_len, quote_argument_len):
	New functions, generalizing the old send_to_emacs and quote_argument.
	Rewrite the old functions to use the new ones.
	(get_server_config): Do not mishandle long lines in the config file.
	(set_tcp_socket): No longer a need to null-terminate auth string.
	(main): Do not mishandle long lines from stdin, or lines with NUL.

2026-04-12  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.8.2

2026-04-12  Elias Gabriel Perez  <eg642616@gmail.com>

	hideshow: New function 'hs-add-cycle-binding' (Bug#80657)

	https://lists.gnu.org/archive/html/emacs-devel/2026-02/msg00153.html

	* lisp/progmodes/hideshow.el (hs-cycle-filter)
	(hs-minor-mode-map): Update.
	(hs--filter-function, hs-add-cycle-binding): New functions.
	(hs-cycle): Minor rework.

2026-04-12  Juri Linkov  <juri@linkov.net>

	* lisp/tab-bar.el (tab-bar-show): Support the 0 value (bug#80713).

	Add explicit choice for the 0 value to always show the tab bar.
	Also add a choice for other non-negative numbers.
	In the setter enable 'tab-bar-mode' only for numbers,
	but not for the t value that should not enable the tab bar
	after customization, only after creating a new tab.

2026-04-12  Dirk-Jan C. Binnema  <djcb@djcbsoftware.nl>  (tiny change)

	xwidgets: re-enable with newer webkit2gtk

	By disabling hw-acceleration we can re-enable xwidgets with newer
	webkit2gtk versions (Bug#80728).
	Newer versions were disallowed (Bug#66068) since they abort when a
	webkit view is created; however, they work fine as long as we disable
	hw-acceleration, since the off-screen windows that xwidgets uses do not
	support that.
	* configure.ac: Remove upper-bound for webkit2gtk version check.
	* src/xwidget.c (Fmake_xwidget): Turn off hardware-acceleration.

2026-04-12  Philip Kaludercic  <philipk@posteo.net>

	Clean up 'Info-directory-list' after deleting package

	* lisp/emacs-lisp/package.el (package--delete-directory): Remove
	manual before physically deleting the package.  (Bug#80776)

2026-04-12  Philip Kaludercic  <philipk@posteo.net>

	Fix computation of package description file

	* lisp/subr.el (package--description-file): Do not expect
	non-numeric version components to be followed directly by a
	number.  (Bug#80744)

2026-04-12  Philip Kaludercic  <philipk@posteo.net>

	Add face for obsolete packages in package menu

	* lisp/emacs-lisp/package.el (package-status-obsolete): New face.
	(package-menu-status-faces): Use new face instead of hard-coding
	a font-lock face.

2026-04-12  Richard Lawrence  <rwl@recursewithless.net>

	Add short documentation group for iCalendar lib

	Define a short documentation group and document the major functions:

	* lisp/calendar/icalendar-shortdoc.el: New file.
	* lisp/calendar/diary-icalendar.el:
	* lisp/calendar/icalendar-ast.el:
	* lisp/calendar/icalendar-parser.el:
	* lisp/calendar/icalendar-recur.el:
	* lisp/calendar/icalendar-utils.el: Refer to icalendar-shortdoc.el in
	file commentary.
	* lisp/calendar/icalendar-macs.el: Ditto, and also mention the macros
	for binding values.
	* lisp/calendar/icalendar.el: Ditto, and also remove some obsolete
	commentary.

	Also make some improvements to documentation strings that the above
	changes revealed would be helpful:

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-recurrences-in-window-w/end-times): Fix broken ref.
	(icalendar-recur-current-tz-to-vtimezone): Clarify docstring.
	* lisp/calendar/icalendar-parser.el (icalendar-parse): Clarify
	docstring.

	(Bug#80727)

2026-04-12  Richard Lawrence  <rwl@recursewithless.net>

	Improve performance of icalendar-recur.el and its tests

	As discussed in Bug#80520.

	* test/lisp/calendar/icalendar-recur-tests.el
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/3)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/29)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/30)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/31)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/33)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/34)
	(icalendar-test-rrule-test-rfc5545-sec3.8.5.3/38): Mark tests expensive.

	Abstract the implementation of intervals in icalendar-recur.el.  Don't
	store interval NEXT-LOW when it's the same as HIGH.  This reduces
	allocations, and shaves about ~20% off the full test suite.

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-make-interval)
	(icalendar-recur-interval-low)
	(icalendar-recur-interval-high)
	(icalendar-recur-interval-next): Implement intervals and subintervals as
	vectors.  Only store NEXT-LOW when it's non-nil.
	(icalendar-recur-find-absolute-interval)
	(icalendar-recur-find-daily-interval)
	(icalendar-recur-find-weekly-interval)
	(icalendar-recur-find-monthly-interval)
	(icalendar-recur-find-yearly-interval)
	(icalendar-recur-next-interval)
	(icalendar-recur-previous-interval)
	(icalendar-recur-refine-byyearday)
	(icalendar-recur-refine-byweekno)
	(icalendar-recur-refine-bymonth)
	(icalendar-recur-refine-bymonthday)
	(icalendar-recur-refine-byday)
	(icalendar-recur-refine-byhour)
	(icalendar-recur-refine-byminute)
	(icalendar-recur-refine-bysecond)
	(icalendar-recur-subintervals-to-date-times)
	(icalendar-recur-subintervals-to-dates)
	(icalendar-recur-recurrences-in-interval)
	(icalendar-recur-recurrences-in-window)
	(icalendar-recur--key-from-interval): Use new interval constructor and
	accessors.  Don't generate NEXT-LOW when it's the same as HIGH.
	* lisp/calendar/icalendar-utils.el (icalendar-dates-until): Use new
	interval constructor and accessors.
	* test/lisp/calendar/icalendar-recur-tests.el
	(icalendar-test-recur-find-secondly-interval)
	(icalendar-test-recur-find-minutely-interval)
	(icalendar-test-recur-find-hourly-interval)
	(icalendar-test-recur-find-daily-interval-w/date)
	(icalendar-test-recur-find-daily-interval-w/date-time)
	(icalendar-test-recur-find-weekly-interval-w/date)
	(icalendar-test-recur-find-weekly-interval-w/date-time)
	(icalendar-test-recur-find-monthly-interval)
	(icalendar-test-recur-find-yearly-interval)
	(icalendar-test-recur-refine-byyearday)
	(icalendar-test-recur-refine-bymonth)
	(icalendar-test-recur-refine-bymonthday)
	(icalendar-test-recur-refine-byday)
	(icalendar-test-recur-refine-byhour)
	(icalendar-test-recur-refine-byminute)
	(icalendar-test-recur-refine-bysecond)
	(icalendar-test-recur-subintervals-to-dates)
	(icalendar-test-recur-subintervals-to-date-times)
	(icalendar-test-rrule-test): Use new interval constructor and accessors.

	Rearrange loops when refining subintervals, so that the loop always runs
	once but doesn't run a second no-op iteration.  Astonishingly this cuts
	the running time of the full test suite by almost 50%.

	* lisp/calendar/icalendar-recur.el (icalendar-recur-refine-byyearday)
	(icalendar-recur-refine-byweekno)
	(icalendar-recur-refine-bymonth)
	(icalendar-recur-refine-bymonthday)
	(icalendar-recur-refine-byday)
	(icalendar-recur-refine-byhour)
	(icalendar-recur-refine-byminute)
	(icalendar-recur-refine-bysecond): Tighten up loop bounds when refining
	subintervals.

	Improve performance of `icalendar-recur-tz-observance-on'.  This also
	brings about a ~20% performance gain.

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-tz-observance-on): Eliminate calculation of previous
	interval recurrences when it's unnecessary.  Add a cheap upper bound check to
	prevent fully computing recurrences for irrelevant observances.
	(icalendar-recur--w/in-locally-p):
	(icalendar-recur--w/in-abs-p): New helper functions for the upper bound check.

	Other more minor changes:

	Improve performance in `icalendar-recur-refine-byday'

	* lisp/calendar/icalendar-recur.el (icalendar-recur-refine-byday): Avoid
	calculating Gregorian from absolute date unless it's necessary.

	Improve performance of BYSETPOS filtering in icalendar-recur.el:
	η-reduce `icalendar-recur-make-bysetpos-filter'.
	Thanks to Mattias Engdegård for the suggestion and implementation.

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-make-bysetpos-filter): Rename to
	`icalendar-recur-bysetpos-filter' and avoid `seq-map-indexed'.
	(icalendar-recur-recurrences-in-interval): Use new function.
	* test/lisp/calendar/icalendar-recur-tests.el
	(icalendar-test-recur-bysetpos-filter): Use new function.

	Improve sorting performance:
	Thanks to Mattias Engdegård for the suggestion and implementation.

	* lisp/calendar/icalendar-recur.el (icalendar-recur-refine-byyearday):
	(icalendar-recur-refine-byweekno):
	(icalendar-recur-refine-bymonthday):
	(icalendar-recur-refine-byday): Use :key instead of :lessp in `sort'
	calls.

	Eliminate `apply-partially' and `seq-take':
	Thanks to Mattias Engdegård for the suggestion and implementation.

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-recurrences-in-window): Eliminate `apply-partially'.
	(icalendar-recur-recurrences-in-interval): Eliminate
	`apply-partially' and replace `seq-take' with `take'.

	Reduce consing:

	* lisp/calendar/icalendar-recur.el
	(icalendar-recur-subintervals-to-dates):
	(icalendar-recur-recurrences-in-window):
	(icalendar-recur-recurrences-in-window-w/end-times):
	(icalendar-recur-recurrences-to-count): Replace `append' with `nconc'.

	Avoid a few uses of `seq-filter' in common functions in icalendar-ast.el:

	* lisp/calendar/icalendar-ast.el (icalendar-ast-node-children-of):
	Reimplement filter imperatively.

2026-04-11  Eli Zaretskii  <eliz@gnu.org>

	Fix setting and restoring cursor shape on Windows Terminal

	* src/w32console.c (w32con_set_cursor_size): New function.
	(w32con_reset_terminal_modes, w32con_set_terminal_modes)
	(Fset_cursor_size): Use it to change cursor shape on Windows
	Terminal.

2026-04-11  Eli Zaretskii  <eliz@gnu.org>

	Fix display of ambiguous-width characters on MS-Windows terminal

	* src/w32console.c (syms_of_ntterm) <w32--terminal-is-conhost>:
	New variable.
	(initialize_w32_display): Set 'w32--terminal-is-conhost' non-nil
	when running on ConHost.

	* lisp/international/characters.el (use-cjk-char-width-table):
	When Emacs runs on MS-Windows Terminal, behave as if
	'cjk-ambiguous-chars-are-wide' were nil even in CJK locales.
	(Bug#79298)

2026-04-11  Stephen Berman  <stephen.berman@gmx.net>

	Improve tests involving 'ls' error message

	* test/lisp/dired-tests.el (dired-test-ls-error-message):
	* test/lisp/files-tests.el
	(files-tests-file-name-non-special-insert-directory): Make test
	comparing the expected 'ls' error message with the string in the
	'ls' error buffer more robust (bug#80499).

2026-04-11  Stephen Berman  <stephen.berman@gmx.net>

	Ensure Dired does not list deleted 'ls' error file

	* lisp/dired.el (dired--ls-error-file): New variable.
	(dired-readin-insert): Use it to find and remove entry in Dired
	buffer of already deleted temporary 'ls' error file (bug#80499).

	* lisp/files.el (insert-directory): Set it to temporary 'ls' error file.

2026-04-11  Eli Zaretskii  <eliz@gnu.org>

	Fix face extension in 'visual-line-mode'

	* src/xdisp.c (display_line): Under WORD_WRAP, save and restore
	the iterator _before_ the wrap point.  This fixes face extension
	under 'visual-line-mode', because otherwise 'extend_face_to_end_of_line'
	is called with the value of 'it' that corresponds to the first display
	element on the next screen line.  (Bug#80673)

2026-04-11  Stephen Berman  <stephen.berman@gmx.net>

	Handle 'dired' called with -Al switches (bug#80711)

	* lisp/dired.el (dired-internal-noselect): After reading in
	directory, check whether there was an 'ls' error instead of
	checking for file entries, since there may be none is the -Al
	switches (or just -l) were used.
	(dired--display-ls-error): Ensure the 'ls' error buffer is a live buffer.

	* lisp/files.el (insert-directory-clean): Ensure deletion of
	"//DIRED-OPTIONS//" line when using -Al switches (or just -l).

2026-04-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	uni-script.el: Fix failure when loading the file directly

	* lisp/international/textsec.el (textsec--create-script-table): Autoload
	and don't define while compiling.
	(uni-script): Require only when loading, not when compiling.

2026-04-10  Pip Cet  <pipcet@protonmail.com>

	Don't continue FOR_EACH_FRAME loops after delete_frame (bug#80789)

	* src/xterm.c (x_connection_closed, x_delete_terminal): Restart
	FOR_EACH_FRAME loops after deleting one (or potentially more) frames.

2026-04-10  Pip Cet  <pipcet@protonmail.com>

	Ensure selected_frame isn't the deleted frame (bug#80789)

	The previous code would sometimes exit the loop with frame1 set to the
	last considered frame, even if that wasn't a suitable frame to switch
	to.

	* src/frame.c (delete_frame): Reset 'frame1' in the loops if we don't
	match the break condition, so we don't think we've found a suitable
	replacement frame if we haven't. Error if, for some reason, that
	fails.

2026-04-10  Pip Cet  <pipcet@protonmail.com>

	Don't accept dead selected_frame in x_connection_closed (bug#80789)

	* src/xterm.c (x_connection_closed): Try to restore frame if the
	selected frame is dead. If that fails, abort.

2026-04-10  Mike Kupfer  <kupfer@rawbw.com>

	Improve previous change.

	* lisp/mh-e/mh-thread.el: Require 'mh-folder.
	(mh-thread-refile): Update the docstring.

2026-04-10  Henrique Martins  <mh-e-users-2009@martins.cc>  (tiny change)

	MH-E: remember destination when refiling a thread (SF#473)

	* lisp/mh-e/mh-thread.el (mh-thread-refile): Add an optional argument
	'dont-update-last-destination-flag'.  If it is nil, update
	'mh-last-destination' and 'mh-last-destination-folder'.

2026-04-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	src/eval.c (Fdefault_toplevel_value): Improve docstring (bug#80775)

2026-04-10  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/gitlab-ci.yml (default): User docker 28.5.2.

	* test/infra/gitlab-ci.yml (default): User docker 28.5.2.

2026-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	(elisp--font-lock-flush-elisp-buffers): Avoid eager font-locking

	When jit-lock is not in use, `font-lock-flush` is too costly to
	justify using it just to maybe update the highlighting of a few macro calls.

	* lisp/progmodes/elisp-mode.el (elisp--font-lock-flush-elisp-buffers):
	Skip buffers that use jit-lock, like the `*ielm*-comint-indirect` buffer.

2026-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	(elisp--local-variables): Restore point earlier

	* lisp/progmodes/elisp-mode.el (elisp--local-variables): Restore
	point before calling `elisp--safe-macroexpand-all` in case this
	triggers a temporary redisplay.

2026-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/vc/vc.el (vc-checkin): Use `vc-dir-buffers` like we do everywhere else

2026-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	(listify-key-sequence): Fix breakage with unibyte chars

	* lisp/subr.el (listify-key-sequence): The funny
	"7th bit is Meta" applies only to unibyte strings.

	* test/lisp/subr-tests.el (subr-listify-key-sequence): New test.

2026-04-09  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/vc/vc.el (vc-checkin): Don't assume vc-dir is loaded.

2026-04-09  Sean Whitton  <spwhitton@spwhitton.name>

	with-vc-properties: Don't substitute in a global value

	* lisp/vc/vc.el (with-vc-properties): Don't substitute in the
	value vc-touched-properties happens to have at macro expansion
	time.  This was left over from when vc-touched-properties was
	bound to a local gensym.

2026-04-09  समीर सिंह Sameer Singh  <lumarzeli30@gmail.com>

	Fix emoji--insert-buffer being wiped by emoji-list-mode

	* lisp/international/emoji.el (emoji-list): Set insert-buffer after the
	emoji buffer is set up.  (bug#80773)

2026-04-09  Dmitry Gutov  <dmitry@gutov.dev>

	Fix "Narrowing src/ file breaks xref"

	* lisp/emacs-lisp/find-func.el (find-function-C-source):
	Look outside of the current narrowing as well (bug#80749).

2026-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/emacs-lisp/cl-macs.el (cl-typep): Undo accidental change

	src/data.c (set_internal): Mention var which can't be unbound in error msg

2026-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	(take-while, drop-while, all, member-if)

	* lisp/subr.el (take-while, drop-while, all, member-if): Don't inline
	if `pred` is not a "constant" since it wouldn't bring any
	significant benefit.  Also, don't explicitly `macroexpand-all` since
	the compiler macro will be called (again) after macro-expansion,
	if needed.
	(internal--effect-free-fun-arg-p): Return nil for variable references.

2026-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	(dired-at-point-prompter): Fix bug#80545

	* lisp/ffap.el (ffap-read-file-or-url): Add `read-dir` argument to
	indicate we expect a directory as return value.
	Avoid `read-file-name` when we want a directory and the dialog UI
	might prevent us from doing so.
	(dired-at-point-prompter): Use the new arg.

2026-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	(natnum, keyword, command): Fix bootstrap warnings (bug#80732)

	To break the interdependence between `cl-macs` and `cl-preloaded`,
	we refrain from defining some types in `cl-macs` in some corner case
	situations which affect only the early bootstrap.
	`transient.el` is used during early bootstrap (while loading
	`emoji.el` to produce `emoji-labels.el`) and it uses the
	`keyword` and `command` types, so make sure they're not among
	those types that are sometimes not defined.

	Include `natnum` while we're at it, so the only types still
	affected by this corner case are "Common Lisp" types, which are
	less likely to be used during early bootstrap.

	* lisp/emacs-lisp/cl-macs.el (natnum, keyword, command): Move type
	declaration from here to...

	* lisp/emacs-lisp/cl-preloaded.el (natnum, keyword, command): ...here.

2026-04-08  Pip Cet  <pipcet@protonmail.com>

	Avoid infinite recursion in bind-keys-form (bug#80759)

	* lisp/bind-key.el (bind-keys-form): Always continue loop after
	matching a keyword argument.

2026-04-08  Michael Albinus  <michael.albinus@gmx.de>

	* doc/misc/tramp.texi (New operations): Extend example.

2026-04-08  ewantown  <ewan@etown.dev>

	Support 24-bit TrueColor on MS-Windows console

	* src/w32console.c (DEFAULTP, SSPRINTF, w32con_write_vt_seq)
	(w32con_get_cursor_coords): New functions and macros.
	(w32con_write_glyphs): Hide cursor before writing to the console.
	Add code for writing in virtual-terminal mode when
	'w32_use_virtual_terminal' is non-zero.
	(w32con_write_glyphs_with_face): Add code for writing in
	virtual-terminal mode when 'w32_use_virtual_terminal' is non-zero.
	(w32con_setup_virtual_terminal): New function.
	(w32con_set_terminal_modes): Call it.
	(turn_on_face, turn_off_face): New functions.
	(initialize_w32_display): Save background and foreground, and the
	current TTY.
	(Fset_screen_color): Accept an additional optional argument VTP;
	if non-nil, arrange for 24-bit display to use the specified
	colors.
	(Fget_screen_color): Accept an additional optional argument VTP;
	if non-nil, return colors used by 24-bit display.
	(Fw32_use_virtual_terminal, Fw32_use_virtual_terminal_p): New
	functions.
	* src/term.c (tty_setup_colors) [WINDOWSNT]: Set up
	virtual-terminal sequences for colors.
	(init_tty) [WINDOWSNT]: Set up terminfo capabilities for Windows
	virtual-terminal.
	* src/xdisp.c (redisplay_internal): Don't call set_tty_color_mode
	for WINDOWSNT.

	* lisp/term/w32console.el (w32-tty-set-base-colors)
	(w32-tty-define-base-colors, w32-tty-define-8bit-colors)
	(w32-tty-define-24bit-colors, w32-tty-get-pixel): New functions.
	(terminal-init-w32console): Remove color setup.
	(w32-tty-setup-colors): New function.
	* lisp/term/tty-colors.el (tty-color-mode-alist): Add --color
	modes for 256 and 24-bit color modes.
	* lisp/startup.el (tty-handle-args): Fix --color handling.
	* lisp/faces.el (tty-set-up-initial-frame-faces): Set up colors
	for MS-Windows consoles.

	* etc/NEWS:
	* doc/emacs/msdos.texi (Windows Misc):
	* doc/emacs/cmdargs.texi (Colors X): Document 24-bit color support
	on MS-Windows.
	(Bug#79298)

2026-04-08  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'url-retrieve' and GnuTLS peer status

	* doc/misc/url.texi (Retrieving URLs): Describe the ':peer' entry
	of the STATUS argument passed to CALLBACK of 'url-retrieve'.

	* lisp/url/url.el (url-retrieve):
	* src/gnutls.c (Fgnutls_peer_status): Doc fixes.
	(Bug#80762)

2026-04-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	Don't load `package` just for `lm-package-needs-footer-line`

	* lisp/emacs-lisp/lisp-mnt.el (lm-package-requires):
	Don't require `package`.

2026-04-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/progmodes/project.el (generator): Don't require at run-time

2026-04-07  Michael Albinus  <michael.albinus@gmx.de>

	Tweak remote-file-name-inhibit-cache in Tramp

	* lisp/net/tramp-cache.el
	(tramp-suppress-remote-file-name-inhibit-cache): New defsubst.

	* lisp/net/tramp.el (tramp-skeleton-file-name-all-completions):
	* lisp/net/tramp-sh.el (tramp-get-remote-path): Use it.

2026-04-06  Sean Whitton  <spwhitton@spwhitton.name>

	vc-hg-working-revision: Return changeset hashes

	* lisp/vc/vc-hg.el (vc-hg-working-revision): Return changeset
	hashes instead of revision numbers.  Respect
	vc-use-short-revision.
	* etc/NEWS: Document the change.

2026-04-06  Diep Pham  <diep@calif.io>  (tiny change)

	Eglot: improve safety spec of eglot-workspace-configuration

	* lisp/progmodes/eglot.el (eglot-workspace-configuration): Improve
	safety spec.

2026-04-06  Michael Albinus  <michael.albinus@gmx.de>

	* test/lisp/net/tramp-tests.el (tramp-test21-file-links): Extend test.

2026-04-06  Michael Albinus  <michael.albinus@gmx.de>

	Keep cache in tramp-skeleton-file-name-all-completions

	* lisp/net/tramp.el (tramp-skeleton-file-name-all-completions):
	Don't expire cache for large directories.

2026-04-06  Joseph Mingrone  <jrm@ftfl.ca>

	lisp/net/tramp.el: Fix performance regression with completions

	* lisp/net/tramp.el (tramp-skeleton-file-name-all-completions):
	Use `file-directory-p' directly instead of calling `file-symlink-p'
	and file-truename first.  Since `file-directory-p' already follows
	symlinks, symlinked directories are handled correctly without the
	extra indirection.

2026-04-05  Philip Kaludercic  <philipk@posteo.net>

	Disable 'package-review-policy' during package-tests

	* test/lisp/emacs-lisp/package-tests.el (with-package-test):
	Disable package reviewing during testing to not require manual
	user input during tests.

2026-04-05  Philip Kaludercic  <philipk@posteo.net>

	Mention package version in 'package-autoremove' prompt

	* lisp/emacs-lisp/package.el (package--removable-packages):
	Return package descriptors instead of names.
	(package-autoremove): Adapt code to handle package descriptors
	instead of names.

2026-04-05  Sean Whitton  <spwhitton@spwhitton.name>

	Fix vc-default-checkin-patch for vc-async-checkin non-nil

	* lisp/vc/vc.el (vc-default-checkin-patch): Fix for
	vc-async-checkin non-nil (bug#80746).

2026-04-05  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/vc/vc-dir.el (vc-dir-update): Remove empty directory entries.

2026-04-05  Sean Whitton  <spwhitton@spwhitton.name>

	New option vc-dir-auto-hide-up-to-date

	* lisp/vc/vc-dir.el (vc-dir-hide-up-to-date-on-revert): Delete.
	(vc-dir-auto-hide-up-to-date): New option.
	(vc-dir-update, vc-dir-revert-buffer-function): Use it.
	* etc/NEWS: Document it.

2026-04-05  Sean Whitton  <spwhitton@spwhitton.name>

	VC-Dir next action: Offer to hide up-to-date items

	* lisp/vc/vc-dir.el (vc-dir--up-to-date-states): New constant.
	(vc-dir-hide-state): Use it.
	(vc-dir--only-files-state-and-model): New function.
	(vc-dir-root-next-action, vc-dir-deduce-fileset): Use it.
	* lisp/vc/vc.el (vc-only-files-state-and-model): Improve error
	message readability.

2026-04-05  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/vc/diff-mode.el (diff-mode-read-only-map): Bind 'v'.

2026-04-05  Eli Zaretskii  <eliz@gnu.org>

	Fix display in window margins when text-area text is reordered

	* src/xdisp.c (handle_stop_backwards): Don't overwrite
	'stop_charpos' if we end up on a different stack level of the
	iterator.  (Bug#80693)

2026-04-05  Yuan Fu  <casouri@gmail.com>

	Fix treesit-query-capture's NODE-ONLY param

	Before the fix, if user uses the NODE-ONLY option, we don't keep
	the capture names in the results, then predicates won't work
	because they can't reference capture names.

	* src/treesit.c (query_capture_remove_capture_name): New
	function.
	(Ftreesit_query_capture): Use the new function to remove capture
	names AFTER running the predicate.
	* test/src/treesit-tests.el:
	(treesit-query-node-only-and-grouped): New test.

2026-04-05  Kyle Meyer  <kyle@kyleam.com>

	* etc/NEWS: Announce Org update.

	Update to Org 9.8.1

2026-04-04  Philip Kaludercic  <philipk@posteo.net>

	List recursive dependencies in the package description

	* lisp/emacs-lisp/package.el (describe-package-1): List and
	indicate if a package will require a recursive dependency.

2026-04-04  Philip Kaludercic  <philipk@posteo.net>

	Recursively check dependencies for package compatibility

	* lisp/emacs-lisp/package.el (package--compatible-packages): Add
	new function.
	(package-install): Use new function to restrict suggestions to
	not include incompatible packages.
	(package--incompatible-p): Check all dependencies to determine
	package compatibility.
	* etc/NEWS: Mention change.  (Bug#80695)

2026-04-04  Philip Kaludercic  <philipk@posteo.net>

	Adjust return format of 'package--dependencies'

	* lisp/emacs-lisp/package.el (package--dependencies): Return
	required dependency version along with every dependency.
	(package-menu--list-to-prompt): Discard required versions.

2026-04-04  Eli Zaretskii  <eliz@gnu.org>

	Fix use of special glyphs with faces from display-table

	* src/xdisp.c (produce_special_glyphs): Fix the case where the
	display-table specifies a face for truncation/continuation glyphs.
	(Bug#80693)

2026-04-04  Jens Lechtenbörger  <jens.lechtenboerger@fsfe.org>

	Avoid line breaks in IMAP AUTHENTICATE PLAIN

	* lisp/net/imap.el (imap-plain-auth): Avoid line breaks in
	AUTHENTICATE PLAIN command (bug#80687).

2026-04-04  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-expand-args): Handle ARGS being nil.

2026-04-03  Stéphane Marks  <shipmints@gmail.com>

	Inform macOS Accessibility Zoom of cursor position (bug#80624)

	Enable cursor focus tracking for visually-impaired users that
	rely on macOS Zoom screen magnification.

	* src/nsterm.m: Import ApplicationServices.h.
	(ns_ua_zoom_enabled_p, ns_cg_rect_flip_y, ns_UAZoomChangeFocus):
	New static function.  Advise UAZoomChangeFocus of potentially
	new cursor position.
	(ns_update_end): Call ns_UAZoomChangeFocus.
	(ns_draw_window_cursor): Cache the cursor position.
	(applicationDidFinishLaunching): NSLog Accessibility API
	permissions AXIsProcessTrusted.
	(windowDidBecomeKey): Schedule a call to ns_UAZoomChangeFocus.
	(deferred_UAZoomChangeFocus_handler): New view method to call
	ns_UAZoomChangeFocus.
	(accessibilityFrame): New view method to help UAZoomChangeFocus.
	(initFrameFromEmacs): Initialize ns_UAZoom_cursor_rect_new and
	ns_UAZoom_cursor_rect_old.
	* etc/NEWS: Announce the change.

2026-04-03  Stéphane Marks  <shipmints@gmail.com>

	Support setopt-local in treesit--font-lock-level-setter (bug#80731)

	* lisp/treesit.el (treesit--font-lock-level-setter): Add
	buffer-local behavior as invoked by 'setopt-local'.

2026-04-03  Yuan Fu  <casouri@gmail.com>

	Filter out some range settings in markdown-ts-mode

	* lisp/textmodes/markdown-ts-mode.el:
	(markdown-ts--add-config-for-mode): Filter out functional queries.

2026-04-03  Dmitry Gutov  <dmitry@gutov.dev>

	grep-edit--prepare-buffer: Fix allowed insertion positions

	* lisp/progmodes/grep.el (grep-edit--prepare-buffer): Fix allowed
	insertion positions, like previously in xref-edit--prepare-buffer.

2026-04-03  Dmitry Gutov  <dmitry@gutov.dev>

	pgtk_set_window_size: Clear out unused code

	* src/pgtkterm.c (pgtk_set_window_size): Remove unused code.
	Rename the last two parameters to pixelwidth and pixelheight so
	they can be used directly (bug#80698).  And remove the
	xg_wm_set_size_hint call because it's called indirectly through
	xg_frame_set_char_size already.
	Update the commentary above.

2026-04-03  Dmitry Gutov  <dmitry@gutov.dev>

	xref-edit--prepare-buffer: Prohibit insertion before group headers too

	* lisp/progmodes/xref.el (xref-edit--prepare-buffer): Do the
	previous change for group headers as well (no insertion in front).

2026-04-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/help.el (help-function-arglist): Fix last change

	lisp/help.el (help-function-arglist): Handle advised aliases (bug#80725)

2026-04-02  Stéphane Marks  <shipmints@gmail.com>

	New macro setopt-local and function set-local (bug#80709)

	'setopt-local' is the buffer local equivalent of 'setopt'.

	Unify 'setopt', 'setopt-local', 'setq-local',
	'buffer-local-set-state' with 'setq' to signal
	'wrong-number-of-arguments'.

	* lisp/cus-edit.el (setopt): Change error signal to
	'wrong-number-of-arguments'.
	(setopt-local): New macro.
	(setopt--set-local): New function.
	* lisp/subr.el (set-local): New function.
	(setq-local, buffer-local-set-state): Signal
	'wrong-number-of-arguments' rather than 'error'.
	* doc/emacs/custom.texi (Examining): Document 'setopt-local'.
	* etc/NEWS: Announce the new macro and function.

2026-04-02  Roi Martin  <jroi.martin@gmail.com>

	Assume wide chars may span any number of columns during semlf filling

	* lisp/textmodes/fill.el (fill-region-as-paragraph-semlf): Use
	`most-positive-fixnum' as the fill-column value during the unfill phase.

2026-04-02  João Távora  <joaotavora@gmail.com>

	Eglot: release version 1.23

	* lisp/progmodes/eglot.el (Version): Bump to 1.23.

	* etc/EGLOT-NEWS: Announce new version.

2026-04-02  João Távora  <joaotavora@gmail.com>

	Jsonrpc: release version 1.0.28

	(Version): Bump to 1.0.28.

2026-04-02  João Távora  <joaotavora@gmail.com>

	Eglot: unbreak eglot-report-progress when set to 'messages' (bug#80653)

	* lisp/progmodes/eglot.el (eglot-mode-line-progress): Fix cl-loop thinko.

2026-04-01  João Távora  <joaotavora@gmail.com>

	Eglot: release version 1.22

	* lisp/progmodes/eglot.el (Version): Bump to 1.22.
	(Package-Requires): Bump eldoc to 1.16.0, flymake to 1.4.5,
	jsonrpc to 1.0.27, xref to 1.7.0.

	* etc/EGLOT-NEWS: Announce new version.

2026-04-01  João Távora  <joaotavora@gmail.com>

	Eglot: revert part of last change

	* lisp/progmodes/eglot.el (eglot--sig-info): Go back to adding
	1, so it's clear that parlabel's are off-by-one.

2026-04-01  Michael Albinus  <michael.albinus@gmx.de>

	Fix last change

2026-04-01  Michael Albinus  <michael.albinus@gmx.de>

	Make epa-file-insert-file-contents more secure

	* lisp/epa-file.el (epa-file-insert-file-contents):
	Use `make-temp-file' instead of `make-temp-name'.

2026-04-01  Sean Whitton  <spwhitton@spwhitton.name>

	newcomers-presets: Set two more variables

	* etc/themes/newcomers-presets-theme.el (newcomers-presets): Set
	column-number-mode and compilation-scroll-output.  Suggested by
	Abdulnafé Toulaïmat <abdulnafe.toulaimat@gmail.com>.

2026-04-01  Tassilo Horn  <tsdh@gnu.org>

	Fix text visibility issue with show-paren--show-context-in-overlay

	* lisp/paren.el (show-paren--show-context-in-overlay): Fix issue where
	the overlay's text was hardly visible in certain cases (bug#59527).

2026-04-01  Dmitry Gutov  <dmitry@gutov.dev>

	xref-edit--prepare-buffer: Fix text insertion behavior around prefix

	* lisp/progmodes/xref.el (xref-edit--prepare-buffer): Fix text
	insertion behavior before and after the line-number prefix.

2026-04-01  Dmitry Gutov  <dmitry@gutov.dev>

	xref-edit-mode: Compute 'occur-target' markers lazily

	* lisp/progmodes/xref.el (xref-edit--before-change-function):
	New function (bug#80616).
	(xref-change-to-xref-edit-mode, xref-edit-save-changes):
	Use it in before-change-functions hook.
	(xref-edit--prepare-buffer): Don't add 'occur-target' here.

2026-04-01  Dmitry Gutov  <dmitry@gutov.dev>

	Change "XREF" to "Xref" in mode lighter

	* lisp/progmodes/xref.el (xref--xref-buffer-mode)
	(xref--transient-buffer-mode, xref-edit-save-changes):
	Change "XREF" to "Xref" for internal consistency.

	* doc/emacs/maintaining.texi (Xref Commands):
	Same.

2026-04-01  Dmitry Gutov  <dmitry@gutov.dev>

	Add xref-edit-mode (bug#80616)

	Based on the existing grep-edit-mode code.

	* lisp/progmodes/xref.el (xref-edit--prepare-buffer): New function.
	(xref-edit-mode-map, xref-edit-mode-hook): New variables.
	(xref-edit-mode, xref-change-to-xref-edit-mode)
	(xref-edit-save-changes): New functions.
	(xref--xref-buffer-mode-map): New binding ("e").

	* doc/emacs/maintaining.texi (Identifier Search):
	Mention xref-change-to-xref-edit-mode.

	* etc/NEWS: Describe the addition.

2026-03-31  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/epa-file.el (epa-file-insert-file-contents): Fix last change.

2026-03-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	python-tests.el: Fix test failures introduced by commit c1c08f3c9f6

	* test/lisp/progmodes/python-tests.el (python-ts-mode-dotted-decorator-face-2)
	(python-ts-mode-builtin-call-face)
	(python-ts-mode-level-fontification-wo-interpolation)
	(python-ts-mode-disabled-string-interpolation): Call `font-lock-ensure`
	after setting a var that may flush the font-locking.

2026-03-31  Michael Albinus  <michael.albinus@gmx.de>

	Improve file name handler usage in epa-file.el

	* lisp/epa-file.el (epa-file-insert-file-contents): Handle other
	file name handlers.  (Bug#80641)

2026-03-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	(treesit--font-lock-level-setter): Work a bit more lazily

	* lisp/treesit.el (treesit--font-lock-level-setter):
	Use `font-lock-flush` (as discused in bug#80626).
	(treesit-font-lock-fontify-region): Simplify a bit.

2026-03-30  Michael Albinus  <michael.albinus@gmx.de>

	Allow format specifiers in `tramp-login-program'

	* doc/misc/tramp.texi (Extension packages): Explain how to use own
	format specifiers.

	* lisp/net/tramp.el (tramp-expand-args): Make DEFAULT argument
	optional.  Handle also ARGS being an atom.
	(tramp-handle-make-process):
	* lisp/net/tramp-container.el (tramp-skeleton-completion-function):
	* lisp/net/tramp-sh.el (tramp-ssh-or-plink-options)
	(tramp-maybe-open-connection):
	* lisp/net/tramp-sshfs.el (tramp-sshfs-handle-process-file):
	Call `tramp-expand-args' for `tramp-login-program'.

2026-03-28  Ulrich Müller  <ulm@gentoo.org>

	Fix typos in char-acronym-table

	* lisp/international/characters.el (c0-acronyms): Fix #x1c "FS".
	(c1-acronyms): Fix #x8d "RI", #x8f "SS3", and #x9a "SCI".
	Leave #x99 alone because standards use both "SGCI" and "SGC".

2026-03-28  Richard Lawrence  <rwl@recursewithless.net>

	Update gnus-icalendar to use new iCalendar library

	This change updates gnus-icalendar.el to use the new iCalendar
	library instead of obsolete functions from icalendar.el.
	* lisp/gnus/gnus-icalendar.el
	(gnus-icalendar-event)
	(gnus-icalendar-event:recurring-p)
	(gnus-icalendar-event:recurring-interval)
	(gnus-icalendar-event:recurring-days)
	(gnus-icalendar-event--find-attendee)
	(gnus-icalendar-event-from-ical)
	(gnus-icalendar-event-from-buffer)
	(gnus-icalendar-event--build-reply)
	(gnus-icalendar-event-reply-from-buffer)
	(gnus-icalendar-event:org-repeat): Reimplement using new iCalendar functions.
	(gnus-icalendar-event--attendees-by-type): Rename from
	`gnus-icalendar-event--get-attendee-names'.
	(gnus-icalendar-event--build-reply): Rename from
	`gnus-icalendar-event--build-reply-event-body'.
	(gnus-icalendar--format-participant-list): Expect list of
	`icalendar-attendee's.  Add docstring.
	(Bug#80426)

	* test/lisp/gnus/gnus-icalendar-tests.el: Update tests.

2026-03-28  Eli Zaretskii  <eliz@gnu.org>

	Better support for anonymous faces in Enriched Text mode

	* lisp/textmodes/enriched.el (enriched-face-ans): Support
	:underline, :weight, and :slant in anonymous faces.  Suggested by
	Madhu <enometh@meer.net>.

2026-03-28  Adam Sjøgren  <asjo@koldfront.dk>  (tiny change)

	Gnus: Accept date and time when specifying delay of a new article

	* lisp/gnus/gnus-delay.el (gnus-delay-article): Accept YYYY-MM-DD
	hh:mm(:ss) as a valid format.  (Bug#80637)

2026-03-28  Michael Albinus  <michael.albinus@gmx.de>

	Fix tramp-smb-handle-copy-file

	* lisp/net/tramp-smb.el (tramp-smb-handle-copy-file):
	Suppress `jka-compr-handler'.  Reported by Seppo Ronkainen
	<sodr80@protonmail.com>.  (Bug#80667)

2026-03-28  Michael Albinus  <michael.albinus@gmx.de>

	Fix file-name-all-completions for symlinked directories in Tramp

	* lisp/net/tramp.el (tramp-skeleton-file-name-all-completions):
	* lisp/net/tramp-adb.el (tramp-adb-handle-file-name-all-completions):
	* lisp/net/tramp-crypt.el (tramp-crypt-handle-file-name-all-completions):
	* lisp/net/tramp-fuse.el (tramp-fuse-handle-file-name-all-completions):
	* lisp/net/tramp-gvfs.el (tramp-gvfs-handle-file-name-all-completions):
	* lisp/net/tramp-sh.el (tramp-sh-handle-file-name-all-completions):
	* lisp/net/tramp-smb.el (tramp-smb-handle-file-name-all-completions):
	* lisp/net/tramp-sudoedit.el
	(tramp-sudoedit-handle-file-name-all-completions): Simplify.
	* test/lisp/net/tramp-tests.el (tramp-test32-shell-command): Adapt
	test.

	* lisp/net/tramp-ftp.el (tramp-disable-ange-ftp): Use `seq-difference'.

	* lisp/net/tramp-gvfs.el (tramp-gvfs-monitor-process-filter):
	Use `thread-last'.

	* lisp/net/tramp-sh.el (tramp-sh-handle-insert-directory):
	Use `seq-difference'.
	(tramp-sh-gio-monitor-process-filter): Use `thread-last'.

	* lisp/net/tramp-smb.el (tramp-smb-get-file-entries): Do not add
	virtual entry ""; it isn't needed anymore.

	* lisp/net/tramp.el (tramp-make-tramp-hop-name): Use `thread-last'.
	(tramp-completion-handle-file-directory-p): Use `tramp-prefix-format'.
	(tramp-fnac-add-trailing-slash): New defvar.
	(tramp-skeleton-file-name-all-completions): Handle also symlinked
	directories.
	(tramp-skeleton-directory-files): Use `tramp-fnac-add-trailing-slash'.
	(tramp-handle-file-name-completion): Use `seq-difference'.
	(tramp-handle-make-process): Handle "%w" format specifier.

	* test/lisp/net/tramp-tests.el (tramp-test26-file-name-completion)
	(tramp-test32-shell-command, tramp-test36-vc-registered): Adapt tests.

2026-03-27  Emil Ingelman Sahlén  <shadewind@gmail.com>  (tiny change)

	Fix recombination of side windows (Bug#80665)

	* lisp/window.el (window--make-major-side-window): Protect the
	sibling (the main-window group) from recombination.  Without
	this, deleting a side window can flatten the group into the
	root, causing subsequent side windows on other sides to be
	placed incorrectly (Bug#80665).

2026-03-27  Stephen Berman  <stephen.berman@gmx.net>

	Implement new Dired handling of errors from 'ls'

	The error messages are now displayed in a popped up buffer instead
	of being output in the Dired buffer and signalling an error.  The
	file name bounds in Dired entries are now determined solely by the
	offsets calculated by 'ls' with the --dired option and
	consequently Dired now reliably recognizes file names that contain
	a newline (bug#80499).

	* etc/NEWS: Announce new Dired handling of errors from 'ls'.

	* lisp/dired.el (dired-internal-noselect): Check Dired buffer for
	file entries and if there are none kill the buffer to prevent
	displaying a Dired buffer with no file entries.
	(dired--ls-error-buffer): New variable.
	(dired--display-ls-error): New function.
	(dired, dired-other-window, dired-other-frame, dired-other-tab):
	Use it to pop up buffer with error message emitted by 'ls'.

	* lisp/files.el (insert-directory-clean): Remove the code that
	treats lines beginning at column 0 in a Dired buffer as error
	lines and consequently also remove the code using these lines to
	adjust the offsets specifying the bounds of the file name in the
	Dired entries.  If the buffer contains a //DIRED-OPTIONS// line
	output by --dired, delete this line even when it is at BOB.
	(insert-directory): Remove the code that checks the return value
	of 'ls' and signals an error based on that value.  Write any error
	message emitted by 'ls' to a temporary file and insert its content
	into a buffer, which will be popped when invoking a Dired command
	results in the 'ls' error.  Adjust the comment above this function
	to accommodate file names containing a newline in Dired entries.
	(insert-directory-adj-pos): Remove this now unused function.

	* test/lisp/dired-tests.el (dired-test-filename-with-newline-1)
	(dired-test-filename-with-newline-2)
	(dired-test-ls-error-message): New tests.

	* test/lisp/files-tests.el
	(files-tests-file-name-non-special-insert-directory): Adjust test
	to use of 'ls' error buffer instead of signaling an error.

2026-03-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	(c++-ts-mode): Fix bug#80682

	* lisp/progmodes/c-ts-mode.el (c++-ts-mode): Set
	`editorconfig-indent-size-vars` since it can't be guessed.

2026-03-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	(kmacro-end-call-mouse): Make obsolete

	* lisp/kmacro.el (kmacro-end-and-call-macro): Add EVENT argument.
	(kmacro-end-call-mouse): Define as obsolete alias
	of `kmacro-end-and-call-macro`.

2026-03-27  Philip Kaludercic  <philipk@posteo.net>

	Elaborate the motivation for the "newcomers-presets" theme

2026-03-27  YugaEgo  <yet@ego.team>

	* lisp/textmodes/css-mode.el (css-pseudo-class-ids): Add 'has' (bug#80664).

2026-03-26  Basil L. Contovounesios  <basil@contovou.net>

	Add predicate for initial_terminal

	This introduces the predicate frame-initial-p, which uses
	struct frame.output_method or struct terminal.type to detect
	initial_terminal without relying on its name (bug#80629).
	For some prior discussion, see:
	https://lists.gnu.org/r/emacs-devel/2019-12/msg00480.html
	https://lists.gnu.org/r/emacs-devel/2020-01/msg00120.html

	* doc/lispref/frames.texi (Frames): Document frame-initial-p.
	(Finding All Frames): Fix grammar.
	* etc/NEWS (Lisp Changes in Emacs 31.1): Announce frame-initial-p.
	* lisp/desktop.el (desktop--check-dont-save):
	* lisp/emacs-lisp/debug.el (debug):
	* lisp/frameset.el (frameset-restore):
	* lisp/menu-bar.el (menu-bar-update-buffers):
	* lisp/xt-mouse.el (turn-on-xterm-mouse-tracking-on-terminal):
	Use frame-initial-p instead of checking the "initial_terminal" name.
	* lisp/emacs-lisp/byte-opt.el: Mark frame-initial-p as error-free.

	* src/pgtkterm.c (pgtk_focus_changed): Use IS_DAEMON in place of
	Fdaemonp, thus also accepting a named daemon session.
	* src/terminal.c (decode_tty_terminal): Clarify commentary.
	(Fframe_initial_p): New function.
	(syms_of_terminal): Expose it.
	(init_initial_terminal): Update commentary now that
	menu-bar-update-buffers uses frame-initial-p (bug#53740).

	* test/lisp/xt-mouse-tests.el (with-xterm-mouse-mode): Simulate the
	lack of an initial terminal by overriding frame-initial-p now
	that turn-on-xterm-mouse-tracking-on-terminal uses it.
	* test/src/terminal-tests.el: New file.

2026-03-26  Basil L. Contovounesios  <basil@contovou.net>

	Simplify some struct frame.output_method checks

	* src/lisp.h (inhibit_window_system): Fix typo in commentary.
	* src/dispnew.c (Fopen_termscript):
	(init_display_interactive) [!HAVE_ANDROID, !MSDOS]:
	* src/dosfns.c [MSDOS] (dos_cleanup):
	* src/frame.c (frame_inhibit_resize, frame_windows_min_size)
	(do_switch_frame, delete_frame):
	(make_terminal_frame) [MSDOS]:
	(Fmake_terminal_frame) [MSDOS, WINDOWSNT]:
	* src/keyboard.c (read_decoded_event_from_main_queue) [!WINDOWSNT]:
	(Fcurrent_input_mode):
	* src/menu.c (single_menu_item):
	* src/msdos.c [MSDOS] (internal_terminal_init):
	* src/sysdep.c (init_sys_modes):
	* src/term.c: [HAVE_GPM] (Fgpm_mouse_start, Fgpm_mouse_stop):
	[MSDOS] (tty_free_frame_resources):
	* src/w32xfns.c (get_frame_dc):
	* src/xdisp.c (clear_garbaged_frames, hscroll_window_tree)
	(redisplay_internal):
	* src/xfaces.c (Fdisplay_supports_face_attributes_p)
	(realize_default_face, realize_face, realize_tty_face): Use
	is_tty_frame, FRAME_INITIAL_P, FRAME_MSDOS_P, FRAME_TERMCAP_P,
	FRAME_W32_P, and FRAME_TTY as appropriate instead of open-coding
	them (bug#80629).

2026-03-26  Basil L. Contovounesios  <basil@contovou.net>

	Improve last change to auth-source-pass

	* lisp/auth-source-pass.el (auth-source-pass-search): Remove
	redundant expand-file-name.
	* test/lisp/auth-source-pass-tests.el
	(auth-source-pass--with-store): Bind auth-source-pass-filename to an
	existing directory to satisfy the new guard in
	auth-source-pass-search (bug#76323).

2026-03-26  Naofumi Yasufuku  <naofumi@yasufuku.dev>  (tiny change)

	Don't error on nonexistent ~/.password-store

	* lisp/auth-source-pass.el (auth-source-pass-search):
	If auth-source-pass-filename is not a directory, just do nothing to
	avoid repeated errors raised by directory-files-recursively in
	auth-source-pass-entries which is called for each search pattern.
	(Bug#76323)

2026-03-25  Jens Schmidt  <jschmidt4gnu@vodafonemail.de>

	Split up shortdoc functions and groups, fix their format

	Move shortdoc group definitions from shortdoc.el to a separate file
	shortdoc-doc.el.  Document shortdoc group format in a future-proof way
	and guide package authors on how to use shortdoc groups across past
	Emacs versions.

	* lisp/emacs-lisp/shortdoc-doc.el: New file.
	* lisp/emacs-lisp/shortdoc.el: Document shortdoc group format in a
	future-proof way.  Require 'shortdoc-doc'.
	(shortdoc--keyword-plist-p): New function.
	(shortdoc--check): Update to check the documented shortdoc group format.
	(shortdoc--groups, define-short-documentation-group): Pull out of
	autoloaded 'progn'.
	(define-short-documentation-group): Report errors in terms of byte
	compiler warnings.
	(alist, map, string, file-name, file, hash-table, list, symbol)
	(comparison, vector, regexp, sequence, buffer, overlay, process, number)
	(text-properties, keymaps): Move group to shortdoc-doc.el.
	(shortdoc): Move alias to after function.
	(shortdoc-add-function): Add argument checks.
	* doc/lispref/tips.texi (Documentation Group Tips): New section.
	* doc/lispref/elisp.texi (Top):
	* doc/lispref/tips.texi (Tips): Add references to it.
	* doc/lispref/help.texi (Documentation Groups): Ditto, and add some
	concept index entries.  (bug#80297)

2026-03-25  Stephen Berman  <stephen.berman@gmx.net>

	Fix Dired check for newlines in file names

	Ensure that Dired does not treat the sequence "\\n" within a file
	name as a newline (bug#80608).

	* lisp/dired.el (dired--filename-with-newline-p): Rewrite using
	'directory-files' with match for regexp "\n".

	* test/lisp/dired-tests.el
	(dired-test--filename-with-backslash-n): New function.
	(dired-test-filename-with-backslash-n): New test.

2026-03-25  Pip Cet  <pipcet@protonmail.com>

	Allow retrieving scheduler information in seccomp (bug#80656)

	* lib-src/seccomp-filter.c (main): Add rules for 'sched_getscheduler'
	and 'sched_getaffinity'.

2026-03-25  Basil L. Contovounesios  <basil@contovou.net>

	Give compile-command a :group again

	Like the commit of 2022-07-31
	"Fix further package.el loaddefs byte-compile warnings"
	this pacifies the warning that compile-command fails to specify
	a containing group when byte-compiling loaddefs.el (bug#80648).

	* lisp/progmodes/compile.el (compile-command): Restore explicit
	custom :group on autoloaded user option.

2026-03-25  Eli Zaretskii  <eliz@gnu.org>

	Fix "File->Open Directory" menu item after 'ffap-bindings'

	* lisp/dired.el (dired-from-menubar): New function.
	* lisp/menu-bar.el (menu-bar-file-menu): Use it in the "Open
	Directory" menu item, instead of calling Dired directly.  This
	ensures we show the correct GUI dialog even if some package remaps
	'dired' to something else (like 'ffap-bindings' does).
	(Bug#80545)

2026-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	minibuffer.el: De-iconify a `*Completions*` frame only for eager display

	* lisp/minibuffer.el (completions--after-change)
	(minibuffer--completions-visible): Don't consider an iconified
	frame as visible.

2026-03-24  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Check all SES local variables are always set locally.

	Rename ses tests with prefix ses-tests-...

2026-03-24  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	Fix SES tests indentation.

	* test/lisp/ses-tests.el (ses-jump-B2-lowcase)
	(ses-jump-B2-lowcase-keys): Fix indentation.

2026-03-24  Eli Zaretskii  <eliz@gnu.org>

	Avoid segfaults in 'bidi_mirror_char' during startup

	* src/bidi.c (bidi_mirror_char): Make sure 'bidi_mirror_table' is
	initialized before accessing it.  (Bug#80668)

2026-03-24  F. Jason Park  <jp@neverwas.me>

	Add tests for erc-track-faces-normal-list regression

	* test/lisp/erc/erc-track-tests.el
	(erc-track-tests--modified-channels/baseline): Update assertion to
	expect an unchanged mode line segment if `erc-track-faces-normal-list'
	lacks a ranked face in the latest inserted message.
	(erc-track-modified-channels/baseline/nonotice)
	(erc-track-modified-channels/priority-only-all/baseline/nonotice): New
	tests.  (Bug#80659)

2026-03-24  Ivan  <iv@ivanrg.es>  (tiny change)

	Fix erc-track-faces-normal-list regression

	* lisp/erc/erc-track.el (erc-track--select-mode-line-face): Check
	whether ranked faces in the message appear in the value of the option
	`erc-track-faces-normal-list' rather than repeatedly checking if the
	current nominee does, usually the highest ranked face in the message.
	Failure to do so caused ERC to treat faces absent from the option's
	value as being present and thus eligible to replace ranked faces in the
	mode line segment.  This bug was introduced in ERC 5.6 and is also part
	of 5.6.1.  (Bug#80659)

2026-03-24  F. Jason Park  <jp@neverwas.me>

	Avoid nested erc-display-message in alert utility

	* lisp/erc/erc.el (erc--warn-once-before-connect): Don't call
	`erc-display-message' from insertion hooks because doing so places an
	unnecessary burden on the caller to preserve the insertion marker and
	"msg prop" environment.

2026-03-23  Basil L. Contovounesios  <basil@contovou.net>

	Fix recent whitespace.el changes

	* etc/NEWS
	(Changes in Specialized Modes and Packages in Emacs 31.1):
	Announce new user option whitespace-global-mode-buffers (bug#79230).
	* lisp/whitespace.el (whitespace-global-modes): Improve docstring
	grammar.
	(whitespace-global-mode-buffers): Make default value match *scratch*
	exactly for backward compatibility.  Fix custom :type.
	(whitespace-enable-predicate): Prefer any over seq-find.

2026-03-22  Pip Cet  <pipcet@protonmail.com>

	Delay initializing 'compile-command' to runtime (bug#80648)

	* lisp/progmodes/compile.el (compile-command): Use
	'custom-initialize-delay'.

2026-03-22  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/subr.el (member-if): Fix compiler macro multiple evaluation.

	Problem reported by Pip Cet <pipcet@protonmail.com>.

2026-03-22  Daniel Mendler  <mail@daniel-mendler.de>

	(dabbrev-completion): Improve last fix for bug#80645

	* lisp/dabbrev.el (dabbrev-completion): Signal the error that
	`dabbrev-capf` doesn't signal any more.

2026-03-22  Helmut Eller  <eller.helmut@gmail.com>

	Staticpro executing_kbd_macro

	* src/macros.c (syms_of_macros): Staticpro executing_kbd_macro.
	(executing_kbd_macro): Update comment.
	* src/macros.h (executing_kbd_macro): Remove redundant comment.

2026-03-22  Basil L. Contovounesios  <basil@contovou.net>

	Fix no-focus-on-map on X without GTK

	* src/xterm.c [!USE_GTK] (x_update_frame_user_time_window): When
	replacing _NET_WM_USER_TIME with a new _NET_WM_USER_TIME_WINDOW and
	the frame has requested no-focus-on-map, ensure _NET_WM_USER_TIME is
	zero also on the new _NET_WM_USER_TIME_WINDOW.
	(x_make_frame_visible) [!USE_GTK]: Don't overwrite _NET_WM_USER_TIME
	before mapping a frame that has requested no-focus-on-map, and whose
	_NET_WM_USER_TIME should thus remain zero (bug#80525).

2026-03-22  Guilherme de Almeida Suckevicz  <guito.linux@gmail.com>  (tiny change)

	Fix wrong type argument error in 'find-file-read-only-other-tab' (Bug#80630)

	* lisp/tab-bar.el (find-file-read-only-other-tab): Pass the
	function 'find-file-other-tab' directly to
	'find-file--read-only' (Bug#80630).

2026-03-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	(dabbrev-capf): Fix bug#80645.

	* lisp/dabbrev.el (dabbrev-capf): Return an empty table rather than
	signaling an error when there are no completions.
	The completion UI already takes care of emitting a message like
	"No match".

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	* test/src/charset-tests.el (charset-tests-define-charset): New.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	Use signed ints in struct charset_table

	* src/charset.h (struct charset_table): Make the slots size and used
	signed.
	(charset_attributes_getter): Fix spacing.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	* src/charset.c (Fdefine_charset_internal): Fix memory leak.

	* src/charset.c (shrink_charset_table): Simplify.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	Introduce a struct charset_table

	The fields of the new struct are what the global variables
	charset_table, charset_table_size, charset_table_used, and
	charset_attributes_table used to be.  The struct should make it clearer
	that those fields must be kept in sync.

	* src/charset.h (struct charset_table): New struct.
	(charset_attributes_getter): Adjust accordingly.
	* src/charset.c (charset_table): Change type to struct charset_table.
	(charset_table_size, charset_table_used, charset_attributes_table):
	Moved to the struct.
	(Fdefine_charset_internal, Ffind_charset_region, Ffind_charset_string)
	(shrink_charset_table, syms_of_charset): Adjust to struct charset_table.
	* src/pdumper.c (dump_charset, dump_charset_table): Adjust to struct
	charset_table.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	* src/charset.h (charset_attributes_getter): Add assertion.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	Remove the charset_table_init array

	Determining the best size for a static array seems difficult; so
	allocate it dynamically.

	* src/charset.c (CHARSET_TABLE_INIT_SIZE): New constant.
	(syms_of_charset): Malloc charset_table here.
	(charset_table_init): Removed.
	(shrink_charset_table): New function.
	(Fclear_charset_maps): Call it.
	* src/charset.h (charset_table_init): Removed.
	(charset_attributes_getter): Add an assertion.
	* src/pdumper.c (dump_charset_table): Assert that charset_table_size ==
	charset_table_used.

2026-03-21  Helmut Eller  <eller.helmut@gmail.com>

	Move the attribute field of charsets to a separate vector

	This simplifies the GC code, as this was the only field in the charset
	struct that referenced the GC heap.  Without it, we no longer need to
	trace the charset_table.

	* src/charset.h (struct charset.attributes): Removed.
	(charset_attributes_getter): New helper.
	(CHARSET_ATTRIBUTES): Use it.
	* src/charset.c (charset_attributes_table): New.
	(Fdefine_charset_internal): Place attrs in charset_attributes_table.
	(syms_of_charset): Initialize charset_attributes_table.
	(mark_charset): Deleted.
	* src/pdumper.c (dump_charset): Skip attributes field.
	* src/lisp.h (mark_charset): Deleted.
	* src/alloc.c (garbage_collect): mark_charset no longer needed.

2026-03-21  Basil L. Contovounesios  <basil@contovou.net>

	Make member-if compiler-macro hygienic

	* lisp/subr.el (member-if): Use uninterned symbol in
	compiler-macro (bug#80647).

2026-03-21  Stéphane Marks  <shipmints@gmail.com>

	vtable truncate-string-pixelwise, ellipsis can be a string (bug#80026)

	Eliminate 'vtable--limit-string' in favor of the more efficient
	'truncate-string-pixelwise'.  Remove extraneous pre-measurement
	calls to 'string-pixel-width' and ellipsis concatenation as
	'truncate-string-pixelwise' does both.
	The 'make-vtable' 'ellipsis' keyword can be a string to override
	the default returned by 'truncate-string-ellipsis'.

	* lisp/emacs-lisp/vtable.el (vtable--ellipsis): New defun.
	(vtable-insert-object, vtable--insert): Use 'vtable--ellipsis'.
	(vtable--insert-line, vtable--insert-header-line): Call
	'truncate-string-pixelwise' instead of 'vtable--limit-string'.
	(vtable--limit-string): Remove function.

	* test/lisp/emacs-lisp/vtable-tests.el
	(test-vtable--limit-string-with-face-remapped-buffer): Remove
	test, obsoleted by misc-test-truncate-string-pixelwise.

	* doc/misc/vtable.texi: Document that :ellipsis can be a string.

2026-03-21  Jeff Valk  <jv@jeffvalk.com>  (tiny change)

	Ensure correct expansion in 'find-sibling-file-search'

	* lisp/files.el (find-sibling-file-search): Following expansion
	of each EXPANSION, advance the search start position to reflect
	the actual length of the expanded text (the updated string), not
	the length of the "\\([&0-9]+\\)" (the string before expansion).
	(Bug#80636)

2026-03-21  Tassilo Horn  <tsdh@gnu.org>

	Fix wrong-type-argument error in package-upgrade

	* lisp/emacs-lisp/package.el (package-upgrade): Fix wrong-type-argument
	error when upgrading a builtin package (bug#80633).

2026-03-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	simple-tests.el: Use `kmacro` function

	* test/lisp/simple-tests.el (undo-test-kill-c-a-then-undo)
	(undo-test-point-after-forward-kill): Use `kmacro` function.

2026-03-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	cursor-sensor.el: Partial fix for bug#80255

	This provides limited support for window-specific overlay properties.
	To complete it, we still need to add support for it to
	`next/previous-single-char-property-change`.

	* lisp/emacs-lisp/cursor-sensor.el (cursor-sensor--intangible-p):
	Add `window` argument.
	(cursor-sensor-tangible-pos, cursor-sensor--detect):
	Pass `window` argument to the functions
	looking for overlay properties.

2026-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	(Fmakunbound): Break aliasing, if present (bug#80538)

	* src/data.c (Fmakunbound): Break aliasing, if present.
	* doc/lispref/variables.texi (Void Variables): Document it.

2026-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	diff-mode.el: Don't recompute the position of Git preamble/footer

	On some profiles (after disabling syntax and refined
	fontification), this was taking >90% of the time to fontify a buffer.

	* lisp/vc/diff-mode.el (diff--git-preamble-overlay)
	(diff--git-footer-overlay): New variables.
	(diff--git-preamble-end, diff--git-footer-start): Use them to cache
	the result.

2026-03-19  Ihor Radchenko  <yantar92@posteo.net>

	New option to enable global-whitespace-mode in special-buffers (bug#79230)

	* lisp/whitespace.el (whitespace-global-mode-buffers): New custom
	option.
	(whitespace-enable-predicate): Use it.
	(whitespace-global-modes): Refer to the new option.

2026-03-19  Elias Gabriel Perez  <eg642616@gmail.com>

	hideshow: Fix 'hs-hide-block-behavior' set to 'after-cursor'.

	Bug#80455.

	* etc/NEWS: Document changed behavior.

	* lisp/progmodes/hideshow.el (hs-get-near-block): Remove
	'forward-line'.
	(hs-hide-block-behavior): Update docstring.

	* doc/emacs/programs.texi (Hideshow): Update.

	Suggested-by: Dima Kogan <dima@secretsauce.net>

2026-03-19  Eli Zaretskii  <eliz@gnu.org>

	Fix "make install-nt" in parallel builds

	* Makefile.in (install-nt): Add order-only dependency on $(NTDIR).
	Suggested by Joel Reicher <joel.reicher@gmail.com>.  (Bug#80470)

2026-03-19  Elías Gabriel Pérez  <eg642616@gmail.com>

	hideshow: New minor mode 'hs-indentation-mode'. (Bug#80179)

	This minor mode configures hs-minor-mode to use
	indentation-based folding.

	* lisp/progmodes/hideshow.el (hs-hideable-block-p): New
	function.
	(hs-indentation-respect-end-block): New option.
	(hs-indentation--store-vars): New variable.
	(hs-cycle-filter, hs-get-first-block-on-line, hs-get-near-block)
	(hs-find-block-beg-fn--default): Adapt code to use
	'hs-hideable-block-p'.
	(hs-block-positions): Update.
	(hs-indentation-mode): New minor mode.

	* doc/emacs/programs.texi (Hideshow): Update documentation.

	* etc/NEWS: Announce changes

	* test/lisp/progmodes/hideshow-tests.el: Add 'require'.
	(hideshow-check-indentation-folding): New test.

2026-03-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/progmodes/elisp-mode.el (elisp--local-macroenv): Add `static-if`

2026-03-18  Stéphane Marks  <shipmints@gmail.com>

	Kick the event loop in NS drag and drop (bug#80592)

	Eliminate an annoying event-loop delay after dropping into an
	Emacs window.

	* src/nsterm.m: ([EmacsView performDragOperation:]): Kick the
	event loop after posting the DRAG_N_DROP_EVENT.

2026-03-17  Michael R. Mauger  <michael@mauger.com>

	Window handling bug fixes.

	* lisp/play/zone.el: (zone--build-zone-buffer): select window.
	(zone--prepare-frames): Avoid dedicated windows.

2026-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	(delete-selection-repeat-replace-region): Partial fix for bug#80216

	* lisp/delsel.el (delete-selection-repeat-replace-region): Clarify the
	need for `delete-selection-save-to-register`.

2026-03-17  Tassilo Horn  <tsdh@gnu.org>

	Further improve blink-matching-paren-highlight-offscreen

	* lisp/simple.el (blink-matching-paren-offscreen): Inherit from
	show-paren-match face.
	(blink-paren-open-paren-line-string): Add blink-matching-paren-offscreen
	face properties to opening paren instead of replacing original
	fontification.
	* lisp/paren.el (show-paren-context-when-offscreen): Mention
	blink-matching-paren-highlight-offscreen in docstring.

2026-03-16  Dmitry Gutov  <dmitry@gutov.dev>

	Assign bit gravity to window in Lucid and Motif ports too

	* src/widget.c (EmacsFrameRealize): Assign bit_gravity, and use
	the value of NorthWestGravity which matches the GTK3 behavior,
	and the general intuition that window's contents should move
	with its top-left corner.  The result is that the frame is not
	blinking during resizing (bug#80369).

	* src/xfns.c (x_window) [!USE_X_TOOLKIT]: Change bit_gravity from
	StaticGravity to NorthWestGravity as well, to match the others.

2026-03-16  Pip Cet  <pipcet@protonmail.com>

	Count characters correctly in 'str_as_multibyte'

	* src/character.c (str_as_multibyte): Increment CHARS for each
	character produced, not just once.

2026-03-16  Basil L. Contovounesios  <basil@contovou.net>

	Remove more regex macros from src/conf_post.h

	Further to bug#80428, they are no longer used since commit of
	2018-08-05 "Simplify regex-emacs code by assuming Emacs".
	Suggested by Pip Cet <pipcet@protonmail.com>.

	* src/conf_post.h [emacs] (RE_TRANSLATE_TYPE): Remove;
	no longer used except under lib-src.
	[emacs] (RE_TRANSLATE): Remove; redefined in src/regex-emacs.c.

2026-03-16  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/emacs-lisp/shortdoc.el (list): Fix `ensure-proper-list' examples.

2026-03-16  Michael Albinus  <michael.albinus@gmx.de>

	Use consistent alias name in tramp-compat.el

	* lisp/net/tramp-compat.el (tramp-compat-error-type-p):
	Rename from `tramp-error-type-p'.

2026-03-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	lisp/startup.el (command-line): Simplify with `error-message-string`

	Suggested by Basil L. Contovounesios <basil@contovou.net>.

2026-03-15  Sean Whitton  <spwhitton@spwhitton.name>

	Set frame-inhibit-implied-resize in newcomers-presets

	* etc/themes/newcomers-presets-theme.el (newcomers-presets): Set
	frame-inhibit-implied-resize as suggested by Martin Rudalics.

2026-03-15  Philip Kaludercic  <philipk@posteo.net>

	Add new function 'ensure-proper-list' (bug#80598)

	* doc/lispref/lists.texi (Building Lists): Document it.
	* etc/NEWS: Mention it.
	* lisp/emacs-lisp/shortdoc.el (list): Demonstrate it.
	* lisp/subr.el (ensure-proper-list): Add it.

2026-03-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid segfaults in TTY menu-item selection

	* src/term.c (tty_menu_show): Don't allow "selection" of items in
	a bogus menu.  (Bug#80603)

2026-03-14  Eli Zaretskii  <eliz@gnu.org>

	Avoid another assertion violation in TTY menus

	* src/term.c (tty_menu_show): Reject bogus menus whose 'menu_items'
	is nil.  (Bug#80603)

2026-03-14  Philip Kaludercic  <philipk@posteo.net>

	Add references to "User Lisp" Info node where applicable

	* etc/NEWS: Update 'package-vc-install-from-checkout'
	obsoletion notice.
	* lisp/emacs-lisp/package-vc.el (package-vc-install-from-checkout):
	Update obsoletion declaration.

2026-03-14  Philip Kaludercic  <philipk@posteo.net>

	Remove references to 'package-vc-install-from-checkout' in docs

	* lisp/emacs-lisp/package-vc.el: Remove mention in Commentary section.
	(package-vc-checkout): Remove suggestion in docstring.

2026-03-14  Basil L. Contovounesios  <basil@contovou.net>

	Rename emacs-module.h.in -> emacs-module.in.h

	* src/emacs-module.h.in: Rename...
	* src/emacs-module.in.h: ...to this, for consistency with all other
	lib/*.in.h files (bug#80428).
	* Makefile.in (CONFIG_STATUS_FILES_IN):
	* admin/release-branch.txt:
	* src/emacs-module.c: All uses updated.
	* admin/authors.el (authors-renamed-files-alist): Register rename.
	* configure.ac: Specify non-default AC_CONFIG_FILES input file.

2026-03-14  Basil L. Contovounesios  <basil@contovou.net>

	Review some attribute macro usage

	* .dir-locals.el (c-noise-macro-names): Remove ANDROID_EXPORT, which
	is no longer used.  Add ATTRIBUTE_COLD, ATTRIBUTE_CONST,
	ATTRIBUTE_MAY_ALIAS, ATTRIBUTE_NONSTRING, ATTRIBUTE_RETURNS_NONNULL,
	EXTERNALLY_VISIBLE, MAYBE_UNUSED, and NODISCARD.
	(c-noise-macro-with-parens-names): Also tell cc-mode about some
	function-like attribute macros in use (bug#80428).

	* src/conf_post.h (RE_TRANSLATE_P): Remove; it is no longer used.

2026-03-14  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in tty menus in rare cases

	* src/term.c (mouse_get_xy): Restore the lost protection against
	'mouse_position' returning nil as mouse coordinates.  (Bug#80603)

2026-03-14  Eli Zaretskii  <eliz@gnu.org>

	Fix backward motion in Info manuals under 'scroll-conservatively'

	* lisp/info.el (Info-find-node-2): Don't skip the header or
	breadcrumbs line when 'scroll-conservatively' is set to a value
	that could leave the beginning of the node outside of the window.
	(Bug#80553)

2026-03-14  Timon Reinold  <tirei+gn@agon.one>  (tiny change)

	Fix auto-correct previous word with 'flyspell-prog-mode'

	* lisp/textmodes/flyspell.el (flyspell-generic-progmode-verify):
	Take into account the word 'flyspell-auto-correct-previous-word'
	moved to (i.e., the word starting at point, not the character
	before point), when checking whether it should be checked/corrected
	by flyspell-prog-mode.  (Bug#80289)

2026-03-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	(smerge--refine-prepare-regions): Reduce number of args and retvals

	* lisp/vc/smerge-mode.el (smerge--refine-set-overlay-props):
	New function, extracted from `smerge--refine-prepare-regions`.
	(smerge--refine-prepare-regions): Take overlays rather than beg/end
	arguments and remove all overlay property manipulation.
	(smerge-refine-regions): Create the overlays and pass them to those
	two functions.

2026-03-14  Dmitry Gutov  <dmitry@gutov.dev>

	etags-regen: Don't try to generate tags during completion, by default

	* etc/NEWS: Describe the change.

	* lisp/progmodes/etags-regen.el
	(etags-regen-create-on-completion): New option.
	(etags-regen-create-on-completion--set): New function.
	(etags-regen-mode): Use it.  Discussed in
	https://lists.gnu.org/archive/html/emacs-devel/2026-03/msg00405.html

2026-03-13  Philip Kaludercic  <philipk@posteo.net>

	Simplify 'xref-mouse-mode-map'

	See https://mail.gnu.org/archive/html/emacs-devel/2026-03/msg00386.html.

	* lisp/progmodes/xref.el (xref-mouse-mode-map): Prevent
	C-<down-mouse-1> from triggering 'mouse-buffer-menu' and drop
	C-<drag-mouse-1> binding.

2026-03-13  Philip Kaludercic  <philipk@posteo.net>

	* etc/NEWS: Announce 'package-vc-install-from-checkout' obsoletion

	(Bug#80604)

2026-03-13  Philip Kaludercic  <philipk@posteo.net>

	Give an example of how to use use-package+:vc without :rev

	* doc/misc/use-package.texi (Install package): Add an example
	block that doesn't use :rev, and instead shows that you can just
	pass a URL as a string to :vc.

2026-03-13  Paul Eggert  <eggert@cs.ucla.edu>

	Ignore Emacs developer’s global core.whitespace

	* build-aux/git-hooks/pre-commit: Use EMACS_GIT_CORE_WHITESPACE,
	not the global core.whitespace, for whitespace checks when committing.
	This defaults to empty, which means to use the Git default, and
	this should fix Bug#80428 “C indentation in .gitattributes, macros
	in .dir-locals.el”.  The environment variable is a better way to
	temporarily override the default.

2026-03-13  Helmut Eller  <eller.helmut@gmail.com>

	* lisp/loadup.el: No longer GC after loading each file

	With the portable dumper it's no longer needed as discussed in
	bug#79021.  Originally this was done for the unexec based dumping (see
	bug#4287 and commit 0e328d3779d1).

2026-03-13  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in 'display_menu_bar'

	* src/xdisp.c (display_menu_bar): Return immediately if the
	menu-bar items were not yet computed.  This avoids assertion
	violations when this function is called as part of creating a new
	frame.  (Bug#80603)

2026-03-13  Basil L. Contovounesios  <basil@contovou.net>

	Fix project-recompile directory

	* lisp/progmodes/project.el: Remove stale compilation-read-command
	declarations.  Autoload recompile for Emacs versions prior to 31, to
	allow calling project-recompile before project-compile (bug#74631).
	(project-recompile): Set compilation-directory to avoid recompile
	using a value unrelated to the current project (bug#68570).

2026-03-12  Basil L. Contovounesios  <basil@contovou.net>

	Replace remaining uses of Qwrong_type_argument

	For discussion, see:
	https://lists.gnu.org/r/emacs-devel/2026-03/msg00306.html

	* src/comp.c (helper_GET_SYMBOL_WITH_POSITION): Use
	symbol-with-pos-p, not wrong-type-argument, in the
	wrong-type-argument error predicate slot.
	* src/data.c (Fbare_symbol):
	* src/print.c (print_bind_overrides):
	* src/treesit.c (Ftreesit_parser_create, treesit_resolve_node):
	Prefer wrong_type_argument over xsignal2.

2026-03-12  Basil L. Contovounesios  <basil@contovou.net>

	Fix window-height of project-kill-buffers

	An alternative to setting window-height and preserve-size is to rely
	on display-buffer--maybe-at-bottom's support for
	temp-buffer-resize-mode.

	* lisp/progmodes/project.el (project-kill-buffers): Set
	window-height to a function, not a form/cons (bug#52148).

2026-03-12  Julian Scheid  <julians37@gmail.com>

	Fix 'comp--func-unique-in-cu-p' to match docstring

	* lisp/emacs-lisp/comp.el (comp--func-unique-in-cu-p): Check
	only the callee name instead of requiring global uniqueness.
	* test/src/comp-resources/comp-test-direct-call.el: New file.
	* test/src/comp-resources/comp-test-direct-call-dup.el: New file.
	* test/src/comp-tests.el (comp-tests-has-direct-call-p)
	(comp-tests-direct-call-with-lambdas)
	(comp-tests-direct-call-with-duplicate-names): New tests.

2026-03-12  Philip Kaludercic  <philipk@posteo.net>

	Add 'xref-mouse-mode' minor mode

	* doc/emacs/maintaining.texi (Looking Up Identifiers): Document
	it.
	* etc/NEWS (bindings): Mention it.
	* etc/themes/newcomers-presets-theme.el (newcomers-presets): Add
	it.
	* lisp/progmodes/xref.el (xref-mouse-mode-map, xref-mouse-mode)
	(global-xref-mouse-mode): Implement it.

2026-03-12  Tassilo Horn  <tsdh@gnu.org>

	Don't strip face properties in blink-paren-open-paren-line-string

	With bug#59527 we ensured that the open paren line string was fontified
	which was broken again with bug#63089 because there, the opening paren
	was fontified with a new face.

	With this change, the returned string is fontified again.  Only if
	`blink-matching-paren-highlight-offscreen' is non-nil, the opening paren
	is unfontified and then fontified again with the
